// fldriter.h
//
// A class which is a Windows based palette folder iterator.
//

#ifndef _H_fldriter
#define _H_fldriter

#include <stdlib.h>
#include <Windows.h>

#define MAX_SEARCH_DEPTH 5

typedef struct tagStackElem
{
	HANDLE searchHandle;
	char   searchPath[_MAX_PATH];
} SearchStackRec, *PSearchStackRec;

class PaletteFolderIterator
{
	public:
		static const char *GetPalettesFolderPath();

		PaletteFolderIterator();
		~PaletteFolderIterator();

		BOOL InitPaletteFolderIterator();
		const char *GetNext();	// return the path name of the next file

	private:
		PSearchStackRec searchStack;	// The stack of information kept during
										// the recursive directory search
		char filePathName[_MAX_PATH];	// path to last file found
		short curDepth;					// current depth of the stack
		WIN32_FIND_DATA	fileData;		// file data from last search

		static BOOL SetPalettesFolderPath();
		static char palettesFolderPath[_MAX_PATH];
};

#endif