#ifndef _H_dictutil
#define _H_dictutil

/*
	File: dictutil.h (core)

	Macromedia Corporation Proprietary Information - copyright 1996.
	For internal use only. Disclosure or transfer to unauthorized
	persons prohibited. This computer software is protected under
	copyright law as an unpublished work.  All rights reserved.

	Abstract:

  	Revision history:
	950118	Original. (srj)
*/

#if defined(__cplusplus) && !defined(CINTERFACE)

#ifndef _H_moastdif
	#include "moastdif.h"
#endif

inline MoaError PutUnk(PIMoaDict pDict, ConstPMoaChar key, PIMoaUnknown pUnk)
{
	return pDict->Put(kMoaDictType_PIMoaUnknown, &pUnk, sizeof(pUnk), key);
}

inline PIMoaUnknown GetUnk(PIMoaDict pDict, ConstPMoaChar key)
{
	PIMoaUnknown pUnk;

	if (pDict->Get(kMoaDictType_PIMoaUnknown, &pUnk, sizeof(pUnk), key))
		pUnk = NULL;
	return pUnk;
}

inline MoaError PutDict(PIMoaDict pDict, ConstPMoaChar key, PIMoaDict pDictToPut)
{
	return pDict->Put(kMoaDictType_Dict, &pDictToPut, sizeof(pDictToPut), key);
}

inline PIMoaDict GetDict(PIMoaDict pDict, ConstPMoaChar key)
{
	PIMoaDict pDictToGet;

	if (pDict->Get(kMoaDictType_Dict, &pDictToGet, sizeof(pDictToGet), key))
		pDictToGet = NULL;
	return pDictToGet;
}

inline MoaError PutUnattachedDict(PIMoaDict pDict, ConstPMoaChar key, PIMoaDict pDictToPut)
{
	return pDict->Put(kMoaDictType_Long, &pDictToPut, sizeof(pDictToPut), key);
}

inline PIMoaDict GetUnattachedDict(PIMoaDict pDict, ConstPMoaChar key)
{
	PIMoaDict pDictToGet;

	if (pDict->Get(kMoaDictType_Long, &pDictToGet, sizeof(pDictToGet), key))
		pDictToGet = 0;
	return pDictToGet;
}

inline MoaError PutBool(PIMoaDict pDict, ConstPMoaChar key, MoaBool value)
{
	return pDict->Put(kMoaDictType_Bool, &value, sizeof(value), key);
}

inline MoaBool GetBool(PIMoaDict pDict, ConstPMoaChar key)
{
	MoaBool value;

	if (pDict->Get(kMoaDictType_Bool, &value, sizeof(value), key))
		value = FALSE;
	return value;
}

inline MoaError PutLong(PIMoaDict pDict, ConstPMoaChar key, MoaLong value)
{
	return pDict->Put(kMoaDictType_Long, &value, sizeof(value), key);
}

inline MoaLong GetLong(PIMoaDict pDict, ConstPMoaChar key)
{
	MoaLong value;

	if (pDict->Get(kMoaDictType_Long, &value, sizeof(value), key))
		value = 0;
	return value;
}

inline MoaError PutHandle(PIMoaDict pDict, ConstPMoaChar key, MoaHandle value)
{
	return pDict->Put(kMoaDictType_Long, &value, sizeof(value), key);
}

inline MoaHandle GetHandle(PIMoaDict pDict, ConstPMoaChar key)
{
	MoaHandle value;

	if (pDict->Get(kMoaDictType_Long, &value, sizeof(value), key))
		value = 0;
	return value;
}

inline MoaError PutBytes(PIMoaDict pDict, ConstPMoaChar key, PMoaVoid p, MoaLong len)
{
	return pDict->Put(kMoaDictType_Bytes, p, len, key);
}

inline MoaError GetBytes(PIMoaDict pDict, ConstPMoaChar key, PMoaVoid p, MoaLong len)
{
	return pDict->Get(kMoaDictType_Bytes, p, len, key);
}

inline MoaError PutString(PIMoaDict pDict, ConstPMoaChar key, PMoaChar p)
{
	return pDict->Put(kMoaDictType_CString, p, 0, key);
}

inline MoaError GetString(PIMoaDict pDict, ConstPMoaChar key, PMoaChar p, MoaLong len)
{
	*p = 0;
	return pDict->Get(kMoaDictType_CString, p, len, key);
}

#endif
#endif
