/*
	File: macevhnd.h (mac)

	Copyright (c) 1994, 1995, 1996 Macromedia, Inc.  All Rights Reserved

	You may utilize this source file to create and compile object code for use within products 
	you may create.  THIS CODE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, AND 
	MACROMEDIA DISCLAIMS ALL IMPLIED WARRANTIES INCLUDING, BUT NOT LIMITED TO, MERCHANTABILITY, 
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT WILL MACROMEDIA BE 
	LIABLE TO YOU FOR ANY CONSEQUENTIAL, INDIRECT OR INCIDENTAL DAMAGES ARISING OUT OF YOUR 
	USE OR INABILITY TO USE THIS CODE.

	Abstract:
	
  	Revision history:
	951018	Original. (srj)
*/

#ifndef _H_macevhnd
#define _H_macevhnd

#ifndef _H_moastdif
	#include "moastdif.h"
#endif

#ifndef PUREMETHOD
	#define PUREMETHOD(macro_NAME, macro_ARGS) \
		STDMETHOD(macro_NAME) macro_ARGS PURE;
#endif

#ifndef PUREMETHOD_
	#define PUREMETHOD_(macro_RET, macro_NAME, macro_ARGS) \
		STDMETHOD_(macro_RET, macro_NAME) macro_ARGS PURE;
#endif

#ifndef EXTERN_DEFMETHOD
	#define EXTERN_DEFMETHOD(macro_NAME, macro_ARGS) \
		EXTERN_DEFINE_METHOD(MoaError, macro_NAME, macro_ARGS)
#endif

#ifndef EXTERN_DEFMETHOD_
	#define EXTERN_DEFMETHOD_(macro_RET, macro_NAME, macro_ARGS) \
		EXTERN_DEFINE_METHOD(macro_RET, macro_NAME, macro_ARGS)
#endif

#if defined(__MWERKS__) && defined(__MC68K__)
#pragma push
#pragma pointers_in_D0
#endif

#undef INTERFACE
#define INTERFACE IMoaMacEventHandler
DECLARE_INTERFACE_(IMoaMacEventHandler, IMoaUnknown)
{
	STD_IUNKNOWN_METHODS

	PUREMETHOD(MacHandleEvent, (THIS_  
		moa_in PMoaVoid pEventRecord
	))
};
typedef IMoaMacEventHandler FAR * PIMoaMacEventHandler;
DEFINE_GUID(IID_IMoaMacEventHandler, 0xAAC24E24L, 0x9159, 0x11CF, 0x90, 0xDC, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

typedef struct _MacDialogCookie FAR * MacDialogCookie;
typedef MacDialogCookie FAR * PMacDialogCookie;

#undef INTERFACE
#define INTERFACE IMoaMacDialogHandler
DECLARE_INTERFACE_(IMoaMacDialogHandler, IMoaUnknown)
{
	STD_IUNKNOWN_METHODS

	PUREMETHOD(MacPrepareModalDialog, (THIS_ 
		moa_out PMacDialogCookie pDialogCookie
	))
	
	PUREMETHOD(MacModalDialog, (THIS_ 
		moa_in MacDialogCookie dialogCookie, 
		moa_in PMoaVoid filterProcUPP, 
		moa_out MoaShort FAR * itemHit
	))

	PUREMETHOD(MacUnprepareModalDialog, (THIS_ 
		moa_in MacDialogCookie dialogCookie
	))

	PUREMETHOD_(MoaLong, MacAlert, (THIS_ 
		moa_in MoaLong alertID, 
		moa_in PMoaVoid filterProcUPP
	))
};
typedef IMoaMacDialogHandler FAR * PIMoaMacDialogHandler;
DEFINE_GUID(IID_IMoaMacDialogHandler, 0xB3117528L, 0x9159, 0x11CF, 0x90, 0xDC, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

#undef INTERFACE
#define INTERFACE IMoaMacWindowHandler
DECLARE_INTERFACE_(IMoaMacWindowHandler, IMoaUnknown)
{
	STD_IUNKNOWN_METHODS

	PUREMETHOD(MacRegisterWindow, (THIS_ 
		moa_in PIMoaMacEventHandler pEventHandler, 
		moa_in PMoaVoid pWindow, 
		moa_in MoaLong flags, 	/* MoaMmRegWindowFlags */
		moa_in PMoaVoid refCon
	)) 

	PUREMETHOD(MacUnregisterWindow, (THIS_ 
		moa_in PIMoaMacEventHandler pEventHandler
	)) 

	PUREMETHOD(MacDragWindow, (THIS_ 
		moa_in PMoaVoid pWindow, 
		moa_in PMoaPoint pStartPoint, 
		moa_in PMoaRect pLimitRect
	)) 

	PUREMETHOD(MacSelectWindow, (THIS_ 
		moa_in PMoaVoid pWindow
	)) 

	PUREMETHOD(MacShowWindow, (THIS_ 
		moa_in PMoaVoid pWindow
	)) 

	PUREMETHOD(MacHideWindow, (THIS_ 
		moa_in PMoaVoid pWindow
	)) 
};
typedef IMoaMacWindowHandler FAR * PIMoaMacWindowHandler;
DEFINE_GUID(IID_IMoaMacWindowHandler, 0xB8715C90L, 0x9159, 0x11CF, 0x90, 0xDC, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

#if defined(__MWERKS__) && defined(__MC68K__)
#pragma pop
#endif

#endif
