/*	
	File: mtexcept.c

	Copyright (c) 2001 Macromedia Incorporated. All rights reserved.

	Abstract:

	Portable exception handler suitable for use within an Xtra.
	You DO NOT need to use this within Xtras, but it can be quite
	handy, so is provided for your convenience.
*/

#include "mtexcept.h"

#ifndef SCORE
ExceptionRec *gTopHandler = NULL;		/* ptr to top of exception handler stack */
#endif

/* ================================================================================ */
/* ============================== Interface Routines ============================== */
/* ================================================================================ */

/* -------------------------------------------------------------------- FHXRaiseMsg */
/*	Transfer control to the topmost exception handler and pop it off the stack. The
	code and message parameters are copied into the exception handler record. If no
	exception handlers are active, the results are unpredictable. */

#ifdef MACINTOSH
void FHXRaiseMsg(long code, long message)
{
	register ExceptionRec *pf;			/* pointer to exception handler */

#ifdef MACINTOSH
#ifndef powerc
	/*
		This is a handy debugging trick: sometimes it is difficult
		to set a breakpoint on this routine; to get around this,
		we use the LoadTrap global (normally set to debug segment
		loading) to break here.
	*/
	if (*((byte*)0x12d)) Debugger();	/* LoadTrap low-memory global */
#endif
#endif

	if ((pf = TOPHANDLER) != NULL) {	/* get a pointer to the top handler */
		TOPHANDLER		= pf->next;		/* pop the top handler */
		pf->code		= code;			/* set the exception code */
		pf->message		= message;		/* set the exception message */
		longjmp(pf->env, 1);			/* transfer to the exception handler */
	}
#ifdef DEBUG
	else {
		#ifdef MACINTOSH
		DebugStr((void*)"\pNo Exception Handler");
		#endif
		code /= (code-code);	/* force a crash */
	}
#endif
}
#endif
