/*
	File: mtexcept.h

	Copyright (c) 2001 Macromedia Incorporated. All rights reserved.

	Portable exception handler suitable for use within an Xtra.
	You DO NOT need to use this within Xtras, but it can be quite
	handy, so is provided for your convenience.
*/

#ifndef _H_mtexcept
#define _H_mtexcept

#include <setjmp.h>
#include "mutbase.h"

#define NO_ERR					0				/* no error */
#define NO_MSG					0L				/* no message */
#define NULL_ERROR				-108			/* memFullErr on Mac */
#define FailNull(p)				if (!(p)) RAISE(NULL_ERROR);
#define FailError(err)			{ long _error_; if ((_error_ = (err)) != 0L) RAISE(_error_); }

typedef struct ExceptionRec {	/* Exception handler record */
	struct ExceptionRec *next;	/* pointer to next handler */
	jmp_buf env;				/* machine state for entering handler */
	long code;					/* exception code */
	long message;				/* exception message */
} ExceptionRec, *ExceptionPtr;

#ifdef SCORE
	#define TOPHANDLER			(*(ExceptionRec**)&(gUserData))
#else
	extern ExceptionRec* 		gTopHandler;
	#define TOPHANDLER			gTopHandler
#endif

#define EXCEPTION_CODE			(Exception.code)
#define EXCEPTION_MSG			(Exception.message)

#ifdef DEBUG
	/* force a crash if we screw something up. */
	#define _E_RESTORE			if (TOPHANDLER != &Exception) Exception.code /= (Exception.code-Exception.code); TOPHANDLER = Exception.next
#else
	#define _E_RESTORE			TOPHANDLER = Exception.next
#endif

#define DURING					{ ExceptionRec Exception;				\
								Exception.code = NO_ERR;				\
								Exception.next = TOPHANDLER;			\
								TOPHANDLER = &Exception;				\
								if (!setjmp(Exception.env)) {

#define HANDLER					 _E_RESTORE; } else {

#define END_HANDLER				} }

#define RAISE(c)				FHXRaiseMsg(c, NO_MSG)
#define RAISE_MSG(c, m)			FHXRaiseMsg(c, m)
#define RERAISE					FHXRaiseMsg(Exception.code, Exception.message)

#define E_RETURN(x)				{ _E_RESTORE; return(x); }
#define E_RETURN_VOID			{ _E_RESTORE; return; }

extern void FHXRaiseMsg(long code, long message);

#endif
