/*
 *	FILE:		xh_path.h
 *	PRODUCT:	FreeHand
 *	SYNOPSIS:	Declarations for helper routines associated with FreeHand paths.
 *	
 *	Copyright (c) 1994, 1995, 1996 Macromedia, Inc.  All Rights Reserved.
 *
 *	You may utilize this source file to create and compile object code for use 
 *	within products you may create.  THIS CODE IS PROVIDED "AS IS", WITHOUT 
 *	WARRANTY OF ANY KIND, AND MACROMEDIA DISCLAIMS ALL IMPLIED WARRANTIES 
 *	INCLUDING, BUT NOT LIMITED TO, MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 *	PURPOSE AND NONINFRINGEMENT.  IN NO EVENT WILL MACROMEDIA BE LIABLE TO YOU 
 *	FOR ANY CONSEQUENTIAL, INDIRECT OR INCIDENTAL DAMAGES ARISING OUT OF YOUR
 *	USE OR INABILITY TO USE THIS CODE.
 */


/*
 *	sentry
 */
#ifndef _H_xh_path
#define _H_xh_path


/*
 *	include files
 */
#include "moaxtra.h"
#include "moastdif.h"
#include "fhxif.h"


/*
 *	special (required for 68k)
 */
#if defined(__MWERKS__) && !defined(powerc)
#pragma push
#pragma pointers_in_D0
#endif


/*
 *	type declarations
 */

typedef struct {
	ElemparamP		pElem;
	MoaLong			numPoints;
	MoaBoolParam	isClosed;
} FhPathInfoRec, * PFhPathInfoRec;

typedef struct {
	MPoint		predBCP,
				mainPt,
				succBCP;
	MoaLong		tripleFlags;
} FhTripleRec, * PFhTripleRec;


/*
 *	external prototypes
 */
 
MoaBoolParam GetPathInfo(
	PIMoaFhCallback pFhCbk,
	ElemparamP pElem,
	PFhPathInfoRec pPathInfo
);

MoaBoolParam GetFhTriple(
	PIMoaFhCallback pFhCbk,
	PFhPathInfoRec pPathInfo,
	MoaLong pointIndex,
	PFhTripleRec pTriple
);

MoaBoolParam SetFhTriple(
	PIMoaFhCallback pFhCbk,
	PFhPathInfoRec pPathInfo,
	MoaLong pointIndex,
	PFhTripleRec pTriple
);


/*
 *	special (required for 68k)
 */
#if defined(__MWERKS__) && !defined(powerc)
#pragma pop
#endif


/*
 *	sentry
 */
#endif
