/**********************************************************************
	NOTICE: This code is used in several Macromedia products. If you
			make changes to the code, please let the other projects
			know about it, and please inform the code librarian.
			Thanks for your cooperation.
									James Armstrong-Brasure
 **********************************************************************/

#pragma once

/*
	coolcolr.h

	Copyright (c) 1994-1996 Macromedia, Inc.  All Rights Reserved.
	
	You may utilize this source file to create and compile object code
	for use within products you may create.  THIS CODE IS PROVIDED "AS IS",
	WITHOUT WARRANTY OF ANY KIND, AND MACROMEDIA DISCLAIMS ALL IMPLIED
	WARRANTIES INCLUDING, BUT NOT LIMITED TO, MERCHANTABILITY, FITNESS FOR A
	PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT WILL MACROMEDIA BE 
	LIABLE TO YOU FOR ANY CONSEQUENTIAL, INDIRECT OR INCIDENTAL DAMAGES ARISING
	OUT OF YOUR USE OR INABILITY TO USE THIS CODE.

	Abstract
	--------
	This file contains constants for use with CoolSelectColor().
	They were placed in a separate file so that people writing
	Xtras could have access to the constants without having to
	include a bunch of other stuff.
*/

#ifndef _H_coolcolr
#define _H_coolcolr

#ifdef __cplusplus
extern "C" {
#endif

/* Color selectors for use with CoolSelectColor() */
typedef enum {
	/* light colors */
	COOL_WHITE,				/* pure white */
	COOL_SUNLIGHT,			/* used for hilites */
	COOL_LIGHT_GRAY,		/* used for very subtle hilites */
	
	/* medium colors */
	COOL_BACKGROUND_COLOR,	/* the standard window background color */
	COOL_DISABLED_COLOR,	/* used to draw disabled items */
	
	/* dark colors */
	COOL_LIGHT_SHADOW,		/* used for subtle shadows */
	COOL_SHADOW,			/* used for shadows */
	COOL_DARK_SHADOW,		/* used for shadows */
	COOL_DARKER_SHADOW,		/* used for very dark shadows */
	COOL_BORDER_COLOR,		/* used to draw borders of most items */
#ifdef WINDOWS
	COOL_BLACK,				/* pure black */
	COOL_BUTTON_FACE,		/* color of button face */
	COOL_BUTTON_SHADOW,		/* color of button shadow */
	COOL_BUTTON_HIGHLIGHT	/* color of button highlight */
#else
	COOL_BLACK				/* pure black */
#endif
} _CoolColorSelector;
typedef long CoolColorSelector;

#define COOL_RECT_NO_FILL	0xFFFFFFFF		/* see CoolDrawRect */

#ifdef __cplusplus
}
#endif

#endif /* _H_coolcolr */
