/*
	file: fhui.h

	Copyright (c) 1994 Altsys. All rights reserved.
*/

#pragma once

#ifndef _H_fhui
#define _H_fhui

#include "uidefs.h"

/*
	a color was dropped in the gadget.
	msgParam1 == PT2LONG() of drop location.
	msgParam2 == ColorparamP
*/
#define UI_FH_COLOR_DROPPED		(UI_FIRSTUSERMSG+1)

/*
	These three messages are used when a color is being
	dragged over a gadget; the gadget may want to hilite
	itself to indicate it can receive the color.

	msgParam1 == PT2LONG() of mouse location.
	msgParam2 == ColorparamP
*/
#define UI_FH_COLOR_ENTERED		(UI_FIRSTUSERMSG+2)
#define UI_FH_COLOR_DRAGGED		(UI_FIRSTUSERMSG+3)
#define UI_FH_COLOR_EXITED		(UI_FIRSTUSERMSG+4)

/*
	use this in conjunction with UI_GET_LONG or UI_SET_LONG
	to get a ColorparamP from a color well, e.g.,
	
	myColor = (ColorparamP)UIGetLong(myGadget, UIKEY_FH_COLOR);
*/
#define UIKEY_FH_COLOR			(-100)

/*
	This is a predefined classid that handles
	a standard color well. If you use it you
	won't need to worry with any of the messages
	above except for UIKEY_FH_COLOR.
*/
#define GADGETCLASS_COLORWELL		"FHColorWell"
#define UIKEY_ALLOW_NONE			(-101)	//	Enable the None button in the popup color window

#define GADGETCLASS_TABGROUPFRAME	"FrameGadget"
#define GADGETCLASS_TABGROUP		"TabGroup"
#define GADGETCLASS_TABGADGET		"TabGadget"

#endif


