/*
	file: fhxif.h

	Copyright (c) 1996 Macromedia. All rights reserved.
	
	Revision History:
	980220	Added IMoaFhVersion interface for FH8J and FH9 (spm)
	97????	Added IMoaFh80Callback and IMoaFh80MacCallback interfaces (hds)
	960711	Added FHI...CustomDocData calls (jsd)
	960501	FEATURE_SCRIPTING Added Printing, export, and GSR API cals (jsa)
	960102	Added FHISetUngroupWarning. (mmb)
	951221	Added FHICopyToClipboard. (mmb)
	951214	Added FHIEndGroup2. (mmb)
	951207	Added FHIElemGetTransparency. (hds)
	951204	Added David Spells' new prototypes for the IMoaXUI methods
			Apparently some profiling stuff he wanted to do depended on
			the prototypes having the names of the arguments as well
			as the types; as a result, I just added in the ones he put
			together (jsd)
	951128	Added IMoaFh60Callbacks iface, and the first three methods:
			FHINewTiledFill
			FHIGetTiledFillRec
			FHIInitTiledFillRec (jsd)
	9504??	Added new IMoaFh60Callbacks.
			FHIGetTiledFillOutput, FHIGetSingleTileMtx, FHIGetFontElement, FHIGetFontMetrics,
			FHITextElemInitTraverse, FHITextElemBeginTraverse, FHITextElemGetNextCharGroup,
			FHIElemIsClipGroup, FHIElemSetClip. (hds)
	??????	Original (probably srj)
*/

#ifndef _H_fhxif
#define _H_fhxif

#ifndef _H_pixelmoa
	#include "pixelmoa.h"
#endif

#ifndef _H_moaxtra
	#include "moaxtra.h"
#endif

#ifndef _H_moastdif
	#include "moastdif.h"
#endif

#ifndef _H_muttypes
	#include "muttypes.h"
#endif

#ifndef _H_uibase
	#include "uibase.h"
#endif

#ifndef _H_cpgraf
	#include "cpgraf.h"
#endif

#ifndef _H_moaprgrs
	#include "moaprgrs.h"
#endif

// CLSID_FHCBK: AB95FC7D6684448A785D080007160DC3
MOA_DEFINE_GUID(CLSID_FHCBK, 0xAB95FC7DL, 0x6684, 0x448A, 0x78, 0x5D, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaMutantDebugger

DECLARE_MOA_INTERFACE_(IMoaMutantDebugger, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(void, MagicMoaMutantDebugger) (THIS_ PMoaChar msg) PURE;
};
typedef IMoaMutantDebugger FAR * PIMoaMutantDebugger;

// IID_IMoaMutantDebugger: AB95FCD210444CB3505B080007160DC3
MOA_DEFINE_GUID(IID_IMoaMutantDebugger, 0xAB95FCD2L, 0x1044, 0x4CB3, 0x50, 0x5B, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhInterrogator

DECLARE_MOA_INTERFACE_(IMoaFhInterrogator, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(void, Interrogate) (THIS) PURE;
};
typedef IMoaFhInterrogator FAR * PIMoaFhInterrogator;

// IID_IMoaFhInterrogator: ABB3FA130034C83E0000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhInterrogator, 0xABB3FA13L, 0x0034, 0xC83E, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:
	None.
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhInterrogator2

DECLARE_MOA_INTERFACE_(IMoaFhInterrogator2, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(void, Interrogate) (THIS) PURE;
};
typedef IMoaFhInterrogator2 FAR * PIMoaFhInterrogator2;

MOA_DEFINE_GUID(IID_IMoaFhInterrogator2, 0xB102852EL, 0xE0C3, 0x11CF, 0xBA, 0x7C, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:
	None.
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhTerminator

DECLARE_MOA_INTERFACE_(IMoaFhTerminator, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(void, Terminate) (THIS) PURE;
};
typedef IMoaFhTerminator FAR * PIMoaFhTerminator;

// IID_IMoaFhTerminator: AC540D0E000124180000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhTerminator, 0xAC540D0EL, 0x0001, 0x2418, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:
	None.
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhMenuItem
DECLARE_MOA_INTERFACE_(IMoaFhMenuItem, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	STDMOAMETHOD(ItemSelected) (THIS_ MoaBoolParam repeatLast) PURE;
};
typedef IMoaFhMenuItem FAR * PIMoaFhMenuItem;

// IID_IMoaFhMenuItem: AC50DE1800044B7E0000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhMenuItem, 0xAC50DE18L, 0x0004, 0x4B7E, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:
*/

#define key_IMoa_Item_Category	"IMoa_Item_Category"	// C String
#define key_IMoa_Item_Name		"IMoa_Item_Name"		// C String
#define key_IMoa_Item_Help		"IMoa_Item_Help"		// C String

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhPublishItem
DECLARE_INTERFACE_(IMoaFhPublishItem, IMoaFhMenuItem)
{
	STD_IUNKNOWN_METHODS
	STDMETHOD(ItemSelected) (THIS_ MoaBoolParam repeatLast) PURE;
};
typedef IMoaFhPublishItem FAR * PIMoaFhPublishItem;

// IID_IMoaFhPublishItem: AC50DE1800044B7F0000080007160DC3
DEFINE_GUID(IID_IMoaFhPublishItem, 0xAC50DE18L, 0x0004, 0x4B7F, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);


#undef INTERFACE
#define INTERFACE IMoaFhButtonItem
DECLARE_MOA_INTERFACE_(IMoaFhButtonItem, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	STDMOAMETHOD(ItemSelected) (THIS_ MoaBoolParam repeatLast) PURE;
	STDMOAMETHOD(GetButtonIcon) (THIS_ CPIconHan FAR * pIcon) PURE;
};
typedef IMoaFhButtonItem FAR * PIMoaFhButtonItem;

// IID_IMoaFhButtonItem: AC50DE1800044B800000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhButtonItem, 0xAC50DE18L, 0x0004, 0x4B80, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:
	??? someday, make the icon cacheable
	
	key_IMoa_Item_Name
	key_IMoa_Item_Help
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhToolItem
DECLARE_MOA_INTERFACE_(IMoaFhToolItem, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	STDMOAMETHOD(TrackBegin) (THIS_ FHXToolTrackRec FAR * pTrackRec) PURE;
	STDMOAMETHOD(TrackMoved) (THIS_ FHXToolTrackRec FAR * pTrackRec) PURE;
	STDMOAMETHOD(TrackFeedback) (THIS_ FHXToolTrackRec FAR * pTrackRec) PURE;
	STDMOAMETHOD(TrackEnd) (THIS_ FHXToolTrackRec FAR * pTrackRec) PURE;
	STDMOAMETHOD(GetOptions) (THIS_ MoaLong FAR * pOptions) PURE;
	STDMOAMETHOD(DoPrefs) (THIS) PURE;
	STDMOAMETHOD(GetToolIcon) (THIS_ CPIconHan FAR * pIcon) PURE;
};
typedef IMoaFhToolItem FAR * PIMoaFhToolItem;

// IID_IMoaFhToolItem: AC50DE1900044B820000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhToolItem, 0xAC50DE19L, 0x0004, 0x4B82, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:

	key_IMoa_Item_Name
	key_IMoa_Item_Help

	??? someday, make the icon cacheable
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhMonitorItem
DECLARE_MOA_INTERFACE_(IMoaFhMonitorItem, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	STDMOAMETHOD(Notify) (THIS_ ConstPMoaChar pFactName) PURE;
};
typedef IMoaFhMonitorItem FAR * PIMoaFhMonitorItem;

// IID_IMoaFhMonitorItem: AC50DE1900044B860000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhMonitorItem, 0xAC50DE19L, 0x0004, 0x4B86, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	keys to enter in registry: none.
	This interface isn't registered; you must explicitly
	start and stop listening with AddMonitor and RemoveMonitor.
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhReaderItem
DECLARE_MOA_INTERFACE_(IMoaFhReaderItem, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	STDMOAMETHOD(PreReadFromFile) (THIS_ SysFileSpec FAR * pFileSpec) PURE;
	STDMOAMETHOD(ReadFromStream) (THIS_ StreamID streamID) PURE;
	STDMOAMETHOD(PostReadFromFile) (THIS_ SysFileSpec FAR * pFileSpec) PURE;
	STDMOAMETHOD(GetOptions) (THIS_ MoaLong FAR * pOptions) PURE;
	STDMOAMETHOD(GetDataType) (THIS_ DataTypeID FAR * pDataTypeID) PURE;
	STDMOAMETHOD(DoPrefs) (THIS) PURE;
};
typedef IMoaFhReaderItem FAR * PIMoaFhReaderItem;

// IID_IMoaFhReaderItem: AC50DE5A00045AD60000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhReaderItem, 0xAC50DE5AL, 0x0004, 0x5AD6, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry: none
	(someday, set it up so data types can be registered here)
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhWriterItem
DECLARE_MOA_INTERFACE_(IMoaFhWriterItem, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	STDMOAMETHOD(TestWrite) (THIS_ MoaBoolParam FAR * pCanWrite) PURE;
	STDMOAMETHOD(WriteToStream) (THIS_ StreamID streamID) PURE;
	STDMOAMETHOD(WriteFileInfo) (THIS_ SysFileSpec FAR * pFileSpec) PURE;
	STDMOAMETHOD(GetOptions) (THIS_ MoaLong FAR * pOptions) PURE;
	STDMOAMETHOD(GetDataType) (THIS_ DataTypeID FAR * pDataTypeID) PURE;
	STDMOAMETHOD(DoPrefs) (THIS) PURE;
};
typedef IMoaFhWriterItem FAR * PIMoaFhWriterItem;

// IID_IMoaFhWriterItem: AC50DE7C000462E20000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhWriterItem, 0xAC50DE7CL, 0x0004, 0x62E2, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/*
	Keys to enter in the registry:
	None
	(someday, set it up so data types can be registered here)
*/

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaStdPrefs

DECLARE_MOA_INTERFACE_(IMoaStdPrefs, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(MoaBoolParam, GetPreference) (THIS_ ConstPMoaChar prefName, PMoaChar prefValue) PURE;
	STDMOAMETHOD_(void, SetPreference) (THIS_ ConstPMoaChar prefName, ConstPMoaChar prefValue) PURE;
	STDMOAMETHOD_(void, SetBoolPref) (THIS_ ConstPMoaChar prefName, MoaBoolParam prefValue) PURE;
	STDMOAMETHOD_(MoaBoolParam, GetBoolPref) (THIS_ ConstPMoaChar prefName) PURE;
	STDMOAMETHOD_(void, SetFixedPref) (THIS_ ConstPMoaChar prefName, MoaFixed prefValue) PURE;
	STDMOAMETHOD_(MoaFixed, GetFixedPref) (THIS_ ConstPMoaChar prefName) PURE;
	STDMOAMETHOD_(void, SetLongPref) (THIS_ ConstPMoaChar prefName, MoaLong prefValue) PURE;
	STDMOAMETHOD_(MoaLong, GetLongPref) (THIS_ ConstPMoaChar prefName) PURE;
	STDMOAMETHOD_(void, SetWinPosPref) (THIS_ ConstPMoaChar prefName, const CPRect FAR * prefValue) PURE;
	STDMOAMETHOD_(MoaBoolParam, GetWinPosPref) (THIS_ ConstPMoaChar prefName, CPRect FAR * prefValue) PURE;
};
typedef IMoaStdPrefs FAR * PIMoaStdPrefs;

// IID_IMoaStdPrefs: ABB40958000133690000080007160DC3
MOA_DEFINE_GUID(IID_IMoaStdPrefs, 0xABB40958L, 0x0001, 0x3369, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhFixMath

DECLARE_MOA_INTERFACE_(IMoaFhFixMath, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(MoaFixed, FixCos) (THIS_ MoaFixed ang) PURE;
	STDMOAMETHOD_(MoaFixed, FixDivFix) (THIS_ MoaFixed a, MoaFixed b) PURE;
	STDMOAMETHOD_(MoaFixed, FixMulFix) (THIS_ MoaFixed fix1, MoaFixed fix2) PURE;
	STDMOAMETHOD_(MoaFixed, FixPtDist) (THIS_ MoaFixed dx, MoaFixed dy) PURE;
	STDMOAMETHOD_(MoaFixed, FixMulDivFix) (THIS_ MoaFixed a, MoaFixed b, MoaFixed c) PURE;
	STDMOAMETHOD_(MoaFixed, FixRoundFix) (THIS_ MoaFixed a) PURE;
	STDMOAMETHOD_(MoaFixed, FixSin) (THIS_ MoaFixed ang) PURE;
	STDMOAMETHOD_(MoaFixed, FixSqrt) (THIS_ MoaFixed f) PURE;
	STDMOAMETHOD_(MoaFixed, FixSlopeAngle) (THIS_ MoaFixed dx, MoaFixed dy) PURE;
	STDMOAMETHOD_(void, FixProjectPoint) (THIS_ ConstPMPoint slope, MoaFixed dist, ConstPMPoint pt, PMPoint outPt) PURE;
};
typedef IMoaFhFixMath FAR * PIMoaFhFixMath;

// IID_IMoaFhFixMath: ABB04C2100141BEC0000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhFixMath, 0xABB04C21L, 0x0014, 0x1BEC, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhMtx

DECLARE_MOA_INTERFACE_(IMoaFhMtx, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(void, FHIMtxCreate) (THIS_ FHIMatrixRec* mtxP, MoaFixed a, MoaFixed b, MoaFixed c, MoaFixed d, MoaFixed tx, MoaFixed ty) PURE;
	STDMOAMETHOD_(void, FHIMtxCreateUnity) (THIS_ FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(void, FHIMtxCreateRotate) (THIS_ FHIMatrixRec* mtxP, MoaFixed angle) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMtxEqual) (THIS_ const FHIMatrixRec* mtx1P, const FHIMatrixRec* mtx2P) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMtxIsUnity) (THIS_ const FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(void, FHIMtxConcat) (THIS_ const FHIMatrixRec* in1, const FHIMatrixRec* in2, FHIMatrixRec* out) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMtxGetTerms) (THIS_ const FHIMatrixRec* mtxP, MoaFixed* a, MoaFixed* b, MoaFixed* c, MoaFixed* d, MoaFixed* tx, MoaFixed* ty) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMtxInvert) (THIS_ const FHIMatrixRec* in, FHIMatrixRec* out) PURE;
	STDMOAMETHOD_(void, FHIMtxPt) (THIS_ const FHIMatrixRec* mtxP, ConstPMPoint in, PMPoint out) PURE;
	STDMOAMETHOD_(void, FHIMtxDist) (THIS_ const FHIMatrixRec* mtxP, ConstPMPoint in, PMPoint out) PURE;
};
typedef IMoaFhMtx FAR * PIMoaFhMtx;

// IID_IMoaFhMtx: ABB0501800150A7C0000080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhMtx, 0xABB05018L, 0x0015, 0x0A7C, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaXUI

DECLARE_MOA_INTERFACE_(IMoaXUI, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(TagID, UIAddChildGadget) (THIS_ GadgetID gadget, GadgetID child, MoaBoolParam childVisible) PURE;
	STDMOAMETHOD_(GadgetID, UICreateGadget) (THIS_ GadgetID parent, TagID gadgetTag,
		GadgetType gadgetType, const UIRect* gadgetBound,
		ConstPMoaChar gadgetTitle, ConstPMoaChar gadgetClass, MoaUlong userMemSize) PURE;
	STDMOAMETHOD_(void, UICreateGadgetClass) (THIS_ ConstPMoaChar className, PIMoaUiProc classProc) PURE;
	STDMOAMETHOD_(void, UICreateUserData) (THIS_ GadgetID gadget, MoaUlong userMemSize) PURE;
	STDMOAMETHOD_(void, UIDestroyGadget) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void, UIDestroyGadgetClass) (THIS_ ConstPMoaChar className) PURE;
	STDMOAMETHOD_(void, UIDestroyUserData) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void*, UIDrawGadgetStart) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void, UIDrawGadgetStop) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void, UIEnableGadget) (THIS_ GadgetID gadget, MoaBoolParam enable) PURE;
	STDMOAMETHOD_(UIMsg, UIError) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, UIGetBool) (THIS_ GadgetID gadget, UIKey key) PURE;
	STDMOAMETHOD_(GadgetID, UIGetChildGadget) (THIS_ GadgetID parent, TagID childIndex) PURE;
	STDMOAMETHOD_(MoaFixed, UIGetFixed) (THIS_ GadgetID gadget, UIKey key) PURE;
	STDMOAMETHOD_(TagID, UIGetGadgetTag) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(MoaLong, UIGetLong) (THIS_ GadgetID gadget, UIKey key) PURE;
	STDMOAMETHOD_(GadgetID, UIGetParent) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void, UIGetPoint) (THIS_ GadgetID gadget, UIKey key, UIPoint*p) PURE;
	STDMOAMETHOD_(void, UIGetRect) (THIS_ GadgetID gadget, UIKey key, UIRect*r) PURE;
	STDMOAMETHOD_(void, UIGetString) (THIS_ GadgetID gadget, UIKey key, PMoaChar gadgetText) PURE;
	STDMOAMETHOD_(void, UIInitialize) (THIS_ MoaUlong dummy) PURE;
	STDMOAMETHOD_(GadgetID, UILoadChildGadget) (THIS_ GadgetID parent, ConstPMoaChar resource, MoaLong hResFile) PURE;
	STDMOAMETHOD_(GadgetID, UILoadGadget) (THIS_ ConstPMoaChar resource, MoaLong hResFile) PURE;
	STDMOAMETHOD_(void*, UILockUserData) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(TagID, UIRunModal) (THIS_ GadgetID gadget, PIMoaUiProc gadgetProc) PURE;
	STDMOAMETHOD_(void, UIRunModeless) (THIS_ GadgetID gadget, PIMoaUiProc gadgetProc) PURE;
	STDMOAMETHOD_(void, UISendMessage) (THIS_ GadgetID gadget, UIMsg msg, MoaUlong msgParam1, MoaUlong msgParam2) PURE;
	STDMOAMETHOD_(void, UISetBool) (THIS_ GadgetID gadget, UIKey key, MoaBoolParam gadgetValue) PURE;
	STDMOAMETHOD_(void, UISetFixed) (THIS_ GadgetID gadget, UIKey key, MoaFixed gadgetValue) PURE;
	STDMOAMETHOD_(void, UISetLong) (THIS_ GadgetID gadget, UIKey key, MoaLong gadgetValue) PURE;
	STDMOAMETHOD_(void, UISetPoint) (THIS_ GadgetID gadget, UIKey key, const UIPoint*p) PURE;
	STDMOAMETHOD_(void, UISetRect) (THIS_ GadgetID gadget, UIKey key, const UIRect*r) PURE;
	STDMOAMETHOD_(void, UISetString) (THIS_ GadgetID gadget, UIKey key, ConstPMoaChar gadgetText) PURE;
	STDMOAMETHOD_(void, UIShowGadget) (THIS_ GadgetID gadget, MoaBoolParam visible) PURE;
	STDMOAMETHOD_(void, UIShutDown) (THIS_ MoaUlong instance) PURE;
	STDMOAMETHOD_(void, UIStopModal) (THIS_ GadgetID gadget, TagID gadgetTag) PURE;
	STDMOAMETHOD_(void, UIStopModeless) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void, UIUnLockUserData) (THIS_ GadgetID gadget) PURE;
	STDMOAMETHOD_(void, UISetKeyFocus) (THIS_ GadgetID gadget, MoaBoolParam hasFocus) PURE;
	STDMOAMETHOD_(GadgetID, UIGetKeyFocus) (THIS) PURE;
	STDMOAMETHOD_(UIMsg, UIStdWindowProc) (THIS_ GadgetID gadget, UIMsg msg, MoaLong msgParam1, MoaLong msgParam2, ConstPMoaChar prefName) PURE;
};
typedef IMoaXUI FAR * PIMoaXUI;

// IID_IMoaXUI: ABB051DA0015744C0000080007160DC3
MOA_DEFINE_GUID(IID_IMoaXUI, 0xABB051DAL, 0x0015, 0x744C, 0x00, 0x00, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#undef INTERFACE
#define INTERFACE IMoaFhCallback

DECLARE_MOA_INTERFACE_(IMoaFhCallback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(MoaBoolParam, FHIAddMonitor) (THIS_ PIMoaFhMonitorItem pMonitor, ConstPMoaChar factName) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIRemoveMonitor) (THIS_ PIMoaFhMonitorItem pMonitor, ConstPMoaChar factName) PURE;
	STDMOAMETHOD_(void, FHISetToolCursor) (THIS_ PIMoaRegistryEntryDict pToolRegDict, CursorparamP cursor) PURE;
	STDMOAMETHOD_(PIMoaRegistryEntryDict, FHIGetCurrentTool) (THIS) PURE;
	STDMOAMETHOD_(void, FHISetCurrentTool) (THIS_ PIMoaRegistryEntryDict pToolRegDict) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetNamedString) (THIS_ XtraResourceCookie cookie, ConstPMoaChar name, MoaLong strIndex, PMoaChar strP) PURE;
	STDMOAMETHOD_(CursorparamP, FHIGetCursor) (THIS_ XtraResourceCookie cookie, ConstPMoaChar name) PURE;
	STDMOAMETHOD_(void, FHIWindowMenu) (THIS_ PMoaChar menuTitle, GadgetID windowGadget, MoaBoolParam add) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetStdCategory) (THIS_ MoaLong index, PMoaChar category) PURE;
	STDMOAMETHOD_(void, FHITKMoveTo) (THIS_ ConstPMPoint pt1) PURE;
	STDMOAMETHOD_(void, FHITKLineTo) (THIS_ ConstPMPoint pt1) PURE;
	STDMOAMETHOD_(void, FHITKCurveTo) (THIS_ ConstPMPoint pt1, ConstPMPoint pt2, ConstPMPoint pt3) PURE;
	STDMOAMETHOD_(void, FHITKClosePath) (THIS) PURE;
	STDMOAMETHOD_(void, FHIConstrainPoint) (THIS_ ConstPMPoint start, ConstPMPoint end, PMPoint out) PURE;
	STDMOAMETHOD_(void, FHITKHiliteStroke) (THIS) PURE;
	STDMOAMETHOD_(void, FHITKText) (THIS_ ConstPMoaChar strP) PURE;
	STDMOAMETHOD_(void, FHIUpdateScreen) (THIS) PURE;
	STDMOAMETHOD_(ColorparamP, FHINewProcessColor) (THIS_ MoaFixed C, MoaFixed M, MoaFixed Y, MoaFixed K) PURE;
	STDMOAMETHOD_(ColorparamP, FHINewSpotColor) (THIS_ MoaFixed C, MoaFixed M, MoaFixed Y, MoaFixed K) PURE;
	STDMOAMETHOD_(MoaLong, FHIColorListSize) (THIS) PURE;
	STDMOAMETHOD_(ColorparamP, FHIColorListAt) (THIS_ MoaLong index) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorListModify) (THIS_ MoaLong index, ColorparamP newColorP) PURE;
	STDMOAMETHOD_(ColorparamP, FHIColorListAdd) (THIS_ ColorparamP newColorP, MoaLong index, PMoaChar name) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorListReorder) (THIS_ MoaLong index1, MoaLong index2) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorGetCMYK) (THIS_ ColorparamP newColorP, MoaFixed* C, MoaFixed* M, MoaFixed* Y, MoaFixed* K) PURE;
	STDMOAMETHOD_(MoaLong, FHIColorGetFlags) (THIS_ ColorparamP newColorP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorGetName) (THIS_ ColorparamP theColorP, PMoaChar namePtr, MoaLong nameLen) PURE;
	STDMOAMETHOD_(ColorparamP, FHIColorGetStandard) (THIS_ MoaLong desiredColor) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorsMatch) (THIS_ ColorparamP color1, ColorparamP color2, MoaFixed tolerance, MoaBoolParam compareType) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIBeginColorTraversal) (THIS_ MoaBoolParam selectedOnly) PURE;
	STDMOAMETHOD_(ColorparamP, FHINextColor) (THIS_ MoaBoolParam* firstTime) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIReplaceCurrentColor) (THIS_ ColorparamP newColorP) PURE;
	STDMOAMETHOD_(void, FHIEndColorTraversal) (THIS) PURE;
	STDMOAMETHOD_(ColorparamP, FHINewTintColor) (THIS_ ColorparamP baseColorP, MoaFixed percent) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITintColorInfo) (THIS_ ColorparamP colorP, ColorparamP* baseColorP, MoaFixed* percentP) PURE;
	STDMOAMETHOD_(FillparamP, FHIFillGet) (THIS_ ElemparamP elem, MoaBoolParam* success) PURE;
	STDMOAMETHOD_(MoaLong, FHIFillGetType) (THIS_ FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIFillSet) (THIS_ ElemparamP elem, FillparamP theFillP) PURE;
	STDMOAMETHOD_(StrokeparamP, FHIStrokeGet) (THIS_ ElemparamP elem, MoaBoolParam* success) PURE;
	STDMOAMETHOD_(MoaLong, FHIStrokeGetType) (THIS_ StrokeparamP theStrokeP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIStrokeSet) (THIS_ ElemparamP elem, StrokeparamP theStrokeP) PURE;
	STDMOAMETHOD_(FillparamP, FHINewBasicFill) (THIS_ BasicFillRec* info) PURE;
	STDMOAMETHOD_(StrokeparamP, FHINewBasicStroke) (THIS_ BasicStrokeRec* strokeInfo) PURE;
	STDMOAMETHOD_(FillparamP, FHINewGradFill) (THIS_ GradFillRec* gradInfo) PURE;
	STDMOAMETHOD_(FillparamP, FHINewPatternFill) (THIS_ PatternFillRec* PatternInfo) PURE;
	STDMOAMETHOD_(StrokeparamP, FHINewPatternStroke) (THIS_ PatternStrokeRec* strokeInfo) PURE;
	STDMOAMETHOD_(FillparamP, FHINewPsFill) (THIS_ ColorparamP theColor, ConstPMoaChar psString) PURE;
	STDMOAMETHOD_(StrokeparamP, FHINewPsStroke) (THIS_ ColorparamP theColor, MoaFixed width, ConstPMoaChar psString) PURE;
	STDMOAMETHOD_(FillparamP, FHINewRadialFill) (THIS_ RadialFillRec* radialInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetBasicFillRec) (THIS_ BasicFillRec* info, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetBasicStrokeRec) (THIS_ BasicStrokeRec* strokeInfo, StrokeparamP theStrokeP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetGradFillRec) (THIS_ GradFillRec* gradInfo, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetPatternFillRec) (THIS_ PatternFillRec* PatternInfo, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetPatternStrokeRec) (THIS_ PatternStrokeRec* strokeInfo, StrokeparamP theStrokeP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetRadialFillRec) (THIS_ RadialFillRec* radialInfo, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitBasicFillRec) (THIS_ BasicFillRec* info) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitBasicStrokeRec) (THIS_ BasicStrokeRec* strokeInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitGradFillRec) (THIS_ GradFillRec* gradInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitPatternFillRec) (THIS_ PatternFillRec* PatternInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitPatternStrokeRec) (THIS_ PatternStrokeRec* strokeInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitRadialFillRec) (THIS_ RadialFillRec* radialInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIBeginCommand) (THIS_ ConstPMoaChar commandName, MoaBoolParam undoable) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdConvertToPath) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdDeleteElem) (THIS_ ElemparamP elemToDelete) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdInsertElem) (THIS_ ElemparamP elemToInsert) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdInsertElemAt) (THIS_ ElemparamP elemToInsert, ElemparamP elemAt, MoaBoolParam behind, MoaBoolParam inside) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdReorderElemAt) (THIS_ ElemparamP elemToReorder, ElemparamP elemAt, MoaBoolParam behind, MoaBoolParam inside) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdReplaceCurrentElem) (THIS_ ElemparamP changedElem) PURE;
	STDMOAMETHOD_(void, FHIEndCommand) (THIS) PURE;
	STDMOAMETHOD_(void, FHIAbortCommand) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIInsertGroupedElem) (THIS_ ElemparamP elemToInsert) PURE;
	STDMOAMETHOD_(ElemparamP, FHIEndGroup) (THIS) PURE;
	STDMOAMETHOD_(ElemparamP, FHICopyElement) (THIS_ ElemparamP elem) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewGroup) (THIS_ MoaBoolParam xgroup) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIBeginElemTraversal) (THIS_ MoaBoolParam selectedOnly, MoaBoolParam travInsideGroups) PURE;
	STDMOAMETHOD_(ElemparamP, FHINextElem) (THIS) PURE;
	STDMOAMETHOD_(void, FHIEndElemTraversal) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIElemBBox) (THIS_ ElemparamP elem, PMPoint lo, PMPoint hi) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIElemPathForAll) (THIS_ ElemparamP elem, FHIMatrixRec* mtxP, void* dataPtr, FHIMoveProc moveProc, FHILineProc lineProc, FHICurveProc curveProc, FHICloseProc closeProc ) PURE;
	STDMOAMETHOD_(MoaLong, FHIElemType) (THIS_ ElemparamP elem) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITranslate) (THIS_ ElemparamP elem, ConstPMPoint offset) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIScale) (THIS_ ElemparamP elem, ConstPMPoint center, MoaFixed hScale, MoaFixed vScale) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIRotate) (THIS_ ElemparamP elem, ConstPMPoint center, MoaFixed scale) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMatrix) (THIS_ ElemparamP elem, const FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetTagBool) (THIS_ ElemparamP elem, MoaLong tag) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetTagInt) (THIS_ ElemparamP elem, MoaLong tag) PURE;
	STDMOAMETHOD_(MoaFixed, FHIGetTagFixed) (THIS_ ElemparamP elem, MoaLong tag) PURE;
	STDMOAMETHOD_(oid, FHIGetTagObject) (THIS_ ElemparamP elem, MoaLong tag) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICopyAttrs) (THIS_ ElemparamP sourceElemP, ElemparamP destElemP) PURE;
	STDMOAMETHOD_(void, FHIPutTagBool) (THIS_ ElemparamP elem, MoaLong tag, MoaBoolParam value) PURE;
	STDMOAMETHOD_(void, FHIPutTagInt) (THIS_ ElemparamP elem, MoaLong tag, MoaLong value) PURE;
	STDMOAMETHOD_(void, FHIPutTagFixed) (THIS_ ElemparamP elem, MoaLong tag, MoaFixed value) PURE;
	STDMOAMETHOD_(void, FHIPutTagObject) (THIS_ ElemparamP elem, MoaLong tag, oid value) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIInitAlongAPath) (THIS_ ElemparamP thePath) PURE;
	STDMOAMETHOD_(MoaFixed, FHILengthAlongAPath) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMtxAlongAPath) (THIS_ const FHIMatrixRec* mtxP, MoaFixed distance, MoaLong mode) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewBlend) (THIS_ ElemparamP firstPath, MoaLong blendPoint1, ElemparamP secondPath, MoaLong blendPoint2, MoaLong numStepsDesired) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPasteCentered) (THIS_ ConstPMPoint position, ConstPMoaChar commandName) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPaste) (THIS_ ConstPMPoint lo, ConstPMPoint hi, AlignT align, ConstPMoaChar commandName) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICanPaste) (THIS) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetPasteElems) (THIS) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOElemToHandle) (THIS_ ElemparamP elem) PURE;
	STDMOAMETHOD_(ElemparamP, FHIOHandleToElem) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(void, FHIOutlineFree) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOCorrectDirection) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOExpandPath) (THIS_ OutlineparamP oHandle, MoaFixed distance, JoinT joinType, MoaFixed miterLimit) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOExpandStroke) (THIS_ OutlineparamP oHandle, MoaFixed width, JoinT joinType, MoaFixed miterLimit, CapT capType) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOIntersect) (THIS_ OutlineparamP oHandle1, OutlineparamP oHandle2) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOPunch) (THIS_ OutlineparamP oHandle1, OutlineparamP oHandle2) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIORemoveOverlap) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOReversePath) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOSimplifyPath) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOSimplifyPathExt) (THIS_ OutlineparamP oHandle, MoaFixed errorTolerance, MoaFixed cornerAngle, MoaFixed numSegments, MoaBoolParam insertHorizontalExtrema, MoaBoolParam insertVerticalExtrema) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOUnion) (THIS_ OutlineparamP oHandle1, OutlineparamP oHandle2) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIOPathForAll) (THIS_ OutlineparamP elem, FHIMatrixRec* mtxP, void* dataPtr, FHIMoveProc moveProc, FHILineProc lineProc, FHICurveProc curveProc, FHICloseProc closeProc) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOWarp) (THIS_ OutlineparamP oHandle1, const FHIWarpRec* warpRecP, MoaBoolParam quick) PURE;
	STDMOAMETHOD_(void, FHIOBuildDefaultWarpFrame) (THIS_ ConstPMPoint lo, ConstPMPoint hi, FHIWarpRec* warpRecP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextBeginTraverse) (THIS_ MoaBoolParam selectedOnly) PURE;
	STDMOAMETHOD_(MoaLong, FHITextNextRange) (THIS) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetNextWord) (THIS_ PMoaChar buffer, MoaLong bufferSize, MoaLong position) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetNextParagraph) (THIS_ PMoaChar buffer, MoaLong bufferSize, MoaLong position) PURE;
	STDMOAMETHOD_(void, FHITextEndTraverse) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextReplace) (THIS_ MoaLong position, MoaLong numCharsToReplace, ConstPMoaChar replaceString) PURE;
	STDMOAMETHOD_(ColorparamP, FHITextGetFillColor) (THIS_ ElemparamP elem, MoaLong position, MoaLong* numCharsOfThisColor) PURE;
	STDMOAMETHOD_(ColorparamP, FHITextGetStrokeColor) (THIS_ ElemparamP elem, MoaLong position, MoaLong* numCharsOfThisColor) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetChars) (THIS_ ElemparamP elemP, MoaLong position, PMoaChar buffer, MoaLong numChars) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextPutChars) (THIS_ ElemparamP elemP, MoaLong position, MoaLong numToReplace, ConstPMoaChar buffer, MoaLong numChars) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetCharAttrs) (THIS_ ElemparamP elem, MoaLong position, CharAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetParaAttrs) (THIS_ ElemparamP elem, MoaLong position, ParaAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(void, FHITextInitCharAttrs) (THIS_ CharAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(void, FHITextInitParaAttrs) (THIS_ ParaAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(ElemparamP, FHITextNewColumn) (THIS_ ConstPMPoint location, MoaFixed columnWidth, MoaFixed columnHeight, ConstPMoaChar buffer, MoaLong numChars) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetCharAttrs) (THIS_ ElemparamP elem, MoaLong position, MoaLong numChars, CharAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetParaAttrs) (THIS_ ElemparamP elem, MoaLong position, MoaLong numChars, ParaAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetFillColor) (THIS_ ElemparamP elem, MoaLong position, MoaLong numCharsOfThisColor, ColorparamP newColor) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetStrokeColor) (THIS_ ElemparamP elem, MoaLong position, MoaLong numCharsOfThisColor, ColorparamP newColor) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetCurrentLayer) (THIS) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetNumLayers) (THIS) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetFirstElemOnLayer) (THIS_ MoaLong layerIndex) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetElemPriorSibling) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetElemSibling) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetElemFirstChild) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetElemLayer) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetElemParent) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHINewLayer) (THIS_ MoaLong index, ConstPMoaChar name) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetCurrentLayer) (THIS_ MoaLong index) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetLayerFlags) (THIS_ MoaLong index) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetLayerFlags) (THIS_ MoaLong index, MoaBoolParam visibleFlag, MoaBoolParam lockedFlag) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetLayerName) (THIS_ MoaLong index, PMoaChar buffer, MoaLong bufLen) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetNumPages) (THIS) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetCurrentPageIndex) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetPageInfo) (THIS_ MoaLong pageIndex, PageInfoRec* pInfoP) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewPathElem) (THIS_ MoaLong numPoints) PURE;
	STDMOAMETHOD_(MoaLong, FHIPathGetNumTriples) (THIS_ ElemparamP thePath) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPathSetTriple) (THIS_ ElemparamP thePath, MoaLong index, ConstPMPoint predBCP, ConstPMPoint thePt, ConstPMPoint succBCP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPathGetTriple) (THIS_ ElemparamP thePath, MoaLong index, PMPoint predBCP, PMPoint thePt, PMPoint succBCP) PURE;
	STDMOAMETHOD_(MoaLong, FHIPathGetTripleFlags) (THIS_ ElemparamP thePath, MoaLong index) PURE;
	STDMOAMETHOD_(void, FHIPathSetTripleFlags) (THIS_ ElemparamP thePath, MoaLong index, MoaLong flags) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPathDeleteTriple) (THIS_ ElemparamP thePath, MoaLong index) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPathInsertTriple) (THIS_ ElemparamP thePath, MoaLong index, ConstPMPoint predBCP, ConstPMPoint thePt, ConstPMPoint succBCP, MoaLong flags) PURE;
	STDMOAMETHOD_(void, FHIPathSetClosed) (THIS_ ElemparamP thePath, MoaBoolParam isClosed) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPathIsClosed) (THIS_ ElemparamP thePath) PURE;
	STDMOAMETHOD_(void, FHIPathCleanup) (THIS_ ElemparamP thePath) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIBeginPSPath) (THIS) PURE;
	STDMOAMETHOD_(void, FHIPSPathMoveTo) (THIS_ ConstPMPoint pt1) PURE;
	STDMOAMETHOD_(void, FHIPSPathLineTo) (THIS_ ConstPMPoint pt1) PURE;
	STDMOAMETHOD_(void, FHIPSPathCurveTo) (THIS_ ConstPMPoint pt1, ConstPMPoint pt2, ConstPMPoint pt3) PURE;
	STDMOAMETHOD_(void, FHIPSPathClose) (THIS) PURE;
	STDMOAMETHOD_(ElemparamP, FHIEndPSPath) (THIS_ MoaBoolParam useDefaults) PURE;
	STDMOAMETHOD_(PMoaChar, FHIStringToLong) (THIS_ ConstPMoaChar s, MoaLong* valueP) PURE;
	STDMOAMETHOD_(PMoaChar, FHILongToString) (THIS_ MoaLong value, PMoaChar s) PURE;
	STDMOAMETHOD_(void, DebugMsg) (THIS_ ConstPMoaChar format, ...) PURE;
	STDMOAMETHOD_(void, FHIReportError) (THIS_ ConstPMoaChar err) PURE;
	STDMOAMETHOD_(void, FHIDragColor) (THIS_ ColorparamP colorP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIDropColorAt) (THIS_ ColorparamP colorP, ConstPMPoint where) PURE;
	STDMOAMETHOD_(ColorparamP, FHIFindColorAt) (THIS_ ConstPMPoint where) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetViewRect) (THIS_ PMPoint lo, PMPoint hi) PURE;
	STDMOAMETHOD_(void, FHIUnitsToString) (THIS_ MoaFixed value, MoaLong code, PMoaChar str) PURE;
	STDMOAMETHOD_(MoaFixed, FHIStringToUnits) (THIS_ ConstPMoaChar str, MoaLong code) PURE;
	STDMOAMETHOD_(void, FHIFixedToString) (THIS_ MoaFixed value, MoaLong precision, PMoaChar str) PURE;
	STDMOAMETHOD_(MoaFixed, FHIStringToFixed) (THIS_ ConstPMoaChar str) PURE;
	STDMOAMETHOD_(void, FHIGetUnitsString) (THIS_ PMoaChar str) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISelectBeginAdd) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISelectBeginEmpty) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISelectAddElem) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISelectRemoveElem) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISelectApply) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISelectStatus) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(DataTypeID, FHICreateWriterDataType) (THIS_ ConstPMoaChar writerIDString, ConstPMoaChar writerDescription, MoaUlong fileType, MoaUlong fileCreator, ConstPMoaChar extension) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIStreamRead) (THIS_ StreamID stream, MoaLong* count, void* buffer) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIStreamWrite) (THIS_ StreamID stream, MoaLong* count, void* buffer) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIStreamGetEOF) (THIS_ StreamID stream, MoaLong* streamEOF) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIStreamGetPos) (THIS_ StreamID stream, MoaLong* streamPos) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIStreamSetPos) (THIS_ StreamID stream, MoaLong streamPos) PURE;
	STDMOAMETHOD_(DataTypeID, FHICreateReaderDataType) (THIS_ ConstPMoaChar readerIDString, ConstPMoaChar readerDescription) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIAddMatchData) (THIS_ DataTypeID dataType, MoaUlong fileType, ConstPMoaChar extension) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewImport) (THIS_ MoaLong importType) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIImportGetMatrix) (THIS_ ElemparamP elemP, FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIImportGetRect) (THIS_ ElemparamP elemP, PMPoint lo, PMPoint hi) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIImportGetName) (THIS_ ElemparamP elemP, PMoaChar buffer, MoaLong bufLen) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIImportSetMatrix) (THIS_ ElemparamP elemP, const FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetFileInfo) (THIS_ ElemparamP elemP, SysFileSpec* fileInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetFileInfo) (THIS_ ElemparamP elemP, const SysFileSpec* fileInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetDocInfo) (THIS_ SysFileSpec* fileInfo, DocInfoRec* infoP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextEditMode) (THIS) PURE;
	STDMOAMETHOD_(ElemparamP, FHITextGetSelection) (THIS_ MoaLong* selStart, MoaLong* numChars) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetSelection) (THIS_ ElemparamP theText, MoaLong selStart, MoaLong numChars) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextCenterSelection) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorGetDisplayRGB) (THIS_ ColorparamP colorP, MoaUshort* r, MoaUshort* g, MoaUshort* b) PURE;
	STDMOAMETHOD_(MoaFixed, FHIGetPixelSize) (THIS) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetNumLines) (THIS_ ElemparamP theText) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextGetLineInfo) (THIS_ ElemparamP theText, MoaLong index, FHILineInfoRec* infoRecP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetMatrix) (THIS_ ElemparamP theElemP, FHIMatrixRec* fhMtxP, MoaBoolParam ignoreParent) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetMatrix) (THIS_ ElemparamP theElemP, FHIMatrixRec* fhMtxP, MoaBoolParam ignoreParent) PURE;
	STDMOAMETHOD_(ElemparamP, FHITextNewOnPath) (THIS_ ElemparamP pathP, ConstPMoaChar buffer, MoaLong numChars) PURE;
	STDMOAMETHOD_(ElemparamP, FHITextNewInPath) (THIS_ ElemparamP pathP, ConstPMoaChar buffer, MoaLong numChars) PURE;
	#ifdef MACINTOSH
	STDMOAMETHOD_(MoaBoolParam, FHIModalDialogProc)(THIS_ void* theDialog, void* theEvent, short* itemHit) PURE;
	#endif
	STDMOAMETHOD_(MoaBoolParam, FHISetCustomData) (THIS_ ElemparamP elemP, ConstPMoaChar customDataName, const void* customDataPtr, MoaLong customDataSize) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetCustomData) (THIS_ ElemparamP elemP, ConstPMoaChar customDataName, void* customDataPtr, MoaLong customDataSize) PURE;
	STDMOAMETHOD_(MoaLong, FHICountDocuments) (THIS) PURE;
	STDMOAMETHOD_(DocparamP, FHIGetNthDocument) (THIS_ MoaLong index) PURE;
	STDMOAMETHOD_(DocparamP, FHIGetCurrentDocument) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetCurrentDocument) (THIS_ DocparamP document) PURE;
	STDMOAMETHOD_(DocparamP, FHIOpenDocument) (THIS_ const SysFileSpec* file) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICloseDocument) (THIS_ DocparamP document, MoaBoolParam warnUser) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISaveDocument) (THIS_ DocparamP document) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISaveDocumentAs) (THIS_ DocparamP document, DataTypeID saveDataType, const SysFileSpec* file) PURE;
	STDMOAMETHOD_(DataTypeID, FHIFindDataType) (THIS_ ConstPMoaChar dataTypeName) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIOMatchMatrix) (THIS_ OutlineparamP original, OutlineparamP modified, MoaBoolParam matchSkew, FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetContents) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetContents) (THIS_ ElemparamP elemP, ElemparamP newContents) PURE;
	STDMOAMETHOD_(MoaLong, FHIRandom) (THIS_ MoaLong* seedP) PURE;
	STDMOAMETHOD_(MoaLong, FHISelectCount) (THIS) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetLocalizeVersion) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIElemIsContentsOrTile) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetCharWords) (THIS_ ElemparamP elemP, MoaLong position, MoaUshort* buffer, MoaLong numChars) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextPutCharWords) (THIS_ ElemparamP elemP, MoaLong position, MoaLong numToReplace, MoaUshort* buffer, MoaLong numChars) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetTiffInfo) (THIS_ ElemparamP elemP, FHITiffInfoRec* infoP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIOpenTiffRowData) (THIS_ ElemparamP elemP, MoaLong rowIndex, MoaByte** dataP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICloseTiffRowData) (THIS_ ElemparamP elemP, MoaLong rowIndex, MoaByte** dataP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetTiff) (THIS_ ElemparamP elemP, FHIDataProc proc, void* userData) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIDraw) (THIS_ FHIDrawInfoRec* infoP) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOInsertPoints) (THIS_ OutlineparamP oHandle1, OutlineparamP oHandle2) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewRectElem) (THIS_ ConstPMPoint lo, ConstPMPoint hi, MoaFixed roundness) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewOvalElem) (THIS_ ConstPMPoint lo, ConstPMPoint hi) PURE;
	STDMOAMETHOD_(MoaFixed, FHIRandomBellCurve) (THIS_ MoaLong* seedP) PURE;
	STDMOAMETHOD_(OutlineparamP, FHIOHandleToHandle) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIOBBox) (THIS_ OutlineparamP oHandle, PMPoint lo, PMPoint hi) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIOIsEmpty) (THIS_ OutlineparamP oHandle) PURE;
	STDMOAMETHOD_(MoaLong, FHICmdNewPage) (THIS_ const PageInfoRec* inP, MoaBoolParam exactPlacement) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdSetPageInfo) (THIS_ MoaLong pageIndex, const PageInfoRec* pInfoP, MoaBoolParam withElements) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdDeletePage) (THIS_ MoaLong pageIndex, MoaBoolParam withElements) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdAddRulerGuide) (THIS_ MoaLong pageIndex, MoaBoolParam vertical, MoaFixed offset) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdDeleteRulerGuide) (THIS_ MoaLong pageIndex, MoaBoolParam vertical, MoaFixed offset) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetRulerGuideInfo) (THIS_ MoaLong pageIndex, MoaBoolParam vertical, MoaLong guideIndex, MoaFixed* offsetP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdElemToGuide) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICmdGuideToElem) (THIS_ ElemparamP guideP) PURE;
	STDMOAMETHOD_(MoaLong, FHIPathGetFlags) (THIS_ ElemparamP pathP) PURE;
	STDMOAMETHOD_(void, FHIPathSetFlags) (THIS_ ElemparamP pathP, MoaLong flags) PURE;
	STDMOAMETHOD_(void, CoolDrawRect) (THIS_ CPPort port, CPRect* rectP, CPColor fillColor, long protrusion, long shadowOffset, long keepShadowInRect) PURE;
	STDMOAMETHOD_(void, CoolDrawLine) (THIS_ CPPort port, long x1, long y1, long x2, long y2) PURE;
	STDMOAMETHOD_(void, CoolDrawBorderedItem) (THIS_ CPPort port, CPIconHan iconH, CPRect* rectP, long borderThickness) PURE;
	STDMOAMETHOD_(void, CoolDrawRepeatingIcon) (THIS_ CPPort port, CPIconHan iconH, CPRect* rectP, CPRect* clipRectP, long horz) PURE;
	STDMOAMETHOD_(long, CoolShouldUseColor) (THIS_ CPPort port, CPRect* rectP, long lenient) PURE;
	STDMOAMETHOD_(void, FHIOSetFlags) (THIS_ OutlineparamP oHandle, MoaLong flags) PURE;
	STDMOAMETHOD_(CPColor, CoolSelectColor) (THIS_ long colorSelector, long selectNow) PURE;
	STDMOAMETHOD_(void, CoolDrawIconButton) (THIS_ CPPort port, CPIconHan iconH, CPRect* rectP, CPRect* updateRectP, long pressed, long enabled, long isColorIcon) PURE;
	STDMOAMETHOD_(ElemparamP, FHIFindElemAt) (THIS_ ConstPMPoint where) PURE;
	STDMOAMETHOD_(MoaLong, FHIElemGetFlags) (THIS_ ElemparamP elemP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIElemSetFlags) (THIS_ ElemparamP elemP, long flags) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIDragColorTo) (THIS_ ColorparamP colorP, PMPoint whereP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetAutoExpand) (THIS_ ElemparamP theText, MoaBoolParam vertical, MoaBoolParam horizontal) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextDoFlow) (THIS_ ElemparamP theText) PURE;
	STDMOAMETHOD_(PIMoaCPGraf, GetCPGraf) (THIS) PURE;
	STDMOAMETHOD_(MoaLong, FHIPartType) (THIS_ MoaLong partCode) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetPartLocation) (THIS_ ElemparamP theElemP,	MoaLong partCode,	MoaFixed t, PMPoint where) PURE;
	STDMOAMETHOD_(void, FHIOGetPointOnStroke) (THIS_ MoaLong part, PMPoint pt, ElemparamP elemP, PMPoint slope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIFindPart) (THIS_ ElemparamP theElemP, ConstPMPoint where, MoaBoolParam usePickDist, MoaLong* partCode, MoaFixed* t) PURE;
	STDMOAMETHOD_(ElemparamP, FHIExtendedFindElemAt) (THIS_ ConstPMPoint where, MoaBoolParam pickOpaque, MoaBoolParam pickBeneath, MoaBoolParam pickSelection, MoaBoolParam pickKids) PURE;
	STDMOAMETHOD_(PIMoaUnknown, FHIGetPixelAccess) (THIS_ ElemparamP theElemP) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIElemDrawBBox) (THIS_ ElemparamP elem, PMPoint lo, PMPoint hi) PURE;
	STDMOAMETHOD_(MoaLong, FHITextGetNumParas) (THIS_ ElemparamP theText) PURE;
	STDMOAMETHOD_(void, FHITextGetParaInfo) (THIS_ ElemparamP theText, MoaLong whichPara, MoaLong *firstCharP, MoaLong *numCharsP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextGetCurAttrs) (THIS_ CharAttrsRec *cAttrsP, ParaAttrsRec *pAttrsP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetCurAttrs) (THIS_ CharAttrsRec *cAttrsP, ParaAttrsRec *pAttrsP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextUseTextEdit) (THIS_ ElemparamP theText) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHITextGetGraphicInfo) (THIS_ ElemparamP elemP, MoaLong position, ElemparamP *graphicP, MoaFixed *widthP, MoaFixed *leftRunaround, MoaFixed *rightRunaround, MoaFixed *factor) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextSetGraphicInfo) (THIS_  ElemparamP elemP, MoaLong position, ElemparamP newGraphic, MoaLong autoFit, MoaFixed width, MoaFixed leftRunaround, MoaFixed rightRunaround, MoaFixed factor) PURE;

	STDMOAMETHOD_(void, FHIEmptyClipboard) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIUndoLastCommand) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetLastCommand) (THIS_ PMoaChar lastCommandP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIElemMtxBBox) (THIS_ ElemparamP elem, FHIMatrixRec* mtxP, PMPoint lo, PMPoint hi) PURE;
	STDMOAMETHOD_(void, SetMutantMenuRepeat) (THIS_ PIMoaRegistryEntryDict pRegDict) PURE;
};
typedef IMoaFhCallback FAR * PIMoaFhCallback;

// IID_IMoaFhCallback: AB95EC35675C6AC6CBFB080007160DC3
MOA_DEFINE_GUID(IID_IMoaFhCallback, 0xAB95EC35L, 0x675C, 0x6AC6, 0xCB, 0xFB, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

// new FH6-specific callbacks interface
#undef INTERFACE
#define INTERFACE IMoaFh60Callback

DECLARE_MOA_INTERFACE_(IMoaFh60Callback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	
	// methods for dealing with tiled fills
	STDMOAMETHOD_(FillparamP, FHINewTiledFill) (THIS_ TiledFillRec *pTiledFillRec) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetTiledFillRec) (THIS_ TiledFillRec *pTiledFillRec, FillparamP fillP, MoaBoolParam concatXforms) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitTiledFillRec) (THIS_ TiledFillRec *pTiledFillRec) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIElemGetTransparency) (THIS_ ElemparamP elemP, ColorparamP *colorP) PURE;

	STDMOAMETHOD_(ElemparamP, FHIEndGroup2) (THIS_ MoaBoolParam xformsAsUnit) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICopyToClipboard) (THIS_ ElemparamP elemsToCopy) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetUngroupWarning) (THIS_ ElemparamP group, ConstPMoaChar warningText) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIGetTiledFillOutput) (THIS_ TiledFillOutputRec *tiledP, ElemparamP elemP, FillparamP fillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetSingleTileMtx) (THIS_ TiledFillOutputRec *tiledP, MoaLong row, MoaLong column, FHIMatrixRec *mtxP) PURE;

	STDMOAMETHOD_(FontparamP, FHIGetFontElement) (THIS_ GetFontRec* fontInfoP, MoaFixed pointSize) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetFontMetrics) (THIS_ FontparamP fontElemP, FontMetricsRec* fontMetricsP, MoaLong flags) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetFontNameFace) (THIS_ FontparamP fontElemP, MoaChar *familyName, MoaLong *face) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetTextWidth) (THIS_ FontparamP fontElemP, MoaChar *text, FhFxPoint *width, MoaLong buffer_len) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIFontIsSame) (THIS_ FontparamP font1, FontparamP font2, MoaBoolParam *theSame) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHITextElemInitTraverse) (THIS_ TextElemTravRec* textTravP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextElemBeginTraverse) (THIS_ TextElemTravRec* textTravP, ElemparamP textElem) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextElemGetNextCharGroup) (THIS_ TextElemTravRec* textTravP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextElemEndTraverse) (THIS_ TextElemTravRec* textTravP) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIElemIsClipGroup) (THIS_ ElemparamP theElement) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIElemSetClip) (THIS_ ElemparamP theGroup, MoaBoolParam clip) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIGenerateGroup) (THIS_ ElemparamP fhElem, ElemparamP *theGroup) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGenerateGroupFromFill) (THIS_
		ElemparamP theElem, FillparamP theFill, ElemparamP *theGroup) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIArrowPathForAll) (THIS_
		ElemparamP arrowElem, ElemparamP figureElem, MoaBoolParam atStart, PMoaVoid data,
		FHIMoveProc moveProc, FHILineProc lineProc, FHICurveProc curveProc,
		FHICloseProc closeProc, FHIFSArrowProc fillStrokeArrowProc) PURE;

	STDMOAMETHOD_(FillparamP, FHINewExtGradFill) (THIS_ ExtGradFillRec *gradInfo) PURE;
	STDMOAMETHOD_(FillparamP, FHINewExtRadialFill) (THIS_ ExtRadialFillRec *radialInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetExtGradFillRec) (THIS_ ExtGradFillRec *gradInfo, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetExtRadialFillRec) (THIS_ ExtRadialFillRec *radialInfo, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitExtGradFillRec) (THIS_ ExtGradFillRec *gradInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitExtRadialFillRec) (THIS_ ExtRadialFillRec *radialInfo) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIGetOutputOptions) (THIS_ DocparamP document, FHIOutputOptsRec *OutputOptsRecP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetOutputOptions) (THIS_ DocparamP document, FHIOutputOptsRec *OutputOptsRecP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPlaceDoc) (THIS_ DocparamP document, const SysFileSpec* file, MoaLong page, PFhFxPoint topLeft, PFhFxPoint bottomRight, MoaLong alignment) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISavePageAs) (THIS_ DocparamP document, DataTypeID saveDataType, const SysFileSpec* file, MoaLong page) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPrintNormally) (THIS_ DocparamP document, MoaBoolParam useDialog) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetPrintSettings) (THIS_ DocparamP document, FHIPrintOptsRec *printOpts) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIPrint) (THIS_ DocparamP document, FHIPrintOptsRec *printOpts) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRSelectAll) (THIS_ DocparamP document) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindProblems) (THIS_ DocparamP document, MoaLong theProblem, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFixProblems) (THIS_ DocparamP document, MoaLong thingToFix, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindName) (THIS_ DocparamP document, ConstPMoaChar pName, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindSelection) (THIS_ DocparamP document, MoaLong whichPart, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindObject) (THIS_ DocparamP document, ElemparamP theElementP, MoaLong whichPart, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindEffect) (THIS_ DocparamP document, MoaLong whichEffect, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindStyles) (THIS_ DocparamP document, MoaLong whichStyle, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindElemType) (THIS_ DocparamP document, MoaLong elemType, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindFillType) (THIS_ DocparamP document, MoaLong fillType, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindStrokeType) (THIS_ DocparamP document, MoaLong strokeType, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindFont) (THIS_ DocparamP document, ConstPMoaChar pFromFontName, MoaLong fromStyle, 
		MoaFixed minSize, MoaLong minOp, MoaFixed maxSize, MoaLong maxOp, 
		MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRChangeFont) (THIS_ DocparamP document, ConstPMoaChar pFromFontName, 
		ConstPMoaChar pToFontName, MoaLong fromStyle, MoaLong toStyle, MoaFixed minSize, MoaLong minOp, 
		MoaFixed maxSize, MoaLong maxOp, MoaFixed toSize, MoaLong toOp, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindComplex) (THIS_ DocparamP document, MoaLong minPts, MoaLong minOp, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindWidth) (THIS_ DocparamP document, MoaFixed minWidth, MoaLong minOp, MoaFixed maxWidth, MoaLong maxOp, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRChangeWidth) (THIS_ DocparamP document, MoaFixed minWidth, MoaLong minOp, MoaFixed maxWidth, MoaLong maxOp, MoaFixed newWidth, MoaLong newOp, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRFindColors) (THIS_ DocparamP document, ColorparamP oldColorP, MoaLong colormode, MoaBoolParam dorelated, MoaLong findscope, MoaLong findop) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRChangeColors) (THIS_ DocparamP document, ColorparamP oldColorP, ColorparamP newColorP, MoaLong colormode, MoaBoolParam dorelated, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRReblendObject) (THIS_ DocparamP document, MoaLong newSteps, MoaLong blendMode, MoaLong minSteps, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRRotateObject) (THIS_ DocparamP document, MoaFixed angle, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRScaleObject) (THIS_ DocparamP document, MoaFixed scalex, MoaFixed scaley, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRSimplifyObject) (THIS_ DocparamP document, MoaFixed tolerance, MoaLong threshhold, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGSRReplaceObject) (THIS_ DocparamP document, ElemparamP oldObjectP, ElemparamP newObjectP, MoaLong changescope) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIDocumentReport) (THIS_ DocparamP document, SysFileSpec* file) PURE;
	STDMOAMETHOD_(DocparamP, FHIOpenDocumentSilently) (THIS_ const SysFileSpec* file, DataTypeID openDataType) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISaveDocumentAsSilently) (THIS_ DocparamP document, DataTypeID saveDataType, const SysFileSpec* file) PURE;

	STDMOAMETHOD_(ColorparamP, FHINewRGBColor) (THIS_
		MoaFixed r, MoaFixed g, MoaFixed b) PURE;
	STDMOAMETHOD_(ColorparamP, FHINewHexColor) (THIS_
		MoaFixed c, MoaFixed m, MoaFixed y, MoaFixed k,
		MoaFixed o, MoaFixed g) PURE;
	STDMOAMETHOD_(MoaUlong, FHIGetColorType) (THIS_
		ColorparamP colorP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorGetRGB) (THIS_
		ColorparamP colorP, MoaFixed *pR, MoaFixed *pG, MoaFixed *pB) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIColorGetHex) (THIS_
		ColorparamP colorP, MoaFixed *pC, MoaFixed *pM, MoaFixed *pY, MoaFixed *pK,
		MoaFixed *pOrange, MoaFixed *pG) PURE;

	STDMOAMETHOD_(MoaError, FHITextCharOutlinePathForAll) (THIS_
		ConstPMoaChar familyName, MoaCharParam face, MoaFixed pointSize, MoaCharParam charCode, void *dataPtr,
		FHIMoveProc moveProc, FHILineProc lineProc, FHICurveProc curveProc, FHICloseProc closeProc) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHISetCustomDocData) (THIS_
		DocparamP docP, ConstPMoaChar pCustDataName, MoaUlong dataSize,
		PMoaVoid pDataIn) PURE;
	STDMOAMETHOD_(MoaUlong, FHIGetCustomDocDataLength) (THIS_
		DocparamP docP, ConstPMoaChar pCustDataName) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetCustomDocData) (THIS_
		DocparamP docP, ConstPMoaChar pCustDataName, MoaUlong bytesToRead, 
		PMoaVoid pDataOut) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHITextSetURL) (THIS_
		ElemparamP elemP, MoaLong position, MoaLong numChars, ConstPMoaChar pUrlIn) PURE;
	STDMOAMETHOD_(MoaUlong, FHITextGetURLLength) (THIS_
		ElemparamP elemP, MoaLong position, MoaLong *pNumCharsInRun) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHITextGetURL) (THIS_
		ElemparamP elemP, MoaLong position, PMoaChar pUrlOut) PURE;

	STDMOAMETHOD_(MoaBoolParam, FHIGetDocInfoFromDocparamP) (THIS_ DocparamP docP, 
		SysFileSpec* fileInfo, DocInfoRec* infoP) PURE;
};
typedef IMoaFh60Callback FAR *PIMoaFh60Callback;

// IID_IMoaFh60Callback: 4F3E09602A3611CF80C400AA00B84356
MOA_DEFINE_GUID(IID_IMoaFh60Callback, 0x4f3e0960L, 0x2A36, 0x11CF, 0x80, 0xC4, 0x00, 0xAA, 0x00, 0xB8, 0x43, 0x56);


// new FH8-specific callbacks interface
#undef INTERFACE
#define INTERFACE IMoaFh80Callback

DECLARE_MOA_INTERFACE_(IMoaFh80Callback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	
	STDMOAMETHOD_(void, FHICoolGrayOutRect) (THIS_ CPPort port, CPRect *rectP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHI80ArrowPathForAll) (THIS_
		ElemparamP arrowElem, ElemparamP figureElem, MoaBoolParam atStart, PMoaVoid data,
		FHIMoveProc moveProc, FHILineProc lineProc, FHICurveProc curveProc, FHICloseProc closeProc,
		FHICapJoinProc pCapJoinArrowProc, FHIFillStrokeProc pFillStrokeProc) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMtxOverflow) (THIS) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHINewBlendGetMatrix)
		(THIS_ ElemparamP blendElem, ElemparamP childElem, FHIMatrixRec* mtxP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHISetViewRect) (THIS_ FhFxPoint *lo, FhFxPoint *hi) PURE;
	STDMOAMETHOD_(MoaLong, FHIGetArcPoints)
		(THIS_ FhRect *pRect, MoaFixed iStartAngle, MoaFixed iArcAngle,
			MutPathTriple *pPointList, MoaLong iArcFlags) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewArcPath)
		(THIS_ FhRect *pRect, MoaFixed iStartAngle, MoaFixed iArcAngle, MoaLong iArcFlags) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICreateRunAround)
		(THIS_ ElemparamP pElem, FhRect *pStandoff) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIDoCommandsInReadersAndWriters) (THIS) PURE;
	STDMOAMETHOD_(ArrowparamP, FHINewArrowPathElem) (THIS_ MoaLong iNumPoints,
		MoaBool bFilled, MoaBool bStroked, CapT iCapCode, JoinT iJoinCode, MoaFixed iMiterLimit) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIArrowGetSetParms) (THIS_ ArrowparamP pArrow,
		CapT iCapCode, JoinT iJoinCode, MoaFixed iMiterLimit, MoaLong iArrowFlags, MoaBool bGet) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHICopyPathToArrow) (THIS_ ElemparamP pElem, ArrowparamP pArrow) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIInitializeHexColor) (THIS_ ColorparamP pColorElem,
		MoaFixed c, MoaFixed m, MoaFixed y, MoaFixed k, MoaFixed o, MoaFixed g) PURE;
	STDMOAMETHOD_(MoaError, FHINewLensFill) (THIS_
		FHILensXformID iFHILensID, ColorparamP pLensColor, MoaFixed iPercentOrScale, 
		MoaBoolParam bCalcCenter, ConstPMPoint pCenterPoint, MoaLong iFHILensFlags, 
		FillparamP *pFill) PURE;
	STDMOAMETHOD_(MoaError, FHIGetLensFillInfo) (THIS_
		FillparamP pFill, FHILensXformID *iFHILensID, ColorparamP *pLensColor,
		MoaFixed *iPercentOrScale, FhFxPoint *pCenterPoint, MoaLong *iFHILensFlags) PURE;
	STDMOAMETHOD_(MoaError, FHISetLensFillInfo) (THIS_
		FillparamP pFill, FHILensXformID iFHILensID, ColorparamP pLensColor,
		MoaFixed iPercentOrScale, MoaBoolParam bCalcCenter, ConstPMPoint pCenterPoint, 
		MoaLong iFHILensFlags) PURE;
	STDMOAMETHOD_(MoaError, FHIWriteTiffFromProc) (THIS_
		PIMoaStream pStream, MoaImageInfoRec *pImageInfo,
		MoaByte *pRedTable, MoaByte *pGreenTable, MoaByte *pBlueTable,
		FHICreateTiffWriteRowProc pWriteRowProc, PMoaVoid pParam) PURE;
	STDMOAMETHOD_(MoaError, FHIStreamWriteTiffFromProc) (THIS_
		StreamID pStream, MoaImageInfoRec *pImageInfo,
		MoaByte *pRedTable, MoaByte *pGreenTable, MoaByte *pBlueTable,
		FHIStreamCreateTiffWriteRowProc pWriteRowProc, PMoaVoid pParam) PURE;
	STDMOAMETHOD_(MoaError, FHIStreamGetFileSpec) (THIS_ StreamID pStream, SysFileSpec *pFS) PURE;
	STDMOAMETHOD_(StreamID, FHINewFileStreamID) (THIS_
		SysFileSpec *pFS, MoaBoolParam bCreateFile) PURE;
	STDMOAMETHOD_(StreamID, FHINewMoaFileStreamID) (THIS_ PIMoaStream pStream) PURE;
	STDMOAMETHOD_(MoaError, FHIStreamOpen) (THIS_
		StreamID pStream, FHIStreamAccessParam iAccess) PURE;
	STDMOAMETHOD_(MoaError, FHIStreamClose) (THIS_ StreamID pStream, MoaBoolParam bDeleteFile) PURE;
	STDMOAMETHOD_(MoaError, FHIStreamFlush) (THIS_ StreamID pStream) PURE;
	STDMOAMETHOD_(MoaBoolParam, UIHasCustomTabGadgets) (THIS) PURE;
	STDMOAMETHOD_(ElemparamP, FHINewBlendOnAPath) (THIS_ ElemparamP pBlendElem, ElemparamP pPathElem) PURE;
	STDMOAMETHOD_(ListparamP, FHINewList) (THIS) PURE;
	STDMOAMETHOD_(MoaError, FHIListInsert)
		(THIS_ ListparamP pList, MoaLong index, ElemparamP pElem) PURE;
	STDMOAMETHOD_(MoaError, FHIListInsertFirst) (THIS_ ListparamP pList, ElemparamP pElem) PURE;
	STDMOAMETHOD_(MoaError, FHIListInsertLast) (THIS_ ListparamP pList, ElemparamP pElem) PURE;
	STDMOAMETHOD_(ElemparamP, FHIListGetNthItem) (THIS_ ListparamP pList, MoaLong iIndex) PURE;
	STDMOAMETHOD_(MoaError, FHIListSetNthItem)
		(THIS_ ListparamP pList, MoaLong index, ElemparamP pElem) PURE;
	STDMOAMETHOD_(MoaError, FHIListDelNthItem) (THIS_ ListparamP pList, MoaLong index) PURE;
	STDMOAMETHOD_(MoaError, FHIListDelAll) (THIS_ ListparamP pList) PURE;
	STDMOAMETHOD_(MoaError, FHIListDelItem) (THIS_ ListparamP pList, ElemparamP pElem) PURE;
	STDMOAMETHOD_(MoaLong, FHIListFindItem) (THIS_ ListparamP pList, ElemparamP pElem) PURE;
	STDMOAMETHOD_(MoaError, FHIListReplaceItem)
		(THIS_ ListparamP pList, ElemparamP pElem, ElemparamP pReplaceElem) PURE;
	STDMOAMETHOD_(DocparamP, FHIOpenMinimalDocument) (THIS_ const SysFileSpec* file) PURE;
	STDMOAMETHOD_(DocparamP, FHISetReferenceDocument) (THIS_ DocparamP document) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetDirectory) 
		(THIS_ FHI_DIRECTORY_ID idDir, SysFileSpec* file) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIFileExists) (THIS_ const SysFileSpec* file) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIEnumFiles)
		(THIS_ const SysFileSpec* file, FHIEnumFilesProc pEnumProc, PMoaVoid pParam) PURE;
	STDMOAMETHOD_(MoaError, FHIDbcsTextInitCharAttrsExt) (THIS_ FHIDbcsCharAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaError, FHIDbcsTextInitParaAttrsExt) (THIS_ FHIDbcsParaAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaError, FHIDbcsTextGetCharAttrsExt) 
		(THIS_ ElemparamP elem, MoaLong position, FHIDbcsCharAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaError, FHIDbcsTextGetParaAttrsExt) 
		(THIS_ ElemparamP elem, MoaLong position, FHIDbcsParaAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaError, FHIDbcsTextSetCharAttrsExt) 
		(THIS_ ElemparamP elem, MoaLong position, MoaLong numChars, FHIDbcsCharAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaError, FHIDbcsTextSetParaAttrsExt) 
		(THIS_ ElemparamP elem, MoaLong position, MoaLong numChars, FHIDbcsParaAttrsRec* attrsP) PURE;
	STDMOAMETHOD_(MoaError, FHIGetRulerOrigin) 
		(THIS_ DocparamP pDocument, MoaLong iPageNo, FhFxPoint *pCurrentOrigin) PURE;
	STDMOAMETHOD_(MoaError, FHISetRulerOrigin) 
		(THIS_ DocparamP pDocument, MoaLong iPageNo, FhFxPoint aCurrentOrigin,
			MoaBoolParam bCreateCmdIfNeeded) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIUpdateElem) (THIS_ ElemparamP elem) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIInvalElemBBox) (THIS_ ElemparamP elem) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetCropInfo) (THIS_ ElemparamP pElem, FHICropInfoRec* pInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHINewGetMatrix) 
		(
		THIS_ 
		ElemparamP theElemP,
		FHIMatrixRec *fhMtxP,
		MoaBoolParam ignoreParent,
		MoaBoolParam includeOwn
		) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIExportAsSilently)
		(THIS_ DocparamP document, DataTypeID saveDataType, const SysFileSpec* file) PURE;
	STDMOAMETHOD_(void, FHIUpdateDuringCommand)(THIS) PURE;
};
typedef IMoaFh80Callback FAR *PIMoaFh80Callback;

// IID_IMoaFh80Callback: 17EACD80E246011D09576000502e8b86f
MOA_DEFINE_GUID(IID_IMoaFh80Callback, 0x17EACD80L, 0xE246, 0x11D0, 0x95, 0x76, 0x00, 0x05, 0x02, 0xE8, 0xB8, 0x6F);


#ifdef MACINTOSH
// new FH8-specific callbacks interface
#undef INTERFACE
#define INTERFACE IMoaFh80MacCallback

DECLARE_MOA_INTERFACE_(IMoaFh80MacCallback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS
	
	STDMOAMETHOD_(MoaBoolParam, FHIMacGetCurrentEvent) (THIS_ EventRecord *pEvent) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMacGetNextMenuCommand) (THIS_ MMenuNdxRec *pMenuCmd) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIMacGetCommandDescription) (THIS_ MoaLong iMenuCmd, PMoaChar pDescription) PURE;
};
typedef IMoaFh80MacCallback FAR *PIMoaFh80MacCallback;

// IID_IMoaFh80MacCallback: 7F997D64LE24611D083B1000502E8B86F
MOA_DEFINE_GUID(IID_IMoaFh80MacCallback, 0x7F997D64L, 0xE246, 0x11D0, 0x83, 0xB1, 0x00, 0x05, 0x02, 0xE8, 0xB8, 0x6F);
#endif	// #ifdef MACINTOSH

// new FH8-specific callbacks interface
#undef INTERFACE
#define INTERFACE IMoaFh81Callback

DECLARE_INTERFACE_(IMoaFh81Callback, IMoaUnknown)
{
	STD_IUNKNOWN_METHODS
	
	STDMETHOD_(MoaBoolParam, FHIGetSetLayerName) (THIS_ MoaLong index, PMoaChar buffer, MoaLong bufLen,
		MoaBoolParam bGet, MoaBoolParam bIsAscii) PURE;
	STDMETHOD_(MoaBoolParam, FHIDeleteLayer) (THIS_ MoaLong index) PURE;
	STDMETHOD_(MoaBoolParam, FHIGetSetStyleName) (THIS_ MoaLong index, PMoaChar buffer, MoaLong bufLen,
		MoaBoolParam bGet, MoaBoolParam bIsAscii) PURE;
	STDMETHOD_(MoaBoolParam, FHIDeleteStyle) (THIS_ MoaLong index) PURE;
	STDMETHOD_(MoaLong, FHIStyleCount) (THIS) PURE;
	STDMETHOD_(MoaLong, FHISetColorName) (THIS_ ColorparamP pColor, PMoaChar pStr, MoaBool bIsAscii) PURE;
};
typedef IMoaFh81Callback FAR *PIMoaFh81Callback;

// IID_IMoaFh81Callback: 0x968B8F48A44D11D1A0D6000502E8B86F
DEFINE_GUID(IID_IMoaFh81Callback, 0x968B8F48L, 0xA44D, 0x11D1, 0xA0, 0xD6, 0x00, 0x05, 0x02, 0xE8, 0xB8, 0x6F);

// version info callback added for FH8J, FH9 and greater. If this interface is not
// present, you are running in single byte FH8, FH7, or earlier.
#undef INTERFACE
#define INTERFACE IMoaFhVersionInfo

DECLARE_INTERFACE_(IMoaFhVersionInfo, IMoaUnknown)
{
	STDMETHOD_(MoaError, FHIAppVersion) 
		(THIS_ MoaLong* pnMajorVersion, 
			   MoaLong* pnMinorVersion, 
			   MoaLong* pnBugVersion) PURE;
	STDMETHOD_(MoaError, FHIOSVersion) 
		(THIS_ PMoaChar pszOSName, 
			   MoaLong* pnMajorVersion,
			   MoaLong* pnMinorVersion,
			   MoaLong* pnBuildNumber,
			   MoaLong* pnPlatform,
			   MoaLong* pnSubPlatform) PURE;
	STDMETHOD_(MoaError, FHIAppLanguage) 
		(THIS_ PMoaChar pszLanguage, 
			   MoaLong* pnLanguage) PURE;
	STDMETHOD_(MoaError, FHIIsDoubleByte) 
		(THIS_ MoaBoolParam* pbIsDoubleByte) PURE;
	STDMETHOD_(MoaError, FHISerialNumber) 
		(THIS_ PMoaChar pszSerialNumber, 
			   MoaLong* pnType, 
			   MoaLong* pnUsers) PURE;
	STDMETHOD_(MoaError, FHIUserName) 
		(THIS_ PMoaChar pszUserName) PURE;
	STDMETHOD_(MoaError, FHICompanyName) 
		(THIS_ PMoaChar pszCompanyName) PURE;
};
typedef IMoaFhVersionInfo FAR *PIMoaFhVersionInfo;

// IID_IMoaFhVersionInfo: A65EFBC0-AA3F-11D1-8599-00A0C9696CB6
MOA_DEFINE_GUID(IID_IMoaFhVersionInfo, 0xA65EFBC0L, 0xAA3F, 0x11D1, 0x85, 0x99, 0x00, 0xA0, 0xC9, 0x69, 0x6C, 0xB6);

#undef INTERFACE
#define INTERFACE IMoaFh90Callback

DECLARE_MOA_INTERFACE_(IMoaFh90Callback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMETHOD_(ElemparamP, FHIEnvAddPoints)(ElemparamP pEnvelope) PURE;
	STDMETHOD(FHIEnvGetElem)(THIS_ ElemparamP pEnvelope, ElemparamP * pElem) PURE;
	STDMETHOD(FHIEnvGetOrigElem)(ElemparamP pEnvelope, ElemparamP * pElem) PURE;
	STDMETHOD(FHIEnvSetOrigElem)(ElemparamP pEnvelope, ElemparamP pElem) PURE;
	STDMETHOD(FHIEnvCreate)(ElemparamP pPath, ElemparamP * pEnvelope) PURE;
	STDMETHOD(FHIEnvRegenerate)(ElemparamP pEnvelope) PURE;

	STDMETHOD_(MoaBoolParam, FHIBeginElemTraversalEx) (THIS_ MoaUlong options) PURE;

	STDMETHOD(FHIGetArrowHeads)(ElemparamP figElem, ElemparamP * pArrow1, ElemparamP * pArrow2) PURE;
	STDMETHOD(FHIGetArrowMatrix)(ElemparamP arrowElem, ElemparamP figElem, MoaBoolParam firstArrow, FHIMatrixRec* mtxP) PURE;
	STDMETHOD(FHIArrowElemParms)(ElemparamP arrowElem, CapT * pCap, JoinT * pJoin, MoaFixed* pMiterLimit, MoaLong* pFlags) PURE;

	STDMETHOD(FHIGetFontFile)(THIS_ FontparamP theFont, SysFileSpec *pFileSpec, long *sfntID) PURE;
	STDMETHOD(FHIAutoTrace)(ElemparamP elemP, ElemparamP * pGroup) PURE;
	STDMETHOD(FHIGetSymbolElement)(THIS_ ElemparamP pInstance, ElemparamP * pElem) PURE;
	STDMETHOD(FHISymbolCacheElement)(THIS_ ElemparamP pInstance, ElemparamP pElem) PURE;

	// Lens support.
	STDMETHOD(FHIPushTransform)(THIS_ FillparamP pLensFill, ElemparamP pFigure) PURE;
	STDMETHOD(FHITransformedContents)(THIS_ FillparamP pLensFill, ElemparamP pFigure, ElemparamP * pContents) PURE;
	STDMETHOD(FHIPopTransform)(THIS) PURE;
	STDMETHOD(FHILensGetDrawColor)(THIS_ MoaFixed *pR, MoaFixed *pG, MoaFixed *pB) PURE;
	STDMETHOD(FHINewSetPageInfo)(THIS_ MoaLong lIndex, const PageInfoRec* pInfoP, MoaBoolParam bWithElements, FHIMatrixRec* mtxP) PURE;

	STDMETHOD(FHIGetImportedImageLocation)(THIS_ ElemparamP pImportImage, PMoaChar pLocationPtr, MoaLong locationSize) PURE;
	STDMETHOD(FHIClearLensCache)(THIS) PURE;
	STDMETHOD(FHIMakeSafeTillExit)(THIS_ ElemparamP pElemToMakeSafe) PURE;
};
typedef IMoaFh90Callback FAR *PIMoaFh90Callback;

// IID_IMoaFh90Callback: A65EFBC0-AA3F-11D2-8599-00A0C9696CB6
MOA_DEFINE_GUID(IID_IMoaFh90Callback, 0xA65EFBC0L, 0xAA3F, 0x11D2, 0x85, 0x99, 0x00, 0xA0, 0xC9, 0x69, 0x6C, 0xB6);

// New callbacks added for FreeHand 10
#undef INTERFACE
#define INTERFACE IMoaFh10Callback

DECLARE_MOA_INTERFACE_(IMoaFh10Callback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMETHOD(FHIGetTempBaseName)(THIS_ PMoaChar pTmpName) PURE;
	STDMETHOD(FHIClearIPTC)(THIS_ MoaLong record, MoaLong dataset) PURE;
	STDMETHOD(FHICountIPTC)(THIS_ MoaLong record, MoaLong dataset, MoaLong *itemcount) PURE;
	STDMETHOD(FHIGetIPTC)(THIS_ MoaLong record, MoaLong dataset, MoaLong itemindex, MoaChar *buffer, MoaLong maxbytes, MoaLong *actualbytes) PURE;
	STDMETHOD(FHIPutIPTC)(THIS_ MoaLong record, MoaLong dataset, MoaLong itemindex, MoaChar *buffer, MoaLong numbytes) PURE;
	STDMETHOD(FHIDoesElementHasBrush)(THIS_ ElemparamP pElement, MoaBool* pHasBrush) PURE;
	STDMETHOD(FHIGenerateReleasedBrushForElement)(THIS_ ElemparamP pElement, ElemparamP * pReleasedBrush) PURE;
	STDMETHOD(FHIWindowMenuAdvanced)(THIS_ GadgetID windowGadget, MoaBoolParam add, MoaBoolParam isVisible, FHMenuPath *menuPath) PURE;
		
	STDMOAMETHOD_(FillparamP, FHINewContourFill) (THIS_ ContourFillRec *contourInfo) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIGetContourFillRec) (THIS_ ContourFillRec *contourInfo, FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIinitContourFillRec) (THIS_ ContourFillRec *contourInfo) PURE;

};
typedef IMoaFh10Callback FAR *PIMoaFh10Callback;

// IID_IMoaFh10Callback: E663341B-79EA-11d4-811C-00C04F6045BA
MOA_DEFINE_GUID(IID_IMoaFh10Callback, 0xE663341BL, 0x79EA, 0x11D4, 0x81, 0x1C, 0x00, 0xC0, 0x4F, 0x60, 0x45, 0xBA);

// some error codes for FHITextCharOutlinePathForAll
#define kFHErr_FontHasNoOutlines	MAKE_MOAERR(0xdea0)
#define kFHErr_CharHasNoOutline		MAKE_MOAERR(0xdea1)

// New callbacks added for FreeHand 11
#undef INTERFACE
#define INTERFACE IMoaFh11Callback

DECLARE_MOA_INTERFACE_(IMoaFh11Callback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMETHOD(FHIGetFlashInfo)(THIS_ FlashOutputInfo *pFlashInfo, ColorparamP * pBgColorP) PURE;
	STDMETHOD(FHISetFlashInfo)(THIS_ FlashOutputInfo *pFlashInfo, ColorparamP bgColorP) PURE;
	STDMETHOD(FHIGetExportFlags)(THIS_ MoaLong *flags) PURE;
	STDMETHOD(FHIMessageOnce)(THIS_ MoaLong lTitleID, MoaLong lMessageID) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIIsFH10Fill)(THIS_ FillparamP theFillP) PURE;
	STDMOAMETHOD_(MoaBoolParam, FHIIsCompatableFill)(THIS_ FillparamP theFillP, ElemparamP pElement) PURE;
	STDMOAMETHOD_(FillparamP, FHIGenerateCompatableFill)(THIS_ FillparamP theFillP, ElemparamP pElement) PURE;
	STDMOAMETHOD_(ElemparamP, FHIGetClipPathInfo)(THIS_ ElemparamP pElement) PURE;
	STDMOAMETHOD(FHIGetExtrusionGroup)(THIS_ ElemparamP pElement, ElemparamP * pGroup) PURE;
	STDMOAMETHOD(FHIFlattenComplexStrokes)(THIS_ ElemparamP pElement, ElemparamP* pGroup) PURE;
	STDMETHOD(FHIDoesElementHaveComplexStroke)(THIS_ ElemparamP pElement, MoaBool* pHasComplexStroke) PURE;
	STDMETHOD(FHIGetImportDataSize)(THIS_ ElemparamP pElement, PMoaUlong pSize) PURE;
	STDMETHOD(FHIGetImportData)(THIS_ ElemparamP pElement, PMoaVoid pData) PURE;
	STDMETHOD(FHIGetProcedureCount)(THIS_ ElemparamP pElement, PMoaLong pCount) PURE;
 	STDMETHOD(FHIGetProcedureAt)(THIS_ ElemparamP pElement, MoaLong lCount, ProcedureParamP* pProcedure, FHIProcedureType* pType) PURE;
 	STDMETHOD(FHIReplaceProcedureAt)(THIS_ ElemparamP pElement, MoaLong lCount, ProcedureParamP pProcedure) PURE;
 	STDMETHOD(FHIInsertProcedureAt)(THIS_ ElemparamP pElement, MoaLong lCount, ProcedureParamP pProcedure) PURE;
	STDMETHOD(FHIClearAllProcedures)(THIS_ ElemparamP pElement) PURE;
	STDMETHOD(FHIExpandGraphicStyle)(THIS_ ElemparamP pElement, MoaLong lFlags, ElemparamP* pResult) PURE;
	STDMETHOD(FHIImageDisplaysAlphaChannel)(THIS_ ElemparamP pElement, MoaBool* pDisplaysAlpha) PURE;
	STDMETHOD(FHILockPremultipliedRGBARowData) (THIS_ ElemparamP pElement, MoaLong rowIndex, MoaByte** ppData) PURE;
	STDMETHOD(FHIUnlockPremultipliedRGBARowData) (THIS_ ElemparamP pElement, MoaLong rowIndex, MoaByte* pData) PURE;
	STDMETHOD(FHIShowNavigationPanel) (THIS) PURE;
	STDMETHOD(FHICmdExchangeConnectorLine) (THIS_ ElemparamP pOldElem, ElemparamP pNewElem) PURE;
	STDMETHOD(FHICopyConnectorLine) (THIS_ ElemparamP pFromElem, ElemparamP pToElem) PURE;
	STDMETHOD(FHIDeleteConnectorLine) (THIS_ ElemparamP pElem, MoaBool bConvertToPath) PURE;
	STDMETHOD(FHISetEndOfFile) (THIS_ StreamID streamID) PURE;
	STDMETHOD(FHIAddElementToSafetyAttachList) (THIS_ ElemparamP pElem) PURE;
	STDMETHOD(FHIMoveLayer) (THIS_ MoaLong lOldIndex, MoaLong lNewIndex) PURE;
	STDMETHOD(FHITranslateInline) (THIS_ ElemparamP elem, ConstPMPoint offset) PURE;
	STDMETHOD(FHITextPutCharsInline) (THIS_ ElemparamP elemP, MoaLong position, MoaLong numToReplace, ConstPMoaChar buffer, MoaLong numChars) PURE;
};
typedef IMoaFh11Callback FAR *PIMoaFh11Callback;

// IID_IMoaFh11Callback: 0661D9DB-BEDE-4701-B6F9-E78000CCA866
MOA_DEFINE_GUID(IID_IMoaFh11Callback, 0x0661D9DBL, 0xBEDE, 0x4701, 0xB6, 0xF9, 0xE7, 0x80, 0x00, 0xCC, 0xA8, 0x66);

#endif	/* _H_fhxif */
