#ifndef _H_moaxtra
#define _H_moaxtra

/*
	File: moaxtra.h (adaptive)

	Copyright (c) 1994, 1995, 1996 Macromedia, Inc.  All Rights Reserved
	
	You may utilize this source file to create and compile object code for use within products 
	you may create.  THIS CODE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, AND 
	MACROMEDIA DISCLAIMS ALL IMPLIED WARRANTIES INCLUDING, BUT NOT LIMITED TO, MERCHANTABILITY, 
	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT WILL MACROMEDIA BE 
	LIABLE TO YOU FOR ANY CONSEQUENTIAL, INDIRECT OR INCIDENTAL DAMAGES ARISING OUT OF YOUR 
	USE OR INABILITY TO USE THIS CODE.

	Abstract:
	
	The public header file for the MOA Services library.
	
	It provides all functionality necessary to construct
	a standalone Xtra.
	
	Revision history:
	
		961204	Release 1.6:
			
			Removed IMoaClassFactoryCallback. 
			
			(srj)
			
	961204	Release 1.51:
			
			One more tweak to the tweaks for mixing C and C++ implementations. 
			
			(srj)

	961204	Release 1.50:
			
			Made some tweaks to better allow for mixing C and C++ implementations. 
			
			Also corrected implementation of X_RETURN.
			
			(srj)
			
	961022	Release 1.49:
			
			the a4saver class for 68k Macs under C++ was faulty; a4 would never get set
			up correctly if:
			-- you compiled for 68k Mac
			-- you compiled under C++
			-- you used X_ENTER (or macros that use it, like moa_try)

			this is now fixed. (srj)

	960627	Release 1.47:

			if IGNORE_STD_GUID is defined, we make DEFINE_STD_GUID the same as MOA_DEFINE_GUID.

			removed the "#define IClassFactory IMoaClassFactory" section to improve
			compatibility with MS headers. (srj)

			simplified all the two-step macros for MPW C (which couldn't handle that
			much macro space, alas).
			
			remove all usage of IN_X_CODE in favor of !MOA_APP_CODE.
			
			generally restructured the macros and symbols for A4-handling for 68k Macs.
			
			changed the type of "magicCookie" from PMoaVoid to a custom type.

			(srj)

	960606	Release 1.46:

			removed the "#define IUnknown IMoaUnknown" section to improve
			compatibility with MS headers. (srj)

	960207	Release 1.43:
			
			Modified all the macros to use two-step macros for token pasting;
			this allows preprocessor definitions to be used for all
			class/interface names.
			
			Modified the definitions of MOA_DEFINE_GUID and VTABLE generating
			macros to place the data into a specific far data segment under Win16;
			this makes it easy to identify all the constant data generated
			by MOA and specify it in a .def file. NOTE: You must compile with the
			SMALLER_VTABLE switch to get vtables placed here. The MOA library files
			do this by default, but app code doesn't.

			Rearranged some macros to allow for easier mixing of C++ and C
			classes within the same Xtra. NOTE: if you do this, the BEGIN_XTRA
			block needs to be in a C file (not C++).
			
			(srj)
			
	960118	Release 1.42: 
			
			Macintosh BEGIN_INTERFACE macro modified for Metrowerks 8 or later; they
			now provide the null entry at the start, so we don't need to. 

			Don't use pragma options align for THINK C. 

			(srj)

	951220	Release 1.41:
			
			Minor mods to compile with some early Windows headers: 
			-- cast all MoaError results to MoaError
			-- #undef IID_NULL to avoid conflict with ours

	951128	Release 1.39:
			
			changed internal macros to be compatible with PPCC and some variations
			of MSVC2.x.
			
			(srj)
			
	951026	Release 1.37:
			
			changed MessageBox prototypes to "const char *". (srj)
	
	951003	Release 1.34:
			
			Include stdio.h and stdarg.h earlier.
			
			Removed gXtraFSSpec (mac only); if we load the Code Fragment using
			GetMemFragment then there isn't a convenient way to get it, and
			besides, it's not very useful anyway. 
			
			Added #pragma export for the necessary exported Mac CFM functions
			(allowing you to skip the .exp file in Mwerks if you specify "use pragma").
			
			moved all error codes to moatypes.h.
			
			declare all vtables FAR to improve memory usage under Win16. 
			"unsafe" vtables are also declared const.
			
			revise defs so that defining SMALLER_VTABLE before including
			this file allows choice of the smaller (but less safe) vtable declaration.
			
			(srj)
	
	950918	Release 1.32:
	
			Switch back to the old technique of BEGIN_VTABLE.
	
			MOA_A4_GLOBALS usage of moa_SaveCodeMainAddr() needed a semicolon.
			
			WIN32 declaration of wvsprintfA needed some extra Windows stuff
			to avoid warnings.

			no longer use the symbol WIN16; now	infer Win 3.x vs. Win32 solely 
			based on the presence or absence of WIN32 being defined.			

			change all slash-slash comments to slash-star comments.

			(srj)
	
	950901	Release 1.3.1:

			Revised the BEGIN_VTABLE macros to allow for more
			efficient static initialization.
			
			Assume IN_X_CODE unless MOA_APP_CODE is defined.
			
			Try to infer MACINTOSH from compiler flags.
			
			Leave INTERFACE undefined at end of file.
			
			explicitly define _debugstr, etc. as FAR CDECL.
			make all args FAR as appropriate. use wvsprintf
			under Windows.
			
			The STD_CREATE_DESTROY macros should have declared
			This as a FAR pointer, but did not.
			
			changed InitBlock to CFragInitBlock.
			
			(srj)

	950809	Release 1.3:
			
			Many changes to allow for new caching scheme.
			
			(srj)
	
	950724	Release 1.2.1:
			
			removed warning from the STD_xxx_CREATE_DESTROY macros.
			
			added MoaFloat, MoaDouble, PMoaVoid, ConstPMoaVoid,
			MoaWide, and macros for MoaWide.
			
			Updated legal notice.
			
			(srj)

	950612	Release 1.2:
			
			Split from moaez.h to form moaxtra.h. 
			
			Provide final C++ support.
			
			(srj)
	
	950523	Release 1.1.7:
			
			revised to allow use of this file without including <windows.h>
			under Windows (for Altura users). Define _NO_MOA_WINDOWS_INCLUDE_
			before including this file to prevent windows.h from being
			included.
			
			Require either WIN16 or WIN32 to be defined now (don't assume one).
			
			(srj)
	
	950515	Release 1.1.6: 
			
			our function pointers all needed to be explicitly typed as to
			call type (some compiler setups may assume Pascal if not explicitly specified).
			If you need to declare your own callback functions for your interface, you
			should use the STDPROCPTR() macro (see the definition of MoaCreatedProc for
			an example).

			Removed the error for compiling C++ in Mwerks 68k because CW6 is now compatible
			with our scheme. Added explicit structure packing pragmas to all exposed
			structures; now we assume 68k on Mac and 2-byte on Windows. 
			
			Modified DEBUG_PREFACE code so that debug-specific routines live in the library 
			rather than the macros for the non-IN_X_CODE case, making it easier to swap debug 
			libraries in and out. 
			
			Respaced lines to allow opening in MSVC. (srj)

	950503	Release 1.1.5: Whoops! In the changes of 950405 below, interfaces with custom data
			didn't get the right amount of space allocated; thus, if you allocated
			an interface with extra storage, you would trash the heap when you
			used that data. This is all better now. This release also features
			an improved internal hashing scheme. (srj)
	950502	Release 1.1.4: add ability to not define the standard types; define
			the symbol NO_STD_GUID before including this file will cause all
			the "standard" guid's to be given external-only declarations. Added
			STD_IMOAUNKNOWN_METHODS macro. (srj)
	950419	Release 1.1.3: added MoaBeginXtraResources and MoaEndXtraResources. (srj)
	950414	Release 1.1.2: added more standard data types. Modified
			IMoaHandle again. Revised all API calls to be of
			form MOASTDAPI; this is important for Win32. (srj)
	950411	Release 1.1.1: modified IMoaHandle to final form. Improved
			efficiency of MoaEqualID. Correct IID_ICallback to be
			named IID_IMoaCallback. (srj)
	950405	Release 1.1: Changes to EasyShell macros to make C++ working easier.
			removed some harmless but annoying compiler warning issues. (srj)
	950404	Release 1.02: renamed IID_ICalloc, IID_IMoaClassFactoryCallback
			to IID_IMoaCalloc and IID_IMoaClassFactoryCallback. (srj)
	950403	Release 1.01: change to prototype of DllGetClassObject to avoid compiler
			warning in MSVC2.0. Added ResEdit-style comments for the standard GUID's. (srj)
	950330	Release 1.0 for MOA. (srj)
	950323	Release 1.2. (srj)
	950321	Release 1.1. (srj)
	950308	Release 1.0b1. (srj)
*/

#if defined(__cplusplus) && !defined(CINTERFACE)
	#ifndef CPLUS
		#define CPLUS
	#endif
#else
	#undef CPLUS
#endif

#if defined(_WINDOWS) && !defined(WINDOWS)
	#define WINDOWS 1
	#if defined(_WIN32) && !defined(WIN32)
		#define WIN32 1
	#endif
#endif

#if !defined(MACINTOSH) && (defined(powerc) || defined(applec))
	#define MACINTOSH 1
#endif

#if defined(WINDOWS) && !defined(WIN32)
	#define MOA_READONLY(macro_TYPE) macro_TYPE const __based(__segname("MOA_READONLY_DATA"))
#elif defined(MACINTOSH) && defined(applec)
	#define MOA_READONLY(macro_TYPE) const macro_TYPE
#else
	#define MOA_READONLY(macro_TYPE) macro_TYPE const FAR
#endif

/* ========================================================================== */
/* ================================= Includes =============================== */
/* ========================================================================== */

#ifdef MACINTOSH

#ifndef __CODEFRAGMENTS__
#include <CodeFragments.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef __STRINGS__
#include <Strings.h>
#endif

#ifndef __CFPLUGINCOM__
#include <CFPluginCOM.h>
#endif
#endif

#ifdef WINDOWS

	#ifndef _NO_MOA_WINDOWS_INCLUDE_
		#include <windows.h>
	#endif
	#define __COMPOBJ__
#endif

#include <stdarg.h>
#include <stdio.h>

/* Yes -- not CPLUS */
#ifdef __cplusplus
	#include <new.h>
#endif

#ifndef _H_moatypes
	/* this must be included _after_ windows.h */
	#include "moatypes.h"
#endif

/* ========================================================================== */
/* ============================ Fundamental Types =========================== */
/* ========================================================================== */

#ifdef WINDOWS //def __COMPOBJ__
	/* makes our identical to MS' to avoid type conflicts */
	typedef GUID MoaID;
#else
	/* these field types and names must EXACTLY match MS' */
	#ifdef MACINTOSH
	#pragma options align=mac68k
	#endif
	#ifdef WINDOWS
	#pragma pack(2)
	#endif
	typedef struct {
		MoaUlong	Data1;
		MoaUshort	Data2;
		MoaUshort	Data3;
		MoaByte		Data4[8];
	} MoaID;
	#ifdef MACINTOSH
	#pragma options align=reset
	#endif
	#ifdef WINDOWS
	#pragma pack()
	#endif
#endif
typedef const MoaID FAR * ConstPMoaID;

typedef MoaID MoaClassID;
typedef const MoaClassID FAR * ConstPMoaClassID;
typedef MoaID MoaInterfaceID;
typedef const MoaInterfaceID FAR * ConstPMoaInterfaceID;
typedef struct _MoaXtraMagicCookie FAR * MoaXtraMagicCookie;

/* MS COM compatibility types. */
#ifndef __COMPOBJ__
	#ifndef __CFPLUGINCOM__
		typedef MoaError HRESULT;
	#endif
#endif

/* ========================================================================== */
/* ======================== Adaptive Declarations =========================== */
/* ========================================================================== */

#define PTRCHECK

#ifdef MOA_A4_GLOBALS
	#undef MOA_A4_GLOBALS
#endif

/* ---------------------------------------------------------------- Macintosh */
#ifdef MACINTOSH

	/* this is a handy trick to make sure you #pragma your
		stuff correctly: we prototype this function with pointers_in_D0
		in effect, then re-prototype it in all the places you need
		the pragma. if you forget, you'll get a compile error
		about "pointers_in_D0_reminder redeclared". unfortunately,
		we can't fix this for you automatically (since you can't include
		#pragma's inside macros) but we can type check and make sure you
		don't make a mistake. */
	
	typedef struct _MoaFileRef * MoaFileRef;
	#define kMoaFileRef_NoRef NULL

	typedef long XtraResourceCookie;

	typedef FSSpec * PMoaSystemFileSpec;
	typedef const FSSpec * ConstPMoaSystemFileSpec;

	#define CODEMODEL_CFM

	#define CDECL

	#define STDAPIIMP_(macro_TYPE) 	MOASTDAPICALLTYPE macro_TYPE
	#define STDAPIIMP 				STDAPIIMP_(MoaError)

	#define STDPROCPTR(macro_CALLCONVENTION, macro_RETURNTYPE, macro_PROCNAME) \
		macro_CALLCONVENTION macro_RETURNTYPE (*macro_PROCNAME)

	#ifndef InterlockedIncrement
		#define InterlockedIncrement(plong) (++(*(plong)))
	#endif
	#ifndef InterlockedDecrement
		#define InterlockedDecrement(plong) (--(*(plong)))	
	#endif

#endif	/* MACINTOSH */

/* ------------------------------------------------------------------ Windows */ 
#ifdef WINDOWS
			 
	#define CODEMODEL_DLL

	#if !defined(_INC_WINDOWS) && !defined(_WINDOWS_)
		#ifdef WIN32

			#define PASCAL 	__stdcall
			#define CDECL
			typedef PMoaVoid HANDLE;

			extern int FAR PASCAL MessageBoxA(HANDLE, const char FAR *, const char FAR *, unsigned int);
			#define MessageBox MessageBoxA

			extern __declspec(dllimport) int __stdcall wvsprintfA(char FAR *, const char FAR *, va_list);
			#define wvsprintf wvsprintfA

			/* ??? Note: won't work for MIPS or ALPHA */
			extern __declspec(dllimport) long __stdcall InterlockedIncrement(long FAR *);
			extern __declspec(dllimport) long __stdcall InterlockedDecrement(long FAR *);

		#else

			#define PASCAL	_pascal
			#define CDECL 	_cdecl
			typedef unsigned int HANDLE;
			extern int FAR PASCAL MessageBox(HANDLE, const char FAR *, const char FAR *, unsigned int);
			extern int FAR PASCAL wvsprintf(char FAR *, const char FAR *, const void FAR *);
		#endif
		typedef HANDLE HINSTANCE;
		extern HANDLE FAR PASCAL GetActiveWindow(void);
		#define MB_OK 0x0000
	#endif

	typedef HINSTANCE MoaFileRef;
	#define kMoaFileRef_NoRef 0

	typedef HINSTANCE XtraResourceCookie;

	typedef char FAR * PMoaSystemFileSpec;
	typedef const char FAR * ConstPMoaSystemFileSpec;

	#ifndef NULL
		#define NULL 0
	#endif

	#define STDAPIIMP_(macro_TYPE) 	macro_TYPE MOASTDAPICALLTYPE
	#define STDAPIIMP 				STDAPIIMP_(MoaError)

	#define STDPROCPTR(macro_CALLCONVENTION, macro_RETURNTYPE, macro_PROCNAME) \
		macro_RETURNTYPE (macro_CALLCONVENTION FAR * macro_PROCNAME)

#endif	/* WINDOWS */

/* ========================================================================== */
/* =========================== Standard Glue Code =========================== */
/* ========================================================================== */

/*
	This macro is used to guarantee a unique name space. All global names
	are defined using this macro. Xtras should always use "Dll" for the
	name convention or they won't load correctly.
*/
#ifndef DLL
	#define DLL(name) Dll##name
#endif

#ifdef __cplusplus
	#define _EXTERN_C_ extern "C" 
#else
	#define _EXTERN_C_ extern
#endif

/*
	Every Xtra needs some custom glue code; external Xtras need other
	special bits of code as well. We put all this code in this header
	file (rather than in separate libraries) to simplify distribution,
	and also allow for easier customization. The first chunk, defined
	by the macro XCODE_PREFACE, defines code that is needed for
	external Xtras (e.g., main(), etc.). Not surprisingly, this code
	is defined conditionally by CODEMODEL.
*/
#ifdef CODEMODEL_CRM

	#pragma parameter __D0 _SetA4(__D0)
	long _SetA4(long) = 0xC18C;	/* EXG D0, A4 */
	long _GetA4(void) = 0x200C;	/* MOVE.L A4, D0 */

	#ifdef MOA_APP_CODE
		_EXTERN_C_ long moa_GetCustomA4(MoaXtraMagicCookie magicCookie);
		#define SET_CURRENT_A4(macro_COOKIE) 	_SetA4(moa_GetCustomA4(macro_COOKIE))
		#ifdef CPLUS
			#define GET_THIS_MAGICCOOKIE	this->pObj->magicCookie
		#else
			#define GET_THIS_MAGICCOOKIE	This->pObj->magicCookie
		#endif
		/*
			This macro is used when calling DllGetClassObject, etc. the deal is
			that a4 needs to be set correctly, but there's nary a magic cookie to
			get the "correct" value from. however, further consideration reveals that
			this isn't a problem: if the Dll entry point is really in an Xtra, then
			SetCurrentA4() is always correct. If the "Dll" entry point is in the
			same executable as the caller (i.e., the Moa library), then a4 will
			always already be correct!
		*/
		#define SET_CURRENT_A4_DLLENTRYPOINT	_GetA4()
	#else
		#define SET_CURRENT_A4(macro_COOKIE) 	SetCurrentA4()
		#define SET_CURRENT_A4_DLLENTRYPOINT	SetCurrentA4()
		#define GET_THIS_MAGICCOOKIE			/* nothing */
	#endif

		#define COMPILER_A4CODE_PREFACE 
		/* we use Metrowerk's implementation of SetCurrentA4. */

		#define MOA_SAVE_MAIN_CODE_ADDR(macro_MAIN) { macro_MAIN; }

	#define __EXPORT(name) if (_localstrcmp(funcName, #name) == 0) { result = name; break; }

	#define XCODE_PREFACE \
		 \
		MoaFileRef gXtraFileRef = kMoaFileRef_NoRef; \
		 \
		_EXTERN_C_ pascal void* main(char* funcName, void* mainAddr); \
		_EXTERN_C_ pascal MoaError Initialize(const Moa68kInitBlock FAR * pInitBlock); \
		_EXTERN_C_ pascal void Terminate(void);	 \
		static int _localstrcmp(const char* a, const char* b); \
		 \
		pascal void* main(char* funcName, void* mainAddr) \
		{ \
			void* result; \
		 \
			/* Think users may notice something funny going on here; \
				we actually pass the main address of the code resource \
				as an argument. This is because Think has no way \
				of getting this info itself; traditionally, Think users \
				would assume that they were called via JSR (A0) and \
				save A0. This is dangerous, though, as (for example) \
				FH5 sometimes calls the code with JSR (A3). To eliminate \
				the possibility of such ugliness, we just make it explicit. */ \
			MOA_SAVE_MAIN_CODE_ADDR(mainAddr); \
			{ \
				long oldA4 = SetCurrentA4(); \
			 \
				result = NULL; \
				do { \
					__EXPORT(Initialize); \
					__EXPORT(Terminate); \
					__EXPORT(DllGetClassObject); \
					__EXPORT(DllCanUnloadNow); \
					__EXPORT(DllGetInterface); \
					__EXPORT(DllGetClassForm); \
					__EXPORT(DllGetClassInfo); \
				} while(0); \
			 \
				SetA4(oldA4); \
			}\
		 \
			return result; \
		} \
		 \
		pascal MoaError Initialize(const Moa68kInitBlock* pInitBlock) \
		{ \
			long oldA4 = SetCurrentA4(); \
		 \
			gXtraFileRef = pInitBlock->fileRef; \
		 \
			SetA4(oldA4); \
		 \
			return kMoaErr_NoErr;	 \
		} \
		 \
		pascal void Terminate(void) { } \
		 \
		static int _localstrcmp(const char* a, const char* b) \
		{ \
			while (*a && *b && *a == *b) { \
				a++; \
				b++; \
			} \
			return *a - *b; \
		} \
 		\
 		COMPILER_A4CODE_PREFACE

#endif /* CODEMODEL_CRM */

#ifdef CODEMODEL_CFM

	#define XCODE_PREFACE \
		 \
		MoaFileRef gXtraFileRef = kMoaFileRef_NoRef; \
		 \
		_EXTERN_C_ void main(void); \
		_EXTERN_C_ pascal OSErr __initialize(const CFragInitBlock* pInitBlock); \
		_EXTERN_C_ pascal OSErr Initialize(const CFragInitBlock* pInitBlock); \
		_EXTERN_C_ pascal void __terminate(void); \
		_EXTERN_C_ pascal void Terminate(void); \
		_EXTERN_C_ void ppcSetFileRef(MoaFileRef fileRef); \
		 \
		void main(void) { } \
		pascal OSErr Initialize(const CFragInitBlock* pInitBlock) { return __initialize (pInitBlock); } \
		pascal void Terminate(void)	{ __terminate ();  } \
		void ppcSetFileRef(MoaFileRef fileRef) { gXtraFileRef = fileRef; }

	#define COMPILER_A4CODE_PREFACE

#endif

#ifdef CODEMODEL_DLL

	#ifndef WIN32

		#define XCODE_PREFACE \
			 \
			MoaFileRef gXtraFileRef = kMoaFileRef_NoRef; \
			 \
			_EXTERN_C_ int FAR PASCAL LibMain(HANDLE hInst, WORD wDataSeg, WORD wHeapSize, LPSTR cmd) \
			{ \
				gXtraFileRef = hInst; \
			 	return 1; \
			}

	#else

		#define XCODE_PREFACE \
			 \
			MoaFileRef gXtraFileRef = kMoaFileRef_NoRef; \
			 \
			 _EXTERN_C_ BOOL WINAPI DllMain(HINSTANCE hInst, DWORD reason, PMoaVoid reserved); \
			 \
			_EXTERN_C_ BOOL WINAPI DllMain(HINSTANCE hInst, DWORD reason, PMoaVoid reserved) \
			{ \
				gXtraFileRef = hInst; \
			 	return 1; \
			}

	#endif

	#define COMPILER_A4CODE_PREFACE

#endif

/* --------------------------------------------------------------------- Misc */
#ifdef MOA_A4_GLOBALS

	#ifdef __cplusplus
		class CMoaA4Saver {
			private:
				long oldA4;
			public:
				inline CMoaA4Saver(MoaXtraMagicCookie magicCookie) 
					{ 
						this->oldA4 = SET_CURRENT_A4(magicCookie); 
						magicCookie;
					}
				inline CMoaA4Saver(MoaLong a4) 
					{ 
						this->oldA4 = SetA4(a4); 
					}
				inline CMoaA4Saver() 
					{ 
						this->oldA4 = SET_CURRENT_A4_DLLENTRYPOINT; 
					}
				inline ~CMoaA4Saver() 
					{ 
						SetA4(this->oldA4); 
					}
		};

	#ifdef MOA_APP_CODE
		#define X_ENTER						{ PTRCHECK CMoaA4Saver __a4saver__(GET_THIS_MAGICCOOKIE);
	#else
		/* 961022 srj -- using the () constructor is NOT the same as using the empty constructor. */
		#define X_ENTER						{ PTRCHECK CMoaA4Saver __a4saver__;
	#endif
		#define X_ENTER_(macro_COOKIE)		{ PTRCHECK CMoaA4Saver __a4saver__(macro_COOKIE);
		#define X_ENTER_A4(macro_A4)		{ PTRCHECK CMoaA4Saver __a4saver__(macro_A4);
		#define X_ENTER_DLLENTRYPOINT		{ PTRCHECK CMoaA4Saver __a4saver__;
		#define X_ABORT						}
		#define X_EXIT						}
		#define X_RETURN(retType, retVal)	do { return(retVal); } while (0)
		#define X_RETURN_VOID				do { return; } while (0)
	#else
		#define X_ENTER						{ PTRCHECK long _oldA4_ = SET_CURRENT_A4(GET_THIS_MAGICCOOKIE);
		#define X_ENTER_(macro_COOKIE)		{ PTRCHECK long _oldA4_ = SET_CURRENT_A4(macro_COOKIE);
		#define X_ENTER_A4(macro_A4)		{ PTRCHECK long _oldA4_ = _SetA4(macro_A4);
		#define X_ENTER_DLLENTRYPOINT		{ PTRCHECK long _oldA4_ = SET_CURRENT_A4_DLLENTRYPOINT;
		#define X_ABORT						{ _SetA4(_oldA4_); }
		#define X_EXIT						_SetA4(_oldA4_); }
		/* this gyration is necessary for safety; the evaluation of (retVal) may
			require A4 to remain valid. */
		#define X_RETURN(retType, retVal)	do { retType _result_ = (retVal); _SetA4(_oldA4_); return _result_; } while (0)
		#define X_RETURN_VOID				do { _SetA4(_oldA4_); return; } while (0)
	#endif
#else
	#define X_ENTER						{ PTRCHECK
	#define X_ENTER_(macro_COOKIE)		{ PTRCHECK
	#define X_ENTER_A4(macro_A4)		{ PTRCHECK 
	#define X_ENTER_DLLENTRYPOINT		{ PTRCHECK
	#define X_ABORT						{ }
	#define X_EXIT						}
	#define X_RETURN(retType, retVal)	do { return(retVal); } while (0)
	#define X_RETURN_VOID				do { return; } while (0)
#endif
#define X_STD_RETURN(retVal)			X_RETURN(MoaError, retVal)


/* -------------------------------------------------------------------------- */
/*
	The next section of code, defined by the macro DEBUG_PREFACE, consists
	of code that's only used when the MOA_DEBUG macro is defined. Not surprisingly,
	this is only used for debugging.
	
	Note that the code actually is included in the library in all cases (not
	just in debug versions), to simplify swapping debug and nondebug versions.
	(The linker should normally strip it out of nondebug versions at final link.)
*/

#if !defined(MOA_APP_CODE)
	#define _DEBUG_NAMING_HACK(x)	_xcode##x
#else
	#define _DEBUG_NAMING_HACK(x)	_libcode##x
#endif

_EXTERN_C_ void FAR CDECL _DEBUG_NAMING_HACK(_debugstr)(const char FAR * msg, ...);
_EXTERN_C_ void FAR CDECL _DEBUG_NAMING_HACK(_clobbermem)(void FAR * p, long sz);
_EXTERN_C_ int FAR CDECL _DEBUG_NAMING_HACK(_isclobbered)(void FAR * p);

#define __FLUSH

#define CLOBBERVAL	0x50ff8001

#ifdef MACINTOSH
	#define _DEBUGSTR_(x)		{ Str255 _y_; CopyCStringToPascal(x,_y_); DebugStr(_y_); }
	#define _VSPRINTF_(x, y, z)	vsprintf((x),(y),(z))
#endif
#ifdef WINDOWS
	#define _DEBUGSTR_(x) 		OutputDebugString("MOA: "); OutputDebugString(x); OutputDebugString("\n");
	#define _VSPRINTF_(x, y, z)	wvsprintf((x),(y),(z))
#endif

#define DEBUG_PREFACE \
	 \
	void FAR CDECL _DEBUG_NAMING_HACK(_debugstr)(const char FAR * msg, ...) \
	{ \
		va_list args; \
		char buffer[256]; \
	 	 \
		va_start(args, msg); \
		_VSPRINTF_(buffer, msg, args); \
		va_end(args); \
		 \
		_DEBUGSTR_(buffer); \
		 \
	} \
	 \
	void FAR CDECL _DEBUG_NAMING_HACK(_clobbermem)(PMoaVoid p, long sz) \
	{ \
		long _c_; \
		long FAR * _p_; \
	 \
		MOA_ASSERT(!MOA_ISCLOBBERED(p), "Mem already clobbered"); \
		for (_c_ = (sz) / 4, _p_ = (long FAR *)(p) ; _c_; _c_--, _p_++) *_p_ = CLOBBERVAL; \
		__FLUSH; \
	} \
	 \
	int FAR CDECL _DEBUG_NAMING_HACK(_isclobbered)(PMoaVoid p) \
	{ \
		return(!p || (*(long FAR *)(p)) == CLOBBERVAL); \
	}

/*
	MPW C's preprocessor chokes on some of our macros,
	so we never define these in MPW C to minimize the
	choke factor.
*/

#if defined(MOA_DEBUG) /*&& !defined(applec) */

	#define MOA_DEBUGSTR(x)					\
		_DEBUG_NAMING_HACK(_debugstr) x
	#define MOA_CLOBBERMEM(p, sz)			\
		_DEBUG_NAMING_HACK(_clobbermem)((p), (sz))
	#define MOA_ISCLOBBERED(p)				\
		_DEBUG_NAMING_HACK(_isclobbered)(p)
	#define MOA_CLOBBERTEST(addr, msg) 		\
		do { if (MOA_ISCLOBBERED((PMoaVoid)(addr))) MOA_DEBUGSTR(("Clobbered in" msg)); } while (0);
	#define MOA_ASSERT(cond, msg)			\
		do { if (!(cond)) MOA_DEBUGSTR((msg)); } while (0);

#else

	#define MOA_DEBUGSTR(x)
	#define MOA_CLOBBERMEM(p, sz)
	#define MOA_ISCLOBBERED(p)
	#define MOA_CLOBBERTEST(addr, msg) 
	#define MOA_ASSERT(cond, msg)

#endif

/* -------------------------------------------------------------------------- */
/*
	The last section of code, defined by the macro STD_PREFACE, is used
	by all Xtras everywhere.
*/

#define MOAEQUALID_PREFACE \
	MOASTDAPI_(MoaLong) MoaEqualID(ConstPMoaID a, ConstPMoaID b) \
	{ \
		return( \
			a->Data1 == b->Data1 && \
			*(MoaLong*)(&a->Data2) == *(MoaLong*)(&b->Data2) && \
			*(MoaLong*)a->Data4 == *(MoaLong*)b->Data4 && \
			*(MoaLong*)(a->Data4+4) == *(MoaLong*)(b->Data4+4) \
		); \
	}

/* -------------------------------------------------------------------------- */
/*
	The final macro, XTRA_PREFACE, is the concatenation of all the other
	prefaces we need. This code will actually be generated by the
	BEGIN_XTRA macro.
*/
#if !defined(MOA_APP_CODE)
	#define XTRA_PREFACE XCODE_PREFACE MOAEQUALID_PREFACE DEBUG_PREFACE
#else
	#define XTRA_PREFACE
#endif

/* --------------------------------------------------------- Reality Checking */
#ifndef CODEMODEL_CFM
#ifndef CODEMODEL_CRM
#ifndef CODEMODEL_DLL
#ifndef CODEMODEL_NONE
#pragma error "you must define a code model"
#endif
#endif
#endif
#endif

/* ========================================================================== */
/* ============================== COM definitions =========================== */
/* ========================================================================== */

/*
	The definitions in this section are (by and large) redundant to
	COM. Thus we don't redefine them if compobj.h has already
	been included.
*/

#ifndef WINDOWS

	#ifdef __cplusplus
		#define MOAEXTERN_C	extern "C"
		#define EXTERN_C MOAEXTERN_C 
	#else
		#define MOAEXTERN_C	extern 
		#define EXTERN_C extern
	#endif
	
	#ifdef MACINTOSH
		#define MOASTDMETHODCALLTYPE		CDECL
		#define MOASTDAPICALLTYPE			pascal
		#define MOASTDAPI_(macro_TYPE)		MOAEXTERN_C MOASTDAPICALLTYPE macro_TYPE
		#define MOASTDAPI					MOASTDAPI_(MoaError)
#ifndef __CFPLUGINCOM__
		#define STDMETHODCALLTYPE			MOASTDMETHODCALLTYPE
#endif
		#define STDAPICALLTYPE				MOASTDAPICALLTYPE
		#define STDAPI_(macro_TYPE)			MOASTDAPI_(macro_TYPE)
		#define STDAPI						MOASTDAPI(MoaError)
		
		#define GUID						MoaID
	#endif	/* MACINTOSH */
	
	#define STDMOAMETHODIMP						PTRCHECK MoaError MOASTDMETHODCALLTYPE
	#define STDMOAMETHODIMP_(returnType)		PTRCHECK returnType MOASTDMETHODCALLTYPE
	#ifdef MACINTOSH
		#define STDMETHODIMP						STDMOAMETHODIMP
		#define STDMETHODIMP_(returnType)			STDMOAMETHODIMP_(returnType)
	#endif
	#define EXTERN_STDMETHODIMP					PTRCHECK MOAEXTERN_C MoaError MOASTDMETHODCALLTYPE
	#define EXTERN_STDMETHODIMP_(returnType)	PTRCHECK MOAEXTERN_C returnType MOASTDMETHODCALLTYPE
	
	/*
		Macros for declaring an interface. These are cunningly designed
		so that when expanded, they form a correct definition of the
		structures and such for either C or C++ (depending on the 
		compiler used to process this file) (actually, depending
		on the __cplusplus definition).
		
		This follows the Microsoft conventions closely (or at least,
		a subset thereof).
		
		A synopsis is as follows:
		
		DECLARE_MOA_INTERFACE(theInterface) is used to declare a base interface.
		DECLARE_MOA_INTERFACE_(theInterface, baseInterface) is used to declare
			an interface that is based on another interface. In practice,
			you'll always use this one, since every interface must be
			derived from IMoaUnknown. Also note that you must still re-list
			all the derived methods. 
	*/
	
	
	#ifdef CPLUS
		
		/* the macros for C++ */
	
		#define INTERFACE_PREFACE								struct FAR
		
		#define STDMOAMETHOD(methodName) 						virtual MoaError MOASTDMETHODCALLTYPE methodName
		#define STDMOAMETHOD_(resultType, methodName) 			virtual resultType MOASTDMETHODCALLTYPE methodName
		#define STDMETHOD(methodName) 							STDMOAMETHOD(methodName)
		#define STDMETHOD_(resultType, methodName) 				STDMOAMETHOD_(resultType, methodName)
		
		#define PURE											= 0
		#define THIS_
		#define THIS											void
		#define DECLARE_MOA_INTERFACE(theInterface)					PTRCHECK INTERFACE_PREFACE theInterface
		#define DECLARE_MOA_INTERFACE_(theInterface, baseInterface)	PTRCHECK INTERFACE_PREFACE theInterface : public baseInterface
		#define DECLARE_MOA_CLASS_INTERFACE_(theInterface, baseInterface) DECLARE_MOA_INTERFACE_(theInterface, baseInterface)
		#define DECLARE_INTERFACE(theInterface)					PTRCHECK INTERFACE_PREFACE theInterface
		#define DECLARE_INTERFACE_(theInterface, baseInterface)	PTRCHECK INTERFACE_PREFACE theInterface : public baseInterface
	#else /* not C++ */	
		/* macros for plain C */
	
		#define INTERFACE_PREFACE						struct
	
		#define STDMOAMETHOD(methodName)					MoaError (MOASTDMETHODCALLTYPE * methodName)
		#define STDMOAMETHOD_(resultType, methodName)		resultType (MOASTDMETHODCALLTYPE * methodName)
		#define STDMETHOD(methodName)					STDMOAMETHOD(methodName)
		#define STDMETHOD_(resultType, methodName)		STDMOAMETHOD_(resultType, methodName)
	
		#define PURE
		#define THIS_									struct INTERFACE FAR * This,
		#define THIS									struct INTERFACE FAR * This
	
		#define DECLARE_MOA_INTERFACE(theInterface)		PTRCHECK struct theInterface##Vtbl; typedef INTERFACE_PREFACE theInterface { \
														struct theInterface##Vtbl FAR * lpVtbl; \
													} theInterface; \
													typedef struct theInterface##Vtbl theInterface##Vtbl; \
													struct theInterface##Vtbl
	
		#define DECLARE_MOA_INTERFACE_(theInterface, baseInterface)	DECLARE_INTERFACE(theInterface)
		#define DECLARE_MOA_CLASS_INTERFACE_(theInterface, baseInterface) DECLARE_MOA_INTERFACE_(theInterface, baseInterface)
		
		
		#define DECLARE_INTERFACE(theInterface)	DECLARE_MOA_INTERFACE(theInterface)
		#define DECLARE_INTERFACE_(theInterface, baseInterface)	DECLARE_MOA_INTERFACE_(theInterface, baseInterface)
	
	#endif											 
	
	#if defined(MOAINITGUID) || defined(INITGUID)
		#define MOA_DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
			MOAEXTERN_C MOA_READONLY(MoaID) CDECL name = { l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8 }
		#ifdef MACINTOSH
			#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
					MOA_DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8)
		#endif
	#else
		#define MOA_DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
			MOAEXTERN_C MOA_READONLY(MoaID) CDECL FAR name
		#ifdef MACINTOSH
			#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
				MOA_DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8)
		#endif
	#endif

	typedef ConstPMoaClassID MOAREFCLSID;
	typedef ConstPMoaInterfaceID MOAREFIID;
#else // ifndef WINDOWS
	#define MOAEXTERN_C		EXTERN_C

	#define STDMOAMETHOD(methodName) 						STDMETHOD(methodName)
	#define STDMOAMETHOD_(resultType, methodName) 			STDMETHOD_(resultType, methodName)

	#define DECLARE_MOA_INTERFACE(theInterface)					DECLARE_INTERFACE(theInterface)
	#define DECLARE_MOA_INTERFACE_(theInterface, baseInterface)	DECLARE_INTERFACE_(theInterface, baseInterface)
	#define DECLARE_MOA_CLASS_INTERFACE_(theInterface, baseInterface) interface theInterface : public baseInterface

	#define STDMOAMETHODIMP				 STDMETHODIMP
	#define STDMOAMETHODIMP_(returnType) STDMETHODIMP_(returnType)

	/* no PTRCHECK done, but probably using Windows anyway */
	#define EXTERN_STDMETHODIMP					EXTERN_C STDMETHODIMP
	#define EXTERN_STDMETHODIMP_(returnType)	EXTERN_C STDMETHODIMP_(returnType)

	#define MOA_DEFINE_GUID		DEFINE_GUID
	#define MOASTDMETHODCALLTYPE STDMETHODCALLTYPE
	#define MOASTDAPICALLTYPE STDAPICALLTYPE

	#define MOASTDAPI	STDAPI_(MoaError)
	#define MOASTDAPI_(returnType) STDAPI_(returnType)
	
	#define MOAREFIID	REFIID
	#define MOAREFCLSID	REFCLSID

#endif	/* __COMPOBJ__ */

#if defined(IGNORE_STD_GUID)
	#define DEFINE_STD_GUID MOA_DEFINE_GUID
#else
	#if (defined(MOAINITGUID) || defined(INITGUID)) && !defined(NO_STD_GUID)
		#define DEFINE_STD_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
			MOAEXTERN_C MOA_READONLY(MoaID) CDECL name = { l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8 }
	#else
		#define DEFINE_STD_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
			MOAEXTERN_C MOA_READONLY(MoaID) CDECL FAR name
	#endif
#endif

#ifndef BEGIN_INTERFACE

	#ifdef MACINTOSH
		#ifdef CPLUS
			#if (defined(_MSC_VER) || defined(__SC__) || (defined(__MWERKS__) && (__MWERKS__ < 0x0800))) && !defined(NO_NULL_VTABLE_ENTRY)
				#define BEGIN_INTERFACE virtual void a() {}
			#else
				#define BEGIN_INTERFACE
			#endif
		#else
			#define BEGIN_INTERFACE	void* b;
		#endif
	#else
		#define BEGIN_INTERFACE
	#endif

#endif

#define STD_IMOAUNKNOWN_METHODS \
	BEGIN_INTERFACE \
	STDMOAMETHOD(QueryInterface) (THIS_ ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppvObj) PURE; \
	STDMOAMETHOD_(MoaUlong, AddRef) (THIS) PURE; \
	STDMOAMETHOD_(MoaUlong, Release) (THIS) PURE; \

#define STD_IUNKNOWN_METHODS STD_IMOAUNKNOWN_METHODS

/* ========================================================================== */
/* ========================== Standard Interfaces =========================== */
/* ========================================================================== */

/* --------------------------------------------------------------------- Misc */

#ifdef IID_NULL
	#undef IID_NULL
#endif

/* IID_NULL: 00000000000000000000000000000000 */
DEFINE_STD_GUID(IID_NULL, 0x00000000L, 0x0000, 0x0000, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00);

/* CLSID_AnyClass: af107ce031ea101c9a9f0000c0ddaa4b */
DEFINE_STD_GUID(CLSID_AnyClass, 0xaf107ce0L, 0x31ea, 0x101c, 0x9a, 0x9f, 0x00, 0x00, 0xc0, 0xdd, 0xaa, 0x4b);


/* ----------------------------------------------------------------- IMoaUnknown */

#undef INTERFACE
#define INTERFACE IMoaUnknown

#ifdef MACINTOSH
/*
	With MPW and MWERKS you must descend from SingleObject
	to enforce Microsoft compiler compatible vtable building; 
	otherwise the vtable may include offsets for multiple 
	inheritance (even if the object doesn't multiply inherit). 
	Since every other interface must inherit from this one, this
	will do the trick...
	
	UPDATE: MWERKS now provides __comobject which is more
	flexible than SingleObject yet compatible with COM. __comobject
	allows C++ classes to inherit from multiple IMoaUnknown-
	derived classes. (sml)
*/
DECLARE_MOA_INTERFACE_(IMoaUnknown, __comobject)
#else
DECLARE_MOA_INTERFACE(IMoaUnknown)
#endif
{
	STD_IMOAUNKNOWN_METHODS
};
typedef IMoaUnknown FAR * PIMoaUnknown;

/* IID_IMoaUnknown: 0000000000000000C000000000000046 */
DEFINE_STD_GUID(IID_IMoaUnknown, 0x00000000L, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46);

/* ------------------------------------------------------------ IMoaClassFactory */

/* this interface is for Moa internal use only. */

#undef INTERFACE
#define INTERFACE IMoaClassFactory

DECLARE_MOA_INTERFACE_(IMoaClassFactory, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD(CreateInstance) (THIS_ PIMoaUnknown pUnkOuter,
		ConstPMoaInterfaceID pInterfaceID,
		PPMoaVoid ppvObject) PURE;
 	STDMOAMETHOD(LockServer) (THIS_ MoaUlong fLock) PURE;
};
typedef IMoaClassFactory FAR * PIMoaClassFactory;

/* IID_IMoaClassFactory: 0000000100000000C000000000000046 */
DEFINE_STD_GUID(IID_IMoaClassFactory, 0x00000001L, 0x0000, 0x0000, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46);

/* --------------------------------------------------------------- IMoaCalloc */
#undef INTERFACE
#define INTERFACE IMoaCalloc

DECLARE_MOA_INTERFACE_(IMoaCalloc, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(PMoaVoid, NRAlloc) (THIS_ MoaUlong cb) PURE;
	STDMOAMETHOD_(void, NRFree) (THIS_ PMoaVoid pv) PURE;
};
typedef IMoaCalloc FAR * PIMoaCalloc;

/* IID_ICalloc: 3a698c2039c3101c9a9f0000c0ddaa4b */
DEFINE_STD_GUID(IID_IMoaCalloc, 0x3a698c20L, 0x39c3, 0x101c, 0x9a, 0x9f, 0x00, 0x00, 0xc0, 0xdd, 0xaa, 0x4b);

/* ------------------------------------------------------------- IMoaCallback */
#undef INTERFACE
#define INTERFACE IMoaCallback

DECLARE_MOA_INTERFACE_(IMoaCallback, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD(MoaCreateInstance) (THIS_ ConstPMoaClassID pClassID, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppvObj) PURE;
	STDMOAMETHOD_(struct IMoaCache FAR *, MoaGetCache) (THIS) PURE;

	STDMOAMETHOD_(XtraResourceCookie, MoaBeginUsingResources) (THIS_ MoaFileRef fileRef, XtraResourceCookie FAR * pSaveCookie) PURE;
	STDMOAMETHOD_(void, MoaEndUsingResources) (THIS_ MoaFileRef fileRef, XtraResourceCookie saveCookie) PURE;
};
typedef IMoaCallback FAR * PIMoaCallback;

/* IID_ICallback: c00bfc803164101c9a9c0000c0ddaa4b */
DEFINE_STD_GUID(IID_IMoaCallback, 0xc00bfc80L, 0x3164, 0x101c, 0x9a, 0x9c, 0x00, 0x00, 0xc0, 0xdd, 0xaa, 0x4b);

/* ========================================================================== */
/* ============================== Function types ============================ */
/* ========================================================================== */

/* STDMOAMETHOD-protocol functions. */

typedef STDPROCPTR(MOASTDMETHODCALLTYPE, MoaError, MoaCreatedProc)(PMoaVoid pObj);

typedef STDPROCPTR(MOASTDMETHODCALLTYPE, void, MoaDestroyedProc)(PMoaVoid pObj);

#ifdef MACINTOSH
#pragma options align=mac68k
#endif
#ifdef WINDOWS
#pragma pack(2)
#endif
/* this structure is for Moa internal use only. */
typedef struct {
	MoaClassID classID;
	MoaLong classVersion;
	MoaInterfaceID interfaceID;
	MoaLong interfaceVersion;
} MoaClassInterfaceInfo;
typedef MoaClassInterfaceInfo FAR * PMoaClassInterfaceInfo;
typedef const MoaClassInterfaceInfo FAR * ConstPMoaClassInterfaceInfo;
#ifdef MACINTOSH
#pragma options align=reset
#endif
#ifdef WINDOWS
#pragma pack()
#endif

#undef XE_DLL
#define XE_DLL(x) DLL(x)

#define EXTERN_XTRA_ENTRIES \
	MOASTDAPI XE_DLL(GetClassObject)(MOAREFCLSID rclsid, MOAREFIID riid, PPMoaVoid ppv); \
	MOASTDAPI XE_DLL(CanUnloadNow)(void); \
	MOASTDAPI XE_DLL(GetInterface)(PMoaVoid pObj, ConstPMoaClassID pClassID, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv); \
	MOASTDAPI XE_DLL(GetClassForm)(ConstPMoaClassID pClassID, MoaLong FAR * pObjSize, MoaCreatedProc FAR * pCreateProc, MoaDestroyedProc FAR * pDestroyProc); \
	MOASTDAPI XE_DLL(GetClassInfo)(PIMoaCalloc pCalloc, ConstPMoaClassInterfaceInfo FAR * ppClassInfo); \
	MOASTDAPI DllGetClassObject(MOAREFCLSID rclsid, MOAREFIID riid, PPMoaVoid ppv); \
	MOASTDAPI DllCanUnloadNow(void); \
	MOASTDAPI DllGetInterface(PMoaVoid pObj, ConstPMoaClassID pClassID, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv); \
	MOASTDAPI DllGetClassForm(ConstPMoaClassID pClassID, MoaLong FAR * pObjSize, MoaCreatedProc FAR * pCreateProc, MoaDestroyedProc FAR * pDestroyProc); \
	MOASTDAPI DllGetClassInfo(PIMoaCalloc pCalloc, ConstPMoaClassInterfaceInfo FAR * ppClassInfo);

#ifdef MACINTOSH
#if !defined(MOA_APP_CODE)
#pragma export on
_EXTERN_C_ void ppcSetFileRef(MoaFileRef fileRef);
#endif
#endif

EXTERN_XTRA_ENTRIES

#ifdef MACINTOSH
#if !defined(MOA_APP_CODE)
#pragma export off
#endif
#endif

/* ========================================================================== */
/* ============================= Type Definitions =========================== */
/* ========================================================================== */

#define _BASE_STRUCTURES \
			MoaXtraMagicCookie		magicCookie; 	/* for internal use */ \
			PIMoaCallback			pCallback; 		/* callbacks, or NULL */ \
			PIMoaCalloc 			pCalloc; 		/* IMoaCalloc we used for ourself */ \
			ConstPMoaClassID	 	pClassID; 		/* ptr to our class id */ \
			MoaLong					refCount; 		/* our refcount */ \

#define _INTERFACE_STRUCTURES(macro_CLASS) \
			macro_CLASS FAR * 		pObj; 			/* pointer to the "real" object */ \
			MoaLong 				refCount; 		/* refcount for THIS INTERFACE */ 

/* This gyration is to allow for classes/interface to be replaced by Macros.
	a two-step token pasting allows for this. */
#ifdef applec
	#define CLSID(macro_CLSID)						CLSID_##macro_CLSID
	#define IID(macro_IID)							IID_##macro_IID
	
	#define MOA_CREATEI(macro_CLASS, macro_INTF)			MoaCreate_##macro_CLASS##_##macro_INTF
	#define MOA_DESTROYI(macro_CLASS, macro_INTF)			MoaDestroy_##macro_CLASS##_##macro_INTF
	
	#define MOA_CREATEI_PARMS(macro_CLASS, macro_INTF)		MoaCreate_##macro_CLASS##_##macro_INTF(macro_CLASS##_##macro_INTF FAR * This)
	#define MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF)	MoaDestroy_##macro_CLASS##_##macro_INTF(macro_CLASS##_##macro_INTF FAR * This)
	
	#define MOA_CREATE(macro_NAME)					MoaCreate_##macro_NAME
	#define MOA_DESTROY(macro_NAME)				MoaDestroy_##macro_NAME
	
	#define MOA_CREATE_PARMS(macro_NAME)			MoaCreate_##macro_NAME(macro_NAME FAR * This)
	#define MOA_DESTROY_PARMS(macro_NAME)			MoaDestroy_##macro_NAME(macro_NAME FAR * This)
	
	#define INTF(macro_CLASS, macro_INTF)			macro_CLASS##_##macro_INTF
	
	#define INTFQUERY(macro_CLASS, macro_INTF)			macro_CLASS##_##macro_INTF##_QI
	#define INTFQUERY_PARMS(macro_CLASS, macro_INTF)	macro_CLASS##_##macro_INTF##_QI(macro_CLASS##_##macro_INTF FAR * This, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv)
	
	#define INTFADDREF(macro_CLASS, macro_INTF)		macro_CLASS##_##macro_INTF##_AR
	#define INTFADDREF_PARMS(macro_CLASS, macro_INTF)	macro_CLASS##_##macro_INTF##_AR(macro_CLASS##_##macro_INTF FAR * This)
	
	#define INTFRELEASE(macro_CLASS, macro_INTF)		macro_CLASS##_##macro_INTF##_RL
	#define INTFRELEASE_PARMS(macro_CLASS, macro_INTF)	macro_CLASS##_##macro_INTF##_RL(macro_CLASS##_##macro_INTF FAR * This)
	
	#define INTFBUILD(macro_CLASS, macro_INTF)			Build_##macro_CLASS##_##macro_INTF
	#define INTFBUILD_PARMS(macro_CLASS, macro_INTF)	Build_##macro_CLASS##_##macro_INTF(macro_CLASS FAR * pObj, struct macro_CLASS##_##macro_INTF FAR * FAR * ppIF)
	
	#define INTFVTBL(macro_INTF)					macro_INTF##Vtbl
	#define GETVTBL(macro_CLASS, macro_INTF)		_Get##macro_CLASS##macro_INTF##Vtbl
	#define THEVTBL(macro_CLASS, macro_INTF)		g_##macro_CLASS##macro_INTF##vt
	#define INITVTBL(macro_CLASS, macro_INTF)		g_##macro_CLASS##macro_INTF##vti
	
	#define CALL_BGI(macro_CLASS, macro_INTF, macro_OBJ, macro_PERR) \
													(macro_CLASS##_##macro_INTF FAR *)DLL(BuildGenInterface) \
													((MBObject FAR *)(macro_OBJ), \
													sizeof(macro_CLASS##_##macro_INTF), \
													(MoaCreatedProc)MoaCreate_##macro_CLASS##_##macro_INTF, \
													(PMoaVoid)GET_VTABLE(macro_CLASS, macro_INTF), \
													(macro_PERR))
	
#else
	#define _CLSID(macro_CLSID)						CLSID_##macro_CLSID
	#define CLSID(macro_CLSID)						_CLSID(macro_CLSID)
	#define _IID(macro_IID)							IID_##macro_IID
	#define IID(macro_IID)							_IID(macro_IID)
	
	#define _MOA_CREATEI(macro_CLASS, macro_INTF)			MoaCreate_##macro_CLASS##_##macro_INTF
	#define MOA_CREATEI(macro_CLASS, macro_INTF)			_MOA_CREATEI(macro_CLASS, macro_INTF)
	#define _MOA_DESTROYI(macro_CLASS, macro_INTF)			MoaDestroy_##macro_CLASS##_##macro_INTF
	#define MOA_DESTROYI(macro_CLASS, macro_INTF)			_MOA_DESTROYI(macro_CLASS, macro_INTF)
	
	#define _MOA_CREATEI_PARMS(macro_CLASS, macro_INTF)		MoaCreate_##macro_CLASS##_##macro_INTF(macro_CLASS##_##macro_INTF FAR * This)
	#define MOA_CREATEI_PARMS(macro_CLASS, macro_INTF)		_MOA_CREATEI_PARMS(macro_CLASS, macro_INTF)
	#define _MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF)	MoaDestroy_##macro_CLASS##_##macro_INTF(macro_CLASS##_##macro_INTF FAR * This)
	#define MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF)		_MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF)
	
	#define _MOA_CREATE(macro_NAME)					MoaCreate_##macro_NAME
	#define MOA_CREATE(macro_NAME)					_MOA_CREATE(macro_NAME)
	#define _MOA_DESTROY(macro_NAME)				MoaDestroy_##macro_NAME
	#define MOA_DESTROY(macro_NAME)					_MOA_DESTROY(macro_NAME)
	
	#define _MOA_CREATE_PARMS(macro_NAME)			MoaCreate_##macro_NAME(macro_NAME FAR * This)
	#define MOA_CREATE_PARMS(macro_NAME)			_MOA_CREATE_PARMS(macro_NAME)
	#define _MOA_DESTROY_PARMS(macro_NAME)			MoaDestroy_##macro_NAME(macro_NAME FAR * This)
	#define MOA_DESTROY_PARMS(macro_NAME)			_MOA_DESTROY_PARMS(macro_NAME)
	
	#define _INTF(macro_CLASS, macro_INTF)			macro_CLASS##_##macro_INTF
	#define INTF(macro_CLASS, macro_INTF)			_INTF(macro_CLASS, macro_INTF)
	
	#define _INTFQUERY(macro_CLASS, macro_INTF)			macro_CLASS##_##macro_INTF##_QI
	#define INTFQUERY(macro_CLASS, macro_INTF)			_INTFQUERY(macro_CLASS, macro_INTF)
	#define _INTFQUERY_PARMS(macro_CLASS, macro_INTF)	macro_CLASS##_##macro_INTF##_QI(macro_CLASS##_##macro_INTF FAR * This, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv)
	#define INTFQUERY_PARMS(macro_CLASS, macro_INTF)	_INTFQUERY_PARMS(macro_CLASS, macro_INTF)
	
	#define _INTFADDREF(macro_CLASS, macro_INTF)		macro_CLASS##_##macro_INTF##_AR
	#define INTFADDREF(macro_CLASS, macro_INTF)			_INTFADDREF(macro_CLASS, macro_INTF)
	#define _INTFADDREF_PARMS(macro_CLASS, macro_INTF)	macro_CLASS##_##macro_INTF##_AR(macro_CLASS##_##macro_INTF FAR * This)
	#define INTFADDREF_PARMS(macro_CLASS, macro_INTF)	_INTFADDREF_PARMS(macro_CLASS, macro_INTF)
	
	#define _INTFRELEASE(macro_CLASS, macro_INTF)		macro_CLASS##_##macro_INTF##_RL
	#define INTFRELEASE(macro_CLASS, macro_INTF)		_INTFRELEASE(macro_CLASS, macro_INTF)
	#define _INTFRELEASE_PARMS(macro_CLASS, macro_INTF)	macro_CLASS##_##macro_INTF##_RL(macro_CLASS##_##macro_INTF FAR * This)
	#define INTFRELEASE_PARMS(macro_CLASS, macro_INTF)	_INTFRELEASE_PARMS(macro_CLASS, macro_INTF)
	
	#define _INTFBUILD(macro_CLASS, macro_INTF)			Build_##macro_CLASS##_##macro_INTF
	#define INTFBUILD(macro_CLASS, macro_INTF)			_INTFBUILD(macro_CLASS, macro_INTF)
	#define _INTFBUILD_PARMS(macro_CLASS, macro_INTF)	Build_##macro_CLASS##_##macro_INTF(macro_CLASS FAR * pObj, struct macro_CLASS##_##macro_INTF FAR * FAR * ppIF)
	#define INTFBUILD_PARMS(macro_CLASS, macro_INTF)	_INTFBUILD_PARMS(macro_CLASS, macro_INTF)
	
	#define _INTFVTBL(macro_INTF)					macro_INTF##Vtbl
	#define INTFVTBL(macro_INTF)					_INTFVTBL(macro_INTF)
	#define _GETVTBL(macro_CLASS, macro_INTF)		_Get##macro_CLASS##macro_INTF##Vtbl
	#define GETVTBL(macro_CLASS, macro_INTF)		_GETVTBL(macro_CLASS, macro_INTF)
	#define _THEVTBL(macro_CLASS, macro_INTF)		g_##macro_CLASS##macro_INTF##vt
	#define THEVTBL(macro_CLASS, macro_INTF)		_THEVTBL(macro_CLASS, macro_INTF)
	#define _INITVTBL(macro_CLASS, macro_INTF)		g_##macro_CLASS##macro_INTF##vti
	#define INITVTBL(macro_CLASS, macro_INTF)		_INITVTBL(macro_CLASS, macro_INTF)
	
	#define _CALL_BGI(macro_CLASS, macro_INTF, macro_OBJ, macro_PERR) \
													(macro_CLASS##_##macro_INTF FAR *)DLL(BuildGenInterface) \
													((MBObject FAR *)(macro_OBJ), \
													sizeof(macro_CLASS##_##macro_INTF), \
													(MoaCreatedProc)MoaCreate_##macro_CLASS##_##macro_INTF, \
													(PMoaVoid)GET_VTABLE(macro_CLASS, macro_INTF), \
													(macro_PERR))
	#define CALL_BGI(macro_CLASS, macro_INTF, macro_OBJ, macro_PERR) \
													_CALL_BGI(macro_CLASS, macro_INTF, macro_OBJ, macro_PERR)
	
#endif

#ifdef CPLUS

	#define CALL_CALLOC(pCalloc, sz) (pCalloc)->NRAlloc(sz)
	#define CALL_NRFREE(pCalloc, p) (pCalloc)->NRFree(p)

	#define EXTERN_BEGIN_DEFINE_CLASS_INSTANCE_VARS(macro_CLASS) \
		PTRCHECK \
		struct macro_CLASS; \
		typedef struct macro_CLASS macro_CLASS; \
		EXTERN_STDMETHODIMP MOA_CREATE_PARMS(macro_CLASS); \
		EXTERN_STDMETHODIMP_(void) MOA_DESTROY_PARMS(macro_CLASS); \
		DECLARE_MOA_INTERFACE_(macro_CLASS, IMoaUnknown) \
		{ \
			_BASE_STRUCTURES \
			BEGIN_INTERFACE \
			STDMOAMETHOD(QueryInterface) (THIS_ ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppvObj);\
			STDMOAMETHOD_(MoaUlong, AddRef) (THIS);\
			STDMOAMETHOD_(MoaUlong, Release) (THIS); \

	#define EXTERN_END_DEFINE_CLASS_INSTANCE_VARS \
		};

	#define EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(macro_CLASS, macro_INTF) \
		PTRCHECK \
		struct INTF(macro_CLASS, macro_INTF); \
		typedef struct INTF(macro_CLASS, macro_INTF) INTF(macro_CLASS, macro_INTF); \
		EXTERN_STDMETHODIMP INTFBUILD_PARMS(macro_CLASS, macro_INTF); \
		DECLARE_MOA_CLASS_INTERFACE_(INTF(macro_CLASS, macro_INTF), macro_INTF) \
		{ \
			_INTERFACE_STRUCTURES(macro_CLASS) \
			BEGIN_INTERFACE \
			STDMOAMETHOD(QueryInterface) (THIS_ ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppvObj);\
			STDMOAMETHOD_(MoaUlong, AddRef) (THIS);\
			STDMOAMETHOD_(MoaUlong, Release) (THIS); \
			inline PMoaVoid operator new (size_t size, PMoaVoid pObj) \
			{ \
				macro_CLASS FAR *pRealObj = reinterpret_cast<macro_CLASS FAR *>(pObj); \
				INTF(macro_CLASS, macro_INTF) FAR * p = (INTF(macro_CLASS, macro_INTF) FAR *)DLL(_MBNew)(size, pRealObj->pCalloc); \
				\
				if (p) { \
					p->pObj = reinterpret_cast<macro_CLASS FAR *>(pObj); \
					p->refCount = 1; \
					pRealObj->AddRef(); \
					pRealObj->AddRef(); \
					InterlockedIncrement(&DLL(gXtraInterfaceCount)); \
				} \
				\
				return (PMoaVoid)p; \
			} \
			inline void operator delete (void *, void *) {} \
			inline void operator delete (PMoaVoid ptr, size_t size) { ptr; } \
			INTF(macro_CLASS, macro_INTF) (MoaError FAR * pErr); \
			~INTF(macro_CLASS, macro_INTF) ();

	#define EXTERN_DEFINE_METHOD(macro_RETURNTYPE, macro_METHODNAME, macro_ARGLIST) \
		STDMOAMETHOD_(macro_RETURNTYPE, macro_METHODNAME) macro_ARGLIST ;

	#define EXTERN_END_DEFINE_CLASS_INTERFACE \
		};
	
#else

	#define CALL_CALLOC(pCalloc, sz) (pCalloc)->lpVtbl->NRAlloc((PIMoaCalloc)(pCalloc), (sz))
	#define CALL_NRFREE(pCalloc, p) (pCalloc)->lpVtbl->NRFree((PIMoaCalloc)(pCalloc), (p))

	/* This macro simply declares the structure of your object. */
	#define EXTERN_BEGIN_DEFINE_CLASS_INSTANCE_VARS(macro_CLASS) \
		PTRCHECK \
		struct macro_CLASS; \
		typedef struct macro_CLASS macro_CLASS; \
		EXTERN_STDMETHODIMP MOA_CREATE_PARMS(macro_CLASS); \
		EXTERN_STDMETHODIMP_(void) MOA_DESTROY_PARMS(macro_CLASS); \
		struct macro_CLASS { \
			IMoaUnknownVtbl FAR * lpVtbl; 		/* our vtable */ \
			_BASE_STRUCTURES

	#define EXTERN_END_DEFINE_CLASS_INSTANCE_VARS \
		};
	
	/* This macro simply declares the structure of a given interface to your object */
	#define EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(macro_CLASS, macro_INTF) \
		PTRCHECK \
		struct INTF(macro_CLASS, macro_INTF); \
		typedef struct INTF(macro_CLASS, macro_INTF) INTF(macro_CLASS, macro_INTF); \
		EXTERN_STDMETHODIMP MOA_CREATEI_PARMS(macro_CLASS, macro_INTF); \
		EXTERN_STDMETHODIMP_(void) MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF); \
		STDMOAMETHODIMP INTFQUERY_PARMS(macro_CLASS, macro_INTF); \
		STDMOAMETHODIMP_(MoaUlong) INTFADDREF_PARMS(macro_CLASS, macro_INTF); \
		STDMOAMETHODIMP_(MoaUlong) INTFRELEASE_PARMS(macro_CLASS, macro_INTF); \
		EXTERN_STDMETHODIMP INTFBUILD_PARMS(macro_CLASS, macro_INTF); \
		MOAEXTERN_C PMoaVoid DLL(BuildGenInterface)(MBObject FAR * pObj, MoaLong interfaceSize, MoaCreatedProc createdProc, PMoaVoid vtbl, MoaError FAR * pErr); \
		\
		struct INTF(macro_CLASS, macro_INTF) { \
			INTFVTBL(macro_INTF) FAR *	lpVtbl; \
			_INTERFACE_STRUCTURES(macro_CLASS) \

	#define EXTERN_DEFINE_METHOD(macro_RETURNTYPE, macro_METHODNAME, macro_ARGLIST) 

	#define EXTERN_END_DEFINE_CLASS_INTERFACE \
		}; 
	
#endif

MOAEXTERN_C PMoaVoid DLL(_MBNew)(size_t size, PIMoaCalloc pCalloc);
MOAEXTERN_C void DLL(_MBDelete)(PMoaVoid ptr, PIMoaCalloc pCalloc);

#ifdef __cplusplus
	#ifdef _MSC_VER
		/* alas, MS does this differently... */
		#define DO_NEW_HANDLER \
			_PNH pehf = _set_new_handler(0); \
			_set_new_handler(pehf); \
			if (pehf) pehf(size); else return 0;
	#else
		#define DO_NEW_HANDLER \
			void (*pehf)() = set_new_handler(0); \
			set_new_handler(pehf); \
			if (pehf) pehf(); else return 0;
	#endif
#else
	#define DO_NEW_HANDLER
#endif

#define DECLARE_MBNEW \
	\
	PMoaVoid DLL(_MBNew)(size_t size, PIMoaCalloc pCalloc) \
	{ \
		void *ptr; \
		while ((ptr = CALL_CALLOC(pCalloc, size))==NULL) { \
			DO_NEW_HANDLER \
		} \
		return ptr; \
	} \
	\
	void DLL(_MBDelete)(PMoaVoid ptr, PIMoaCalloc pCalloc) \
	{ \
		MOA_CLOBBERTEST(ptr, "_MBDelete") \
		CALL_NRFREE(pCalloc, ptr); \
	}

EXTERN_BEGIN_DEFINE_CLASS_INSTANCE_VARS(MBObject)
EXTERN_END_DEFINE_CLASS_INSTANCE_VARS

#ifndef CPLUS
	EXTERN_BEGIN_DEFINE_CLASS_INTERFACE(MBObject, IMoaUnknown)
	EXTERN_END_DEFINE_CLASS_INTERFACE
#endif

/* ========================================================================== */
/* =========================== Interface Routines =========================== */
/* ========================================================================== */

MOASTDAPI_(MoaLong) MoaEqualID(ConstPMoaID a, ConstPMoaID b);

/* ========================================================================== */
/* ============================= Global Variables =========================== */
/* ========================================================================== */

#if !defined(MOA_APP_CODE)
	MOAEXTERN_C MoaFileRef gXtraFileRef;
#endif

MOAEXTERN_C MoaLong DLL(gXtraInterfaceCount);

/* ========================================================================== */
/* =========================== Macro Definitiions =========================== */
/* ========================================================================== */

/* ---------------------------------------------- VTable-constructing macros. */

/*
	By default, choose "safer vtable" over the slightly smaller and
	faster (but more error-prone) fast vtable macros.
*/
#ifndef SMALLER_VTABLE
#define SAFER_VTABLE 1
#endif

/*
	some compilers can't handle auto-initializing vtable arrays
	to addresses (notably Mac 68k compilers). Mwerks does this OK
	if you turn on "link single segment" and "multi segment",
	confusingly enough, but the older, less efficient macros
	for building vtables on the fly is left in just in case...
*/

#ifdef SAFER_VTABLE

	/*
		This is "safer" because it's not order-dependent.
	*/
	#define EXTERN_GET_VTABLE(macro_CLASS, macro_INTF) \
		MOAEXTERN_C INTFVTBL(macro_INTF) FAR * GETVTBL(macro_CLASS, macro_INTF)(void);

	#ifdef MOA_DEBUG
		#define _DBG_VT_NM(macro_CLASS, macro_INTF) \
			char* vtNm = "Bad Vtbl" #macro_CLASS #macro_INTF;
	#else
		#define _DBG_VT_NM(macro_CLASS, macro_INTF)
	#endif

	#ifdef MACINTOSH
		#define _DBG_EXTRA_ENTRIES 1
	#else
		#define _DBG_EXTRA_ENTRIES 0
	#endif

	#define BEGIN_VTABLE(macro_CLASS, macro_INTF) \
	PTRCHECK \
	INTFVTBL(macro_INTF) FAR THEVTBL(macro_CLASS, macro_INTF); \
	long FAR INITVTBL(macro_CLASS, macro_INTF) = 0; \
	\
	EXTERN_GET_VTABLE(macro_CLASS, macro_INTF) \
	INTFVTBL(macro_INTF) FAR * GETVTBL(macro_CLASS, macro_INTF)(void) { \
		INTFVTBL(macro_INTF) FAR * result; \
		result = &THEVTBL(macro_CLASS, macro_INTF); \
		if (!INITVTBL(macro_CLASS, macro_INTF)) { \
			INTFVTBL(macro_INTF) FAR * lpVtbl = &THEVTBL(macro_CLASS, macro_INTF); \
			long vtErrChk = sizeof(INTFVTBL(macro_INTF)) / sizeof(PMoaVoid) - _DBG_EXTRA_ENTRIES; \
			_DBG_VT_NM(macro_CLASS, macro_INTF) \
			InterlockedIncrement(&INITVTBL(macro_CLASS, macro_INTF)); \

	#define VTABLE_ENTRY(macro_METHODNAME, macro_IMPLROUTINENAME) \
			*(PPMoaVoid)&(lpVtbl->macro_METHODNAME) = (PMoaVoid)(macro_IMPLROUTINENAME); InterlockedDecrement(&vtErrChk);

	#define FIRST_VTABLE_ENTRY(macro_METHODNAME, macro_IMPLROUTINENAME) \
			VTABLE_ENTRY(macro_METHODNAME, macro_IMPLROUTINENAME)

	#define END_VTABLE \
			MOA_ASSERT(vtErrChk == 0, vtNm); \
		}\
		return result; \
	} \

	#define GET_VTABLE(macro_CLASS, macro_INTF) \
		GETVTBL(macro_CLASS, macro_INTF)()

#else

	#define EXTERN_GET_VTABLE(macro_CLASS, macro_INTF) \
		MOAEXTERN_C const PMoaVoid FAR THEVTBL(macro_CLASS, macro_INTF)[sizeof(INTFVTBL(macro_INTF))/sizeof(PMoaVoid)];

	#define BEGIN_VTABLE(macro_CLASS, macro_INTF) \
		PTRCHECK \
		MOA_READONLY(PMoaVoid) THEVTBL(macro_CLASS, macro_INTF)[sizeof(INTFVTBL(macro_INTF))/sizeof(PMoaVoid)] = {
	
	#ifdef MACINTOSH
		/* Mac vtables have an empty entry in the first slot */
		#define FIRST_VTABLE_ENTRY(macro_METHODNAME, macro_IMPLROUTINENAME) \
				NULL, (PMoaVoid)(macro_IMPLROUTINENAME)
	#else
		#define FIRST_VTABLE_ENTRY(macro_METHODNAME, macro_IMPLROUTINENAME) \
				(PMoaVoid)(macro_IMPLROUTINENAME)
	#endif

	#define VTABLE_ENTRY(macro_METHODNAME, macro_IMPLROUTINENAME) \
			, (PMoaVoid)(macro_IMPLROUTINENAME)

	
	#define END_VTABLE \
			};

	#define GET_VTABLE(macro_CLASS, macro_INTF) \
		((INTFVTBL(macro_INTF) FAR *)&THEVTBL(macro_CLASS, macro_INTF))
#endif

/* -------------------------------------------------- Xtra-Declaration macros */
/*
	These macros construct the DllGetClassObject, DllGetInterface,
	and DllCanUnloadNow routines; declare the types of the objects
	you specify; and glue to the Stub routines above.
*/

#if defined(applec) || defined(__MWERKS__)
	#define _SICD_NOWARN PMoaVoid foo = (PMoaVoid)This;
#else
	#define _SICD_NOWARN
#endif


#define STD_CLASS_CREATE_DESTROY(macro_CLASS) \
	EXTERN_STDMETHODIMP MOA_CREATE_PARMS(macro_CLASS); \
	EXTERN_STDMETHODIMP_(void) MOA_DESTROY_PARMS(macro_CLASS); \
	STDMOAMETHODIMP MOA_CREATE_PARMS(macro_CLASS) { _SICD_NOWARN return kMoaErr_NoErr; } \
	STDMOAMETHODIMP_(void) MOA_DESTROY_PARMS(macro_CLASS) { _SICD_NOWARN }

#ifdef CPLUS

	#define STD_INTERFACE_CREATE_DESTROY(macro_CLASS, macro_INTF) \
		INTF(macro_CLASS, macro_INTF)::INTF(macro_CLASS, macro_INTF)(MoaError FAR * pErr) { *pErr = (kMoaErr_NoErr); } \
		INTF(macro_CLASS, macro_INTF)::~ INTF(macro_CLASS, macro_INTF)() { }

	#define BEGIN_DEFINE_CLASS_INTERFACE(macro_CLASS, macro_INTF) \
		PTRCHECK \
		STDMOAMETHODIMP INTF(macro_CLASS, macro_INTF)::QueryInterface(ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv) \
		{ \
			X_ENTER \
			MOA_CLOBBERTEST(this, #macro_CLASS "_" #macro_INTF "::QueryInterface") \
			X_STD_RETURN(this->pObj->QueryInterface(pInterfaceID, ppv)); \
			X_EXIT \
		} \
		 \
		STDMOAMETHODIMP_(MoaUlong) INTF(macro_CLASS, macro_INTF)::AddRef() \
		{ \
			X_ENTER \
			MOA_CLOBBERTEST(this, #macro_CLASS "_" #macro_INTF "::AddRef") \
			this->pObj->AddRef(); \
			X_RETURN(MoaUlong, InterlockedIncrement(&this->refCount)); \
			X_EXIT \
		} \
		 \
		STDMOAMETHODIMP_(MoaUlong) INTF(macro_CLASS, macro_INTF)::Release() \
		{ \
			X_ENTER \
			MBObject FAR * localPObj; \
			MoaUlong result; \
			 \
			MOA_CLOBBERTEST(this, #macro_CLASS "_" #macro_INTF "::Release") \
			result = InterlockedDecrement(&this->refCount); \
			MOA_ASSERT(result >= 0, "saveRef must be positive"); \
			localPObj = (MBObject FAR *)this->pObj; \
			\
			if (result == 0) { \
				delete this; \
				/* this call is necessary even in C++ because we overload delete \
					to do nothing. */ \
				DLL(_MBDelete)(this, localPObj->pCalloc); \
				InterlockedDecrement(&DLL(gXtraInterfaceCount)); \
				localPObj->Release(); \
			} \
		 	\
		 	localPObj->Release(); \
			X_RETURN(MoaUlong, result); \
			X_EXIT \
		} \
		 \
		EXTERN_STDMETHODIMP INTFBUILD_PARMS(macro_CLASS, macro_INTF); \
		STDMOAMETHODIMP INTFBUILD_PARMS(macro_CLASS, macro_INTF) \
		{ \
			X_ENTER_(pObj->magicCookie) \
			INTF(macro_CLASS, macro_INTF) FAR * pIF = NULL; \
			MoaError err = kMoaErr_NoErr; \
			 \
			MOA_CLOBBERTEST(pObj, #macro_CLASS "_" #macro_INTF "::New") \
			pIF = new(static_cast<PMoaVoid>(pObj)) INTF(macro_CLASS, macro_INTF)(&err); \
			if (pIF) { \
				if (err) { \
					pIF->Release(); \
					pIF = NULL; \
				} \
			} else { \
				err = kMoaErr_OutOfMem; \
			} \
		 	\
		 	*ppIF = pIF; \
			X_STD_RETURN(err); \
			X_EXIT \
		}

	#define DEFINE_METHOD(macro_METHODNAME, macro_IMPLNAME)

	#define END_DEFINE_CLASS_INTERFACE

#else

	#define STD_INTERFACE_CREATE_DESTROY(macro_CLASS, macro_INTF) \
		EXTERN_STDMETHODIMP MOA_CREATEI_PARMS(macro_CLASS, macro_INTF); \
		EXTERN_STDMETHODIMP_(void) MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF); \
		STDMOAMETHODIMP MOA_CREATEI_PARMS(macro_CLASS, macro_INTF) { _SICD_NOWARN return kMoaErr_NoErr; } \
		STDMOAMETHODIMP_(void) MOA_DESTROYI_PARMS(macro_CLASS, macro_INTF) { _SICD_NOWARN }

	#define BEGIN_DEFINE_CLASS_INTERFACE(macro_CLASS, macro_INTF) \
		\
		PTRCHECK \
		STDMOAMETHODIMP INTFQUERY_PARMS(macro_CLASS, macro_INTF) \
		{ \
			X_ENTER \
			MOA_CLOBBERTEST(This, #macro_CLASS "_" #macro_INTF "::QueryInterface") \
			X_STD_RETURN(This->pObj->lpVtbl->QueryInterface((PIMoaUnknown)This->pObj, pInterfaceID, ppv)); \
			X_EXIT \
		} \
		 \
		STDMOAMETHODIMP_(MoaUlong) INTFADDREF_PARMS(macro_CLASS, macro_INTF) \
		{ \
			X_ENTER \
			MOA_CLOBBERTEST(This, #macro_CLASS "_" #macro_INTF "::AddRef") \
			This->pObj->lpVtbl->AddRef((PIMoaUnknown)This->pObj); \
			X_RETURN(MoaUlong, InterlockedIncrement(&This->refCount)); \
			X_EXIT \
		} \
		 \
		STDMOAMETHODIMP_(MoaUlong) INTFRELEASE_PARMS(macro_CLASS, macro_INTF) \
		{ \
			X_ENTER \
			MBObject FAR * localPObj; \
			MoaUlong result; \
			 \
			MOA_CLOBBERTEST(This, #macro_CLASS "_" #macro_INTF "::Release") \
			result = InterlockedDecrement(&This->refCount); \
			MOA_ASSERT(result >= 0, "saveRef must be positive"); \
			localPObj = (MBObject FAR *)This->pObj; \
			\
			if (result == 0) { \
				MOA_DESTROYI(macro_CLASS, macro_INTF)(This); \
				localPObj->pCalloc->lpVtbl->NRFree(localPObj->pCalloc, This); \
				InterlockedDecrement(&DLL(gXtraInterfaceCount)); \
				localPObj->lpVtbl->Release((PIMoaUnknown)localPObj); \
			} \
		 	\
		 	localPObj->lpVtbl->Release((PIMoaUnknown)localPObj); \
			X_RETURN(MoaUlong, result); \
			X_EXIT \
		} \
		 \
		EXTERN_GET_VTABLE(macro_CLASS, macro_INTF) \
		EXTERN_STDMETHODIMP INTFBUILD_PARMS(macro_CLASS, macro_INTF); \
		STDMOAMETHODIMP INTFBUILD_PARMS(macro_CLASS, macro_INTF) \
		{ \
			X_ENTER_(pObj->magicCookie) \
			INTF(macro_CLASS, macro_INTF) FAR * pIF = NULL; \
			MoaError err = kMoaErr_NoErr; \
			 \
			MOA_CLOBBERTEST(pObj, #macro_CLASS "_" #macro_INTF "::New") \
			pIF = CALL_BGI(macro_CLASS, macro_INTF, pObj, &err); \
			\
			if (pIF) { \
				if (err) { \
					pIF->lpVtbl->Release((macro_INTF FAR *)pIF); \
					pIF = NULL; \
				} \
			} \
			else { \
				err = kMoaErr_OutOfMem; \
			} \
		 	\
		 	*ppIF = pIF; \
			X_STD_RETURN(err); \
			X_EXIT \
		} \
		BEGIN_VTABLE(macro_CLASS, macro_INTF) \
			FIRST_VTABLE_ENTRY(QueryInterface, INTFQUERY(macro_CLASS, macro_INTF)) \
			VTABLE_ENTRY(AddRef, INTFADDREF(macro_CLASS, macro_INTF)) \
			VTABLE_ENTRY(Release, INTFRELEASE(macro_CLASS, macro_INTF)) \

	#define DEFINE_METHOD(macro_METHODNAME, macro_IMPLNAME) \
			VTABLE_ENTRY(macro_METHODNAME, macro_IMPLNAME)

	#define END_DEFINE_CLASS_INTERFACE \
		END_VTABLE

#endif

#ifdef CPLUS

	#define STDINTERFACE_PREFACE \
		DECLARE_MBNEW

#else

	#define STDINTERFACE_PREFACE \
		\
		DECLARE_MBNEW \
		\
		MOAEXTERN_C PMoaVoid DLL(BuildGenInterface)(MBObject FAR * pObj, MoaLong interfaceSize, MoaCreatedProc createdProc, PMoaVoid vtbl, MoaError FAR * pErr); \
		MOAEXTERN_C PMoaVoid DLL(BuildGenInterface)(MBObject FAR * pObj, MoaLong interfaceSize, MoaCreatedProc createdProc, PMoaVoid vtbl, MoaError FAR * pErr) \
		{ \
			MBObject_IMoaUnknown FAR * pIF = NULL; \
			PIMoaCalloc pCalloc = pObj->pCalloc; \
			\
			pIF = (MBObject_IMoaUnknown FAR *)pCalloc->lpVtbl->NRAlloc(pCalloc, interfaceSize); \
			\
			if (pIF) { \
				pIF->lpVtbl = (IMoaUnknownVtbl FAR *)vtbl; \
				pIF->pObj = pObj; \
				pIF->refCount = 1; \
				pObj->lpVtbl->AddRef((PIMoaUnknown)pObj); \
				pObj->lpVtbl->AddRef((PIMoaUnknown)pObj); \
				InterlockedIncrement(&DLL(gXtraInterfaceCount)); \
				*pErr = (*createdProc)((PMoaVoid)pIF); \
				/* do NOT release in event of error. */ \
			} \
			else { \
				*pErr = kMoaErr_OutOfMem; \
			} \
			return pIF; \
		}

#endif

typedef STDPROCPTR(MOASTDMETHODCALLTYPE, MoaError, XtraBuildInterfaceProc)(
	PMoaVoid pObj,
	PPMoaVoid ppIF
);

typedef STDPROCPTR(MOASTDMETHODCALLTYPE, MoaError, XtraEnumClassFormProc)(
	ConstPMoaClassID pClassID,
	MoaLong classVersion,
	MoaLong objSize,
	MoaCreatedProc createProc,
	MoaDestroyedProc destroyProc,
	PMoaVoid refCon
);

typedef STDPROCPTR(MOASTDMETHODCALLTYPE, MoaError, XtraEnumClassInterfacesProc)(
	ConstPMoaClassID pClassID,
	MoaLong classVersion,
	ConstPMoaInterfaceID pInterfaceID,
	MoaLong interfaceVersion,
	XtraBuildInterfaceProc buildProc,
	PMoaVoid refCon
);

#define _GLUE_GETCLASSOBJECT \
	MOASTDAPI DLL(GetClassObject)(MOAREFCLSID rclsid, MOAREFIID riid, PPMoaVoid ppv); \
	STDAPIIMP DLL(GetClassObject)(MOAREFCLSID rclsid, MOAREFIID riid, PPMoaVoid ppv) { \
		rclsid; riid; ppv; /* avoid unused warnings in MPW C */ \
		return kMoaErr_BadClass; \
	} \

#define _GLUE_CANUNLOADNOW \
	MOASTDAPI DLL(CanUnloadNow)(void); \
	STDAPIIMP DLL(CanUnloadNow)(void) { \
		X_ENTER_DLLENTRYPOINT \
		X_STD_RETURN((DLL(gXtraInterfaceCount) == 0 ? 0 : kMoaErr_XtraInUse)); \
		X_EXIT \
	} \

#define _GLUE_GETCLASSFORM \
	typedef struct { \
		MoaLong FAR * pObjSize; \
		MoaCreatedProc FAR * pCreateProc; \
		MoaDestroyedProc FAR * pDestroyProc; \
		MoaBool found; \
	} _XtraGetClassFormRec; \
	STDMOAMETHODIMP DLL(_XtraGetClassForm)(ConstPMoaClassID pClassID, MoaLong classVersion, MoaLong objSize, MoaCreatedProc createProc, MoaDestroyedProc destroyProc, _XtraGetClassFormRec FAR * pInfo); \
	STDMOAMETHODIMP DLL(_XtraGetClassForm)(ConstPMoaClassID pClassID, MoaLong classVersion, MoaLong objSize, MoaCreatedProc createProc, MoaDestroyedProc destroyProc, _XtraGetClassFormRec FAR * pInfo) \
	{ \
		pClassID; classVersion; \
		*pInfo->pObjSize = objSize; \
		*pInfo->pCreateProc = createProc; \
		*pInfo->pDestroyProc = destroyProc; \
		pInfo->found = TRUE; \
		return (MoaError)1; \
	} \
	MOASTDAPI DLL(GetClassForm)(ConstPMoaClassID pClassID, MoaLong FAR * pObjSize, MoaCreatedProc FAR * pCreateProc, MoaDestroyedProc FAR * pDestroyProc); \
	STDAPIIMP DLL(GetClassForm)(ConstPMoaClassID pClassID, MoaLong FAR * pObjSize, MoaCreatedProc FAR * pCreateProc, MoaDestroyedProc FAR * pDestroyProc) { \
		_XtraGetClassFormRec info; \
		X_ENTER_DLLENTRYPOINT \
		info.pObjSize = pObjSize; \
		info.pCreateProc = pCreateProc; \
		info.pDestroyProc = pDestroyProc; \
		info.found = FALSE; \
		DLL(SecretGlue)(pClassID, (XtraEnumClassFormProc)DLL(_XtraGetClassForm), NULL, &info); \
		X_STD_RETURN(info.found ? kMoaErr_NoErr : kMoaErr_BadClass); \
		X_EXIT \
	} \

#define _GLUE_GETINTERFACE \
	typedef struct { \
		ConstPMoaInterfaceID pInterfaceID; \
		XtraBuildInterfaceProc buildProc; \
	} _XtraGetClassInterfaceRec; \
	STDMOAMETHODIMP DLL(_XtraGetClassInterface)(ConstPMoaClassID pClassID, MoaLong classVersion, ConstPMoaInterfaceID pInterfaceID, MoaLong interfaceVersion, XtraBuildInterfaceProc buildProc, _XtraGetClassInterfaceRec FAR * pInfo); \
	STDMOAMETHODIMP DLL(_XtraGetClassInterface)(ConstPMoaClassID pClassID, MoaLong classVersion, ConstPMoaInterfaceID pInterfaceID, MoaLong interfaceVersion, XtraBuildInterfaceProc buildProc, _XtraGetClassInterfaceRec FAR * pInfo) \
	{ \
		pClassID; classVersion; interfaceVersion; \
		if (MoaEqualID(pInterfaceID, pInfo->pInterfaceID)) { \
			pInfo->buildProc = buildProc; \
			return (MoaError)1; \
		} \
		return (MoaError)0; \
	} \
	\
	MOASTDAPI DLL(GetInterface)(PMoaVoid pObj, ConstPMoaClassID pClassID, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv); \
	STDAPIIMP DLL(GetInterface)(PMoaVoid pObj, ConstPMoaClassID pClassID, ConstPMoaInterfaceID pInterfaceID, PPMoaVoid ppv) { \
		_XtraGetClassInterfaceRec info; \
		X_ENTER_DLLENTRYPOINT \
		info.pInterfaceID = pInterfaceID; \
		info.buildProc = NULL; \
		DLL(SecretGlue)(pClassID, NULL, (XtraEnumClassInterfacesProc)DLL(_XtraGetClassInterface), &info); \
		X_STD_RETURN(info.buildProc ? (*info.buildProc)(pObj, ppv) : kMoaErr_BadInterface); \
		X_EXIT \
	} \

#define _GLUE_GETCLASSINFO \
	typedef struct { \
		MoaLong count; \
		PMoaClassInterfaceInfo pCur; \
	} _XtraGetClassInfoRec; \
	STDMOAMETHODIMP DLL(_XtraGcfInfo)(ConstPMoaClassID pClassID, MoaLong classVersion, MoaLong objSize, MoaCreatedProc createProc, MoaDestroyedProc destroyProc, _XtraGetClassInfoRec FAR * pInfo); \
	STDMOAMETHODIMP DLL(_XtraGcfInfo)(ConstPMoaClassID pClassID, MoaLong classVersion, MoaLong objSize, MoaCreatedProc createProc, MoaDestroyedProc destroyProc, _XtraGetClassInfoRec FAR * pInfo) \
	{ \
		objSize; createProc; destroyProc; \
		++pInfo->count; \
		if (pInfo->pCur) { \
			pInfo->pCur->classID = *pClassID; \
			pInfo->pCur->classVersion = classVersion; \
			pInfo->pCur->interfaceID = IID_IMoaClassFactory; \
			pInfo->pCur->interfaceVersion = 1; \
			++pInfo->pCur; \
		} \
		return 0; \
	} \
	STDMOAMETHODIMP DLL(_XtraGciInfo)(ConstPMoaClassID pClassID, MoaLong classVersion, ConstPMoaInterfaceID pInterfaceID, MoaLong interfaceVersion, XtraBuildInterfaceProc buildProc, _XtraGetClassInfoRec FAR * pInfo); \
	STDMOAMETHODIMP DLL(_XtraGciInfo)(ConstPMoaClassID pClassID, MoaLong classVersion, ConstPMoaInterfaceID pInterfaceID, MoaLong interfaceVersion, XtraBuildInterfaceProc buildProc, _XtraGetClassInfoRec FAR * pInfo) \
	{ \
		buildProc; \
		++pInfo->count; \
		if (pInfo->pCur) { \
			pInfo->pCur->classID = *pClassID; \
			pInfo->pCur->classVersion = classVersion; \
			pInfo->pCur->interfaceID = *pInterfaceID; \
			pInfo->pCur->interfaceVersion = interfaceVersion; \
			++pInfo->pCur; \
		} \
		return 0; \
	} \
	MOASTDAPI DLL(GetClassInfo)(PIMoaCalloc pCalloc, ConstPMoaClassInterfaceInfo FAR * ppClassInfo); \
	STDAPIIMP DLL(GetClassInfo)(PIMoaCalloc pCalloc, ConstPMoaClassInterfaceInfo FAR * ppClassInfo) { \
		_XtraGetClassInfoRec info; \
		X_ENTER_DLLENTRYPOINT \
		info.count = 0; \
		info.pCur = NULL; \
		DLL(SecretGlue)(NULL, (XtraEnumClassFormProc)DLL(_XtraGcfInfo), (XtraEnumClassInterfacesProc)DLL(_XtraGciInfo), &info); \
		*ppClassInfo = (ConstPMoaClassInterfaceInfo)CALL_CALLOC(pCalloc, (info.count + 1) * sizeof(MoaClassInterfaceInfo)); \
		if (!*ppClassInfo) X_STD_RETURN(kMoaErr_OutOfMem); \
		info.pCur = (PMoaClassInterfaceInfo)*ppClassInfo; \
		DLL(SecretGlue)(NULL, (XtraEnumClassFormProc)DLL(_XtraGcfInfo), (XtraEnumClassInterfacesProc)DLL(_XtraGciInfo), &info); \
		info.pCur->classID = IID_NULL; \
		info.pCur->interfaceID = IID_NULL; \
		X_STD_RETURN(kMoaErr_NoErr); \
		X_EXIT \
	}

#define BEGIN_XTRA \
	PTRCHECK \
	XTRA_PREFACE \
	STDINTERFACE_PREFACE \
	static MoaError DLL(SecretGlue)( \
		ConstPMoaClassID pClassID, \
		XtraEnumClassFormProc ecfProc, \
		XtraEnumClassInterfacesProc eciProc, \
		PMoaVoid refCon); \
	static MoaError DLL(SecretGlue)( \
		ConstPMoaClassID pClassID, \
		XtraEnumClassFormProc ecfProc, \
		XtraEnumClassInterfacesProc eciProc, \
		PMoaVoid refCon) { \
		\
		MoaError err = 0; \
		X_ENTER_DLLENTRYPOINT \
		pClassID; ecfProc; eciProc; \
		do { \

#define BEGIN_XTRA_AUGMENTS_CLASS(macro_CLASS, macro_CLASSVERSION) \
		if (!pClassID || MoaEqualID(pClassID, &CLSID(macro_CLASS)) || &(CLSID(macro_CLASS)) == &CLSID_AnyClass) { \
		ConstPMoaClassID pCurClassID = &CLSID(macro_CLASS); \
		MoaLong curClassVersion = macro_CLASSVERSION; \
		\
		if (eciProc) {

#define BEGIN_XTRA_DEFINES_CLASS(macro_CLASS, macro_CLASSVERSION) \
		if (!pClassID || MoaEqualID(pClassID, &CLSID(macro_CLASS)) || &(CLSID(macro_CLASS)) == &CLSID_AnyClass) { \
		ConstPMoaClassID pCurClassID = &CLSID(macro_CLASS); \
		MoaLong curClassVersion = macro_CLASSVERSION; \
		\
		err = ecfProc ? (*ecfProc)(pCurClassID, curClassVersion, sizeof(macro_CLASS), (MoaCreatedProc)(MOA_CREATE(macro_CLASS)), (MoaDestroyedProc)(MOA_DESTROY(macro_CLASS)), refCon) : 0; \
		if (err) break; \
		if (eciProc) {

#ifdef MOA_DEBUG
	#define _BX_DBG_CHK(c1, c2) MOA_ASSERT(c1 == c2, "Class Mismatch in macro");
#else
	#define _BX_DBG_CHK(c1, c2) ;
#endif

#define CLASS_DEFINES_INTERFACE(macro_CLASS, macro_INTF, macro_INTERFACEVERSION) \
			_BX_DBG_CHK(&CLSID(macro_CLASS), pCurClassID) \
			{ \
			/* this can cause problems when mixing C and C++ */ \
			/*STDMOAMETHODIMP INTFBUILD(macro_CLASS, macro_INTF)(macro_CLASS FAR * pObj, struct INTF(macro_CLASS, macro_INTF) FAR * FAR * ppIF);*/ \
			err = (*eciProc)(pCurClassID, curClassVersion, &IID(macro_INTF), macro_INTERFACEVERSION, (XtraBuildInterfaceProc)(INTFBUILD(macro_CLASS, macro_INTF)), refCon); \
			if (err) break; \
			}

#define END_XTRA_DEFINES_CLASS \
		} }

#define END_XTRA \
		} while (0); \
		X_EXIT \
		return err; \
	} \
	\
	MoaLong DLL(gXtraInterfaceCount) = 0; \
	\
	_GLUE_GETCLASSOBJECT \
	_GLUE_CANUNLOADNOW \
	_GLUE_GETCLASSFORM \
	_GLUE_GETINTERFACE \
	_GLUE_GETCLASSINFO

#undef INTERFACE /* leave it undefined */

#endif /* _H_moaxtra */
