/*
	file: mutbase.h (core)

	Copyright (c) 1996 Macromedia, Inc. All rights reserved.
*/

#pragma once

#ifndef _H_mutbase
#define _H_mutbase

#ifndef _H_moaxtra
	#include "moaxtra.h"
#endif

#if !defined(MOA_APP_CODE)

	/* compiling inside an FHX */

	#ifndef FALSE
		#define FALSE 0
	#endif
	#ifndef TRUE
		#define TRUE 1
	#endif
	
	#define NOID 0
	
	#ifndef _H_base
		typedef MoaUlong oid;				/* Object ID */
	#endif /* _H_base */
	
#ifdef powerc
#pragma options align=mac68k
#endif

		typedef struct {			/* point */
			MoaFixed x;				/* x coordinate */
			MoaFixed y;				/* y coordinate */
		} FhFxPoint;

		typedef FhFxPoint * PFhFxPoint;

#ifdef powerc
#pragma options align=reset
#endif

#ifdef powerc
#pragma options align=mac68k
#endif

	typedef struct {
		FhFxPoint	lo;
		FhFxPoint	hi;
	} FhRect;

	typedef FhRect * PFhRect;

	typedef FhRect MRect;

	// don't define PMRect - the definition conflicts with a typedef
	// in one of the Metrowerks-provided headers 
	// typedef PFhRect PMRect;

#ifdef powerc
#pragma options align=reset
#endif

#ifdef powerc
#pragma options align=mac68k
#endif

	struct _DataTypeID;
	typedef struct _DataTypeID *DataTypeID;
	
#ifdef powerc
#pragma options align=reset
#endif

	#ifdef MACINTOSH
		#include <stdio.h>
		#include <stdlib.h>
		#include <Memory.h>
		#include <pool_alloc.h>
		#define malloc(x)			((void *)NewPtr((Size )(x)))
		#define free(x)				(DisposePtr((Ptr )(x)))
		#define calloc(x,y)			((void *)NewPtrClear((Size )(x)*(Size )(y)))
		#define realloc(x,y)		???
		#define printf				???
		#define __pool_free_all(x)	{ /* We don't need to deallocate the pools if we never allocated them */ }
	#endif

	#ifdef MPW
		#define VOLATILEPTR(t)				volatile t *
	#else
		#define VOLATILEPTR(t)				t * volatile
	#endif

	#ifndef NULL
		#define NULL 0
	#endif

#else

	/* 
		compiling inside FreeHand. External developers should ignore this.
	*/

	#include "base.h"
	#include "mtypes.h"
	#include "fhfixmath.h"
	#include "dtmgr.h"

#endif // !defined(MOA_APP_CODE)

typedef PFhFxPoint PMPoint;
typedef const PFhFxPoint ConstPMPoint;

typedef MoaFixed FhFixed;

#endif // _H_mutbase
