/*
	File: uibase.h	    (adaptive)

	Copyright (c) 1994 Altsys. All rights reserved.
*/

#ifndef _H_uibase
#define _H_uibase

#ifndef _H_uidefs
	#include "uidefs.h"
#endif

#ifndef _H_moaxtra
	#include "moaxtra.h"
#endif

/* --------------------------- Utility Definitions ---------------------------- */

#ifndef ABS
	#define ABS(x)      	((x)<0?-(x):(x))
#endif /* ABS */

#ifndef MIN
	#define MIN(a,b) 		((a)<=(b)?(a):(b))
#endif /* MIN */

#ifndef MAX
	#define MAX(a,b) 		((a)>=(b)?(a):(b))
#endif /* MAX */

/* ---------------------------------------------------------------------------- */
/* -------- This portion of the file contains UI specific data types ---------- */
/* ---------------------------------------------------------------------------- */

#ifdef MACINTOSH
	#ifndef __TYPES__
	#include <Types.h>
	#endif

	typedef struct {
		MoaShort	y;		/* Horizontal coordinate */
		MoaShort 	x;		/* Vertical coordinate */
	} UIPoint;

	typedef Rect UIRect;
#endif

#ifdef WINDOWS
	typedef struct {
		MoaLong		y;		/* Horizontal coordinate */
		MoaLong 	x;		/* Vertical coordinate */
	} UIPoint;

	typedef RECT UIRect;
#endif

typedef struct {
	UIPoint		dropLocation;	/* where mouse was when dropped */
	MoaLong		dataType;		/* type of data stored */
	PMoaVoid	data;		/* pointer to data stored */
	MoaLong		dataLen;		/* length of data stored */
} UIDrop;

#ifdef WINDOWS

	#include <windows.h>

	typedef	HWND		GadgetID;
	typedef	MoaLong		UIMsg;
	typedef MoaLong		UIKey;
	typedef MoaLong		TagID;
	typedef MoaLong		GadgetType;
	typedef	MoaShort	UICoord;		/* must be the size of a UIPoint/UIRect entry */

#endif /* ifdef WINDOWS */

#ifdef MACINTOSH
	#include <Types.h>

	/* Note: on the Mac, we'd like all these types
		to be long-sized to simplify parameter-passing
		conventions between Think and MPW. */
	typedef MoaUlong	GadgetID;
	typedef MoaLong 	UIMsg;
	typedef MoaLong		UIKey;
	typedef MoaLong		TagID;
	typedef MoaLong		GadgetType;
	typedef MoaShort	UICoord;		/* must be the size of a UIPoint/UIRect entry */
#endif /* ifdef MACINTOSH */

/* -------------- */
#undef INTERFACE
#define INTERFACE IMoaUiProc

DECLARE_MOA_INTERFACE_(IMoaUiProc, IMoaUnknown)
{
	STD_IMOAUNKNOWN_METHODS

	STDMOAMETHOD_(UIMsg, UiProcInit) (THIS_ PMoaVoid pData) PURE;
	STDMOAMETHOD_(UIMsg, UiProcGo) (THIS_ GadgetID theGadget, UIMsg msg, MoaUlong arg1, MoaUlong arg2) PURE;
};
typedef IMoaUiProc FAR * PIMoaUiProc;

// IID_IMoaUiProc: AB9F0ADC17DC6B7F2ED7080007160DC3
MOA_DEFINE_GUID(IID_IMoaUiProc, 0xAB9F0ADCL, 0x17DC, 0x6B7F, 0x2E, 0xD7, 0x08, 0x00, 0x07, 0x16, 0x0D, 0xC3);

/* -------------- */

#define PT2LONG(uipoint) 		(((uipoint).x << 16) | ((uipoint).y & 0xffff))
#define LONG2PT(longval, pt) 	(pt).x = (longval) >> 16; (pt).y = (MoaShort)((longval) & 0xffff);

#endif
