/*
	File: uitypes.r

	Copyright (c) 1994 Altsys. All rights reserved.
*/

#include "uidefs.h"

type 'Gadg'
{
	integer = $$CountOf(GadgetList);
	wide array GadgetList {
		integer;		/* gadget type */
		longint;		/* gadget tag */
		cstring;		/* gadget class (empty string if not a custom class) */
		rect;			/* gadget bounds */
		integer = $$CountOf(GadgetData);
		wide array GadgetData {
			integer;	/* the key */
			/* note: intentionally no "aligns" here; do
				only byte alignment to conserve space */
			switch {
				case ui_bool:
					key byte = UIDATATYPE_BOOL;
					byte;
				case ui_long:
					key byte = UIDATATYPE_LONG;
					longint;
				case ui_fixed:
					key byte = UIDATATYPE_FIXED;
					longint;
				case ui_point:
					key byte = UIDATATYPE_POINT;
					point;
				case ui_rect:
					key byte = UIDATATYPE_RECT;
					rect;
				case ui_string:
					key byte = UIDATATYPE_STRING;
					cstring;
			};
		};
	};
};

#if 0

/* TMPL resource for editing Gadg resources. Note that
	this will only work with Resorceror (ResEdit can't handle it). */
resource 'TMPL' (10000, "Gadg", purgeable) {
	{	/* array: 67 elements */
		/* [1] */
		"Gadget List",
		'OCNT',
		/* [2] */
		"*****",
		'LSTC',
		/* [3] */
		"Gadget Type",
		'DWRD',
		/* [4] */
		"Gadget Tag",
		'DLNG',
		/* [5] */
		"Gadget Class (Do Not Localize)",
		'CSTR',
		/* [6] */
		"Gadget Top",
		'DWRD',
		/* [7] */
		"Gadget Left",
		'DWRD',
		/* [8] */
		"Gadget Bottom",
		'DWRD',
		/* [9] */
		"Gadget Right",
		'DWRD',
		/* [10] */
		"Gadget Data List",
		'OCNT',
		/* [11] */
		"*****",
		'LSTC',
		/* [12] */
		"Data Key",
		'DWRD',
		/* [13] */
		"Value=0",
		'CASE',
		/* [14] */
		"Bounds=1",
		'CASE',
		/* [15] */
		"Position=2",
		'CASE',
		/* [16] */
		"Title (Localize)=3",
		'CASE',
		/* [17] */
		"Icon Resource Name (Do Not Localize)=4",
		'CASE',
		/* [18] */
		"Min Value=5",
		'CASE',
		/* [19] */
		"Max Value=6",
		'CASE',
		/* [20] */
		"Selection=7",
		'CASE',
		/* [21] */
		"NewSelection=8",
		'CASE',
		/* [22] */
		"Count=9",
		'CASE',
		/* [23] */
		"Is Default Button?=14",
		'CASE',
		/* [24] */
		"Is Cancel Button?=15",
		'CASE',
		/* [25] */
		"Is Growable?=16",
		'CASE',
		/* [26] */
		"Has H ScrollBar?=18",
		'CASE',
		/* [27] */
		"Use Tiny Font?=17",
		'CASE',
		/* [28] */
		"Page Delta=20",
		'CASE',
		/* [29] */
		"Scroll Bounds=21",
		'CASE',
		/* [30] */
		"Scroll To=22",
		'CASE',
		/* [31] */
		"ScrollGroupContent=23",
		'CASE',
		/* [32] */
		"Visible=25",
		'CASE',
		/* [33] */
		"Enabled=26",
		'CASE',
		/* [34] */
		"Arrow Delta=27",
		'CASE',
		/* [35] */
		"Has VScrollBar?=28",
		'CASE',
		/* [36] */
		"Text Centered?=32",
		'CASE',
		/* [37] */
		"Text Right?=33",
		'CASE',
		/* [38] */
		"Text Left?=34",
		'CASE',
		/* [39] */
		"Data Type",
		'KBYT',
		/* [40] */
		"bool=0",
		'CASE',
		/* [41] */
		"long=1",
		'CASE',
		/* [42] */
		"fixed=2",
		'CASE',
		/* [43] */
		"point=3",
		'CASE',
		/* [44] */
		"rect=4",
		'CASE',
		/* [45] */
		"cstring=5",
		'CASE',
		/* [46] */
		"0",
		'KEYB',
		/* [47] */
		"bool",
		'DBYT',
		/* [48] */
		"True=1",
		'CASE',
		/* [49] */
		"False=0",
		'CASE',
		/* [50] */
		"",
		'KEYE',
		/* [51] */
		"1",
		'KEYB',
		/* [52] */
		"long",
		'DLNG',
		/* [53] */
		"",
		'KEYE',
		/* [54] */
		"2",
		'KEYB',
		/* [55] */
		"fixed",
		'FIXD',
		/* [56] */
		"",
		'KEYE',
		/* [57] */
		"3",
		'KEYB',
		/* [58] */
		"point",
		'PNT ',
		/* [59] */
		"",
		'KEYE',
		/* [60] */
		"4",
		'KEYB',
		/* [61] */
		"rect",
		'RECT',
		/* [62] */
		"",
		'KEYE',
		/* [63] */
		"5",
		'KEYB',
		/* [64] */
		"cstring",
		'CSTR',
		/* [65] */
		"",
		'KEYE',
		/* [66] */
		"*****",
		'LSTE',
		/* [67] */
		"*****",
		'LSTE'
	}
};


#endif
